import { AfterContentChecked, AfterViewInit, ElementRef, isDevMode, OnInit, QueryList } from '@angular/core';
import { WebGLRenderer } from 'three';
import { RaycasterService } from './events/raycaster.service';
import { ThAnimationLoopService } from './renderer/th-animation-loop.service';
import { ThEngineService } from './ThEngine.service';
import { ThView } from './ThView';
import * as i0 from "@angular/core";
export declare class ThCanvas extends ThView implements OnInit, AfterViewInit, AfterContentChecked {
    protected engServ: ThEngineService;
    protected animationLoop: ThAnimationLoopService;
    protected raycaster: RaycasterService;
    readonly isDevMode: typeof isDevMode;
    private static instanceCnt;
    readonly nid: number;
    /**
     * renderer parameters
     * those will be applied to the renderer during construction / initialization
     */
    rendererParameters?: Partial<WebGLRenderer>;
    /**
     * if true does not use the ThCanvas as view
     * this is esepcially usefull if you have multiple views
     * and want to iterate over all of them with *ngFor
     * use statically (before ngOnInit is triggered)
     */
    disableDefaultView: boolean;
    get obj(): this;
    set views(viewList: QueryList<ThView>);
    protected _rendererCanvas?: ElementRef<HTMLCanvasElement>;
    set rendererCanvas(canvas: ElementRef<HTMLCanvasElement> | undefined);
    get rendererCanvas(): ElementRef<HTMLCanvasElement> | undefined;
    constructor(engServ: ThEngineService, animationLoop: ThAnimationLoopService, raycaster: RaycasterService);
    ngAfterContentChecked(): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    private applyRendererParameters;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThCanvas, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThCanvas, "th-canvas", never, { "rendererParameters": "rendererParameters"; "disableDefaultView": "disableDefaultView"; }, {}, ["views"], ["*"], false, never>;
}
