import { NgZone, OnDestroy } from '@angular/core';
import * as THREE from 'three';
import { WebGLRenderer } from 'three';
import { ThView } from './ThView';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export interface RenderState {
    engine: ThEngineService;
    delta: number;
}
export interface ThRendererParameters extends Partial<WebGLRenderer> {
    domElement: HTMLCanvasElement;
}
export declare class ThEngineService implements OnDestroy {
    private ngZone;
    readonly beforeRender$: Observable<RenderState>;
    readonly resize$: Observable<{
        width: number;
        height: number;
    }>;
    private _renderer?;
    private rendererParameters?;
    private clock;
    private destroyed$;
    private readonly resizeEmitter;
    private readonly beforeRenderEmitter;
    private views;
    get canvas(): HTMLCanvasElement | undefined;
    private resizeObserver?;
    constructor(ngZone: NgZone);
    get renderer(): THREE.WebGLRenderer | undefined;
    ngOnDestroy(): void;
    private initResizeObserver;
    private initRenderer;
    setRenderer(options: ThRendererParameters): void;
    addView(view: ThView): void;
    render(): void;
    protected renderView(view: ThView): void;
    protected applyRendererParametersFromView(view: ThView): void;
    resize(): boolean;
    protected calcRendererSize(): {
        width: number;
        height: number;
    } | undefined;
    protected adjustViewDimensions(view: ThView, width: number, height: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThEngineService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ThEngineService>;
}
