import { Type } from '@angular/core';
import { Camera, Color, ColorRepresentation, MeshDepthMaterial, Scene, ShaderMaterial, WebGLRenderTarget } from 'three';
import { BokehPass, BokehPassParamters } from 'three/examples/jsm/postprocessing/BokehPass';
import { FullScreenQuad } from 'three/examples/jsm/postprocessing/Pass';
import { ThPass } from './ThPass';
import * as i0 from "@angular/core";
export declare class ThBokehPass<T extends BokehPass = BokehPass, TARGS = [scene: Scene, camera: Camera, params: BokehPassParamters]> extends ThPass<T, TARGS> {
    getType(): Type<BokehPass>;
    set scene(value: Scene);
    get scene(): Scene | undefined;
    set camera(value: Camera);
    get camera(): Camera | undefined;
    set renderTargetColor(value: WebGLRenderTarget);
    get renderTargetColor(): WebGLRenderTarget | undefined;
    set renderTargetDepth(value: WebGLRenderTarget);
    get renderTargetDepth(): WebGLRenderTarget | undefined;
    set materialDepth(value: MeshDepthMaterial);
    get materialDepth(): MeshDepthMaterial | undefined;
    set materialBokeh(value: ShaderMaterial);
    get materialBokeh(): ShaderMaterial | undefined;
    set uniforms(map: {
        [name: string]: {
            value: any;
        };
    });
    get uniforms(): {
        [name: string]: {
            value: any;
        };
    } | undefined;
    set fsQuad(value: FullScreenQuad);
    get fsQuad(): FullScreenQuad | undefined;
    set oldClearColor(value: Color | [color: ColorRepresentation]);
    get oldClearColor(): Color | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThBokehPass<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThBokehPass<any, any>, "th-bokehPass", never, { "scene": "scene"; "camera": "camera"; "renderTargetColor": "renderTargetColor"; "renderTargetDepth": "renderTargetDepth"; "materialDepth": "materialDepth"; "materialBokeh": "materialBokeh"; "uniforms": "uniforms"; "fsQuad": "fsQuad"; "oldClearColor": "oldClearColor"; }, {}, never, ["*"], false, never>;
}
