import { Type } from '@angular/core';
import { CubeTexture, CubeTextureMapping, MagnificationTextureFilter, MinificationTextureFilter, PixelFormat, TextureDataType, TextureEncoding, Wrapping } from 'three';
import { ThTexture } from './ThTexture';
import * as i0 from "@angular/core";
export declare class ThCubeTexture<T extends CubeTexture = CubeTexture, TARGS = [
    images?: any[],
    mapping?: CubeTextureMapping,
    wrapS?: Wrapping,
    wrapT?: Wrapping,
    magFilter?: MagnificationTextureFilter,
    minFilter?: MinificationTextureFilter,
    format?: PixelFormat,
    type?: TextureDataType,
    anisotropy?: number,
    encoding?: TextureEncoding
]> extends ThTexture<T, TARGS> {
    getType(): Type<CubeTexture>;
    get isCubeTexture(): true | undefined;
    set mapping(value: CubeTextureMapping);
    get mapping(): CubeTextureMapping | undefined;
    set flipY(value: boolean);
    get flipY(): boolean | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThCubeTexture<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThCubeTexture<any, any>, "th-cubeTexture", never, { "mapping": "mapping"; "flipY": "flipY"; }, {}, never, ["*"], false, never>;
}
