import { Type } from '@angular/core';
import { Color, ColorRepresentation, MeshPhysicalMaterial, MeshPhysicalMaterialParameters, Texture, Vector2 } from 'three';
import { ThMeshStandardMaterial } from './ThMeshStandardMaterial';
import * as i0 from "@angular/core";
export declare class ThMeshPhysicalMaterial<T extends MeshPhysicalMaterial = MeshPhysicalMaterial, TARGS = MeshPhysicalMaterialParameters> extends ThMeshStandardMaterial<T, TARGS> {
    getType(): Type<MeshPhysicalMaterial>;
    set type(value: string);
    get type(): string | undefined;
    set defines(value: {
        [key: string]: any;
    });
    get defines(): {
        [key: string]: any;
    } | undefined;
    set clearcoat(value: number);
    get clearcoat(): number | undefined;
    set clearcoatMap(value: Texture | null);
    get clearcoatMap(): (Texture | null) | undefined;
    set clearcoatRoughness(value: number);
    get clearcoatRoughness(): number | undefined;
    set clearcoatRoughnessMap(value: Texture | null);
    get clearcoatRoughnessMap(): (Texture | null) | undefined;
    set clearcoatNormalScale(value: Vector2 | [x: number, y: number]);
    get clearcoatNormalScale(): Vector2 | undefined;
    set clearcoatNormalMap(value: Texture | null);
    get clearcoatNormalMap(): (Texture | null) | undefined;
    set reflectivity(value: number);
    get reflectivity(): number | undefined;
    set ior(value: number);
    get ior(): number | undefined;
    set sheen(value: number);
    get sheen(): number | undefined;
    set sheenColor(value: Color | [color: ColorRepresentation]);
    get sheenColor(): Color | undefined;
    set sheenColorMap(value: Texture | null);
    get sheenColorMap(): (Texture | null) | undefined;
    set sheenRoughness(value: number);
    get sheenRoughness(): number | undefined;
    set sheenRoughnessMap(value: Texture | null);
    get sheenRoughnessMap(): (Texture | null) | undefined;
    set transmission(value: number);
    get transmission(): number | undefined;
    set transmissionMap(value: Texture | null);
    get transmissionMap(): (Texture | null) | undefined;
    set thickness(value: number);
    get thickness(): number | undefined;
    set thicknessMap(value: Texture | null);
    get thicknessMap(): (Texture | null) | undefined;
    set attenuationDistance(value: number);
    get attenuationDistance(): number | undefined;
    set attenuationColor(value: Color | [color: ColorRepresentation]);
    get attenuationColor(): Color | undefined;
    set specularIntensity(value: number);
    get specularIntensity(): number | undefined;
    set specularColor(value: Color | [color: ColorRepresentation]);
    get specularColor(): Color | undefined;
    set specularIntensityMap(value: Texture | null);
    get specularIntensityMap(): (Texture | null) | undefined;
    set specularColorMap(value: Texture | null);
    get specularColorMap(): (Texture | null) | undefined;
    set iridescenceMap(value: Texture | null);
    get iridescenceMap(): (Texture | null) | undefined;
    set iridescenceIOR(value: number);
    get iridescenceIOR(): number | undefined;
    set iridescence(value: number);
    get iridescence(): number | undefined;
    set iridescenceThicknessRange(value: [number, number]);
    get iridescenceThicknessRange(): [number, number] | undefined;
    set iridescenceThicknessMap(value: Texture | null);
    get iridescenceThicknessMap(): (Texture | null) | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThMeshPhysicalMaterial<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThMeshPhysicalMaterial<any, any>, "th-meshPhysicalMaterial", never, { "type": "type"; "defines": "defines"; "clearcoat": "clearcoat"; "clearcoatMap": "clearcoatMap"; "clearcoatRoughness": "clearcoatRoughness"; "clearcoatRoughnessMap": "clearcoatRoughnessMap"; "clearcoatNormalScale": "clearcoatNormalScale"; "clearcoatNormalMap": "clearcoatNormalMap"; "reflectivity": "reflectivity"; "ior": "ior"; "sheen": "sheen"; "sheenColor": "sheenColor"; "sheenColorMap": "sheenColorMap"; "sheenRoughness": "sheenRoughness"; "sheenRoughnessMap": "sheenRoughnessMap"; "transmission": "transmission"; "transmissionMap": "transmissionMap"; "thickness": "thickness"; "thicknessMap": "thicknessMap"; "attenuationDistance": "attenuationDistance"; "attenuationColor": "attenuationColor"; "specularIntensity": "specularIntensity"; "specularColor": "specularColor"; "specularIntensityMap": "specularIntensityMap"; "specularColorMap": "specularColorMap"; "iridescenceMap": "iridescenceMap"; "iridescenceIOR": "iridescenceIOR"; "iridescence": "iridescence"; "iridescenceThicknessRange": "iridescenceThicknessRange"; "iridescenceThicknessMap": "iridescenceThicknessMap"; }, {}, never, ["*"], false, never>;
}
