import { Type } from '@angular/core';
import { Color, ColorRepresentation, MeshToonMaterial, MeshToonMaterialParameters, NormalMapTypes, Texture, Vector2 } from 'three';
import { ThMaterial } from './ThMaterial';
import * as i0 from "@angular/core";
export declare class ThMeshToonMaterial<T extends MeshToonMaterial = MeshToonMaterial, TARGS = MeshToonMaterialParameters> extends ThMaterial<T, TARGS> {
    getType(): Type<MeshToonMaterial>;
    set type(value: string);
    get type(): string | undefined;
    set defines(value: {
        [key: string]: any;
    });
    get defines(): {
        [key: string]: any;
    } | undefined;
    set color(value: Color | [color: ColorRepresentation]);
    get color(): Color | undefined;
    set gradientMap(value: Texture | null);
    get gradientMap(): (Texture | null) | undefined;
    set map(value: Texture | null);
    get map(): (Texture | null) | undefined;
    set lightMap(value: Texture | null);
    get lightMap(): (Texture | null) | undefined;
    set lightMapIntensity(value: number);
    get lightMapIntensity(): number | undefined;
    set aoMap(value: Texture | null);
    get aoMap(): (Texture | null) | undefined;
    set aoMapIntensity(value: number);
    get aoMapIntensity(): number | undefined;
    set emissive(value: Color | [color: ColorRepresentation]);
    get emissive(): Color | undefined;
    set emissiveIntensity(value: number);
    get emissiveIntensity(): number | undefined;
    set emissiveMap(value: Texture | null);
    get emissiveMap(): (Texture | null) | undefined;
    set bumpMap(value: Texture | null);
    get bumpMap(): (Texture | null) | undefined;
    set bumpScale(value: number);
    get bumpScale(): number | undefined;
    set normalMap(value: Texture | null);
    get normalMap(): (Texture | null) | undefined;
    set normalMapType(value: NormalMapTypes);
    get normalMapType(): NormalMapTypes | undefined;
    set normalScale(value: Vector2 | [x: number, y: number]);
    get normalScale(): Vector2 | undefined;
    set displacementMap(value: Texture | null);
    get displacementMap(): (Texture | null) | undefined;
    set displacementScale(value: number);
    get displacementScale(): number | undefined;
    set displacementBias(value: number);
    get displacementBias(): number | undefined;
    set alphaMap(value: Texture | null);
    get alphaMap(): (Texture | null) | undefined;
    set wireframe(value: boolean);
    get wireframe(): boolean | undefined;
    set wireframeLinewidth(value: number);
    get wireframeLinewidth(): number | undefined;
    set wireframeLinecap(value: string);
    get wireframeLinecap(): string | undefined;
    set wireframeLinejoin(value: string);
    get wireframeLinejoin(): string | undefined;
    set fog(value: boolean);
    get fog(): boolean | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThMeshToonMaterial<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThMeshToonMaterial<any, any>, "th-meshToonMaterial", never, { "type": "type"; "defines": "defines"; "color": "color"; "gradientMap": "gradientMap"; "map": "map"; "lightMap": "lightMap"; "lightMapIntensity": "lightMapIntensity"; "aoMap": "aoMap"; "aoMapIntensity": "aoMapIntensity"; "emissive": "emissive"; "emissiveIntensity": "emissiveIntensity"; "emissiveMap": "emissiveMap"; "bumpMap": "bumpMap"; "bumpScale": "bumpScale"; "normalMap": "normalMap"; "normalMapType": "normalMapType"; "normalScale": "normalScale"; "displacementMap": "displacementMap"; "displacementScale": "displacementScale"; "displacementBias": "displacementBias"; "alphaMap": "alphaMap"; "wireframe": "wireframe"; "wireframeLinewidth": "wireframeLinewidth"; "wireframeLinecap": "wireframeLinecap"; "wireframeLinejoin": "wireframeLinejoin"; "fog": "fog"; }, {}, never, ["*"], false, never>;
}
