import { Type } from '@angular/core';
import { Camera, Color, ColorRepresentation, Material, MeshBasicMaterial, MeshNormalMaterial, Scene, ShaderMaterial, WebGLRenderer, WebGLRenderTarget } from 'three';
import { ReflectorForSSRPass } from 'three/examples/jsm/objects/ReflectorForSSRPass';
import { FullScreenQuad } from 'three/examples/jsm/postprocessing/Pass';
import { SSRPass, SSRPassParams } from 'three/examples/jsm/postprocessing/SSRPass';
import { ThPass } from './ThPass';
import * as i0 from "@angular/core";
export declare class ThSSRPass<T extends SSRPass = SSRPass, TARGS = SSRPassParams> extends ThPass<T, TARGS> {
    getType(): Type<SSRPass>;
    set width(value: number);
    get width(): number | undefined;
    set height(value: number);
    get height(): number | undefined;
    set clear(value: boolean);
    get clear(): boolean | undefined;
    set renderer(value: WebGLRenderer);
    get renderer(): WebGLRenderer | undefined;
    set scene(value: Scene);
    get scene(): Scene | undefined;
    set camera(value: Camera);
    get camera(): Camera | undefined;
    set groundReflector(value: ReflectorForSSRPass | null);
    get groundReflector(): (ReflectorForSSRPass | null) | undefined;
    set opacity(value: number);
    get opacity(): number | undefined;
    set output(value: number);
    get output(): number | undefined;
    set maxDistance(value: number);
    get maxDistance(): number | undefined;
    set thickness(value: number);
    get thickness(): number | undefined;
    set tempColor(value: Color | [color: ColorRepresentation]);
    get tempColor(): Color | undefined;
    set selective(value: boolean);
    get selective(): boolean | undefined;
    set blur(value: boolean);
    get blur(): boolean | undefined;
    set thickTolerance(value: number);
    get thickTolerance(): number | undefined;
    set beautyRenderTarget(value: WebGLRenderTarget);
    get beautyRenderTarget(): WebGLRenderTarget | undefined;
    set prevRenderTarget(value: WebGLRenderTarget);
    get prevRenderTarget(): WebGLRenderTarget | undefined;
    set normalRenderTarget(value: WebGLRenderTarget);
    get normalRenderTarget(): WebGLRenderTarget | undefined;
    set metalnessRenderTarget(value: WebGLRenderTarget);
    get metalnessRenderTarget(): WebGLRenderTarget | undefined;
    set ssrRenderTarget(value: WebGLRenderTarget);
    get ssrRenderTarget(): WebGLRenderTarget | undefined;
    set blurRenderTarget(value: WebGLRenderTarget);
    get blurRenderTarget(): WebGLRenderTarget | undefined;
    set blurRenderTarget2(value: WebGLRenderTarget);
    get blurRenderTarget2(): WebGLRenderTarget | undefined;
    set ssrMaterial(value: ShaderMaterial);
    get ssrMaterial(): ShaderMaterial | undefined;
    set normalMaterial(value: MeshNormalMaterial);
    get normalMaterial(): MeshNormalMaterial | undefined;
    set metalnessOnMaterial(value: MeshBasicMaterial);
    get metalnessOnMaterial(): MeshBasicMaterial | undefined;
    set metalnessOffMaterial(value: MeshBasicMaterial);
    get metalnessOffMaterial(): MeshBasicMaterial | undefined;
    set blurMaterial(value: ShaderMaterial);
    get blurMaterial(): ShaderMaterial | undefined;
    set blurMaterial2(value: ShaderMaterial);
    get blurMaterial2(): ShaderMaterial | undefined;
    set depthRenderMaterial(value: ShaderMaterial);
    get depthRenderMaterial(): ShaderMaterial | undefined;
    set copyMaterial(value: ShaderMaterial);
    get copyMaterial(): ShaderMaterial | undefined;
    set fsQuad(value: FullScreenQuad);
    get fsQuad(): FullScreenQuad | undefined;
    set originalClearColor(value: Color | [color: ColorRepresentation]);
    get originalClearColor(): Color | undefined;
    static readonly OUTPUT: {
        Default: 0;
        SSR: 1;
        Beauty: 3;
        Depth: 4;
        Normal: 5;
        Metalness: 7;
    };
    set dispose(value: () => void);
    get dispose(): (() => void) | undefined;
    set renderPass(value: (renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void);
    get renderPass(): ((renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void) | undefined;
    set renderOverride(value: (renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void);
    get renderOverride(): ((renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void) | undefined;
    set renderMetalness(value: (renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void);
    get renderMetalness(): ((renderer: WebGLRenderer, passMaterial: Material, renderTarget: WebGLRenderTarget, clearColor: ColorRepresentation, clearAlpha: ColorRepresentation) => void) | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThSSRPass<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThSSRPass<any, any>, "th-sSRPass", never, { "width": "width"; "height": "height"; "clear": "clear"; "renderer": "renderer"; "scene": "scene"; "camera": "camera"; "groundReflector": "groundReflector"; "opacity": "opacity"; "output": "output"; "maxDistance": "maxDistance"; "thickness": "thickness"; "tempColor": "tempColor"; "selective": "selective"; "blur": "blur"; "thickTolerance": "thickTolerance"; "beautyRenderTarget": "beautyRenderTarget"; "prevRenderTarget": "prevRenderTarget"; "normalRenderTarget": "normalRenderTarget"; "metalnessRenderTarget": "metalnessRenderTarget"; "ssrRenderTarget": "ssrRenderTarget"; "blurRenderTarget": "blurRenderTarget"; "blurRenderTarget2": "blurRenderTarget2"; "ssrMaterial": "ssrMaterial"; "normalMaterial": "normalMaterial"; "metalnessOnMaterial": "metalnessOnMaterial"; "metalnessOffMaterial": "metalnessOffMaterial"; "blurMaterial": "blurMaterial"; "blurMaterial2": "blurMaterial2"; "depthRenderMaterial": "depthRenderMaterial"; "copyMaterial": "copyMaterial"; "fsQuad": "fsQuad"; "originalClearColor": "originalClearColor"; "dispose": "dispose"; "renderPass": "renderPass"; "renderOverride": "renderOverride"; "renderMetalness": "renderMetalness"; }, {}, never, ["*"], false, never>;
}
