import { Type } from '@angular/core';
import { GLSLVersion, IUniform, ShaderMaterial, ShaderMaterialParameters } from 'three';
import { ThMaterial } from './ThMaterial';
import * as i0 from "@angular/core";
export declare class ThShaderMaterial<T extends ShaderMaterial = ShaderMaterial, TARGS = ShaderMaterialParameters> extends ThMaterial<T, TARGS> {
    getType(): Type<ShaderMaterial>;
    set type(value: string);
    get type(): string | undefined;
    set defines(value: {
        [key: string]: any;
    });
    get defines(): {
        [key: string]: any;
    } | undefined;
    set uniforms(value: {
        [uniform: string]: IUniform;
    });
    get uniforms(): {
        [uniform: string]: IUniform;
    } | undefined;
    set vertexShader(value: string);
    get vertexShader(): string | undefined;
    set fragmentShader(value: string);
    get fragmentShader(): string | undefined;
    set linewidth(value: number);
    get linewidth(): number | undefined;
    set wireframe(value: boolean);
    get wireframe(): boolean | undefined;
    set wireframeLinewidth(value: number);
    get wireframeLinewidth(): number | undefined;
    set fog(value: boolean);
    get fog(): boolean | undefined;
    set lights(value: boolean);
    get lights(): boolean | undefined;
    set clipping(value: boolean);
    get clipping(): boolean | undefined;
    set derivatives(value: any);
    get derivatives(): any | undefined;
    set extensions(value: {
        derivatives: boolean;
        fragDepth: boolean;
        drawBuffers: boolean;
        shaderTextureLOD: boolean;
    });
    get extensions(): {
        derivatives: boolean;
        fragDepth: boolean;
        drawBuffers: boolean;
        shaderTextureLOD: boolean;
    } | undefined;
    set defaultAttributeValues(value: any);
    get defaultAttributeValues(): any | undefined;
    set index0AttributeName(value: string | undefined);
    get index0AttributeName(): (string | undefined) | undefined;
    set uniformsNeedUpdate(value: boolean);
    get uniformsNeedUpdate(): boolean | undefined;
    set glslVersion(value: GLSLVersion | null);
    get glslVersion(): (GLSLVersion | null) | undefined;
    set isShaderMaterial(value: boolean);
    get isShaderMaterial(): boolean | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThShaderMaterial<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThShaderMaterial<any, any>, "th-shaderMaterial", never, { "type": "type"; "defines": "defines"; "uniforms": "uniforms"; "vertexShader": "vertexShader"; "fragmentShader": "fragmentShader"; "linewidth": "linewidth"; "wireframe": "wireframe"; "wireframeLinewidth": "wireframeLinewidth"; "fog": "fog"; "lights": "lights"; "clipping": "clipping"; "derivatives": "derivatives"; "extensions": "extensions"; "defaultAttributeValues": "defaultAttributeValues"; "index0AttributeName": "index0AttributeName"; "uniformsNeedUpdate": "uniformsNeedUpdate"; "glslVersion": "glslVersion"; "isShaderMaterial": "isShaderMaterial"; }, {}, never, ["*"], false, never>;
}
