import * as i0 from '@angular/core';
import { InjectionToken, inject, Injectable, EventEmitter, Component, Input, Output, ChangeDetectionStrategy, SkipSelf, Directive, Host, forwardRef, ContentChild, Optional, isDevMode, Inject, ContentChildren, ViewChild, NgModule, Pipe, Self } from '@angular/core';
import * as THREE from 'three';
import { Raycaster, Object3D, Scene, Clock, Vector4, WebGLRenderTarget, AmbientLight, LightProbe, AmbientLightProbe, PerspectiveCamera, ArrayCamera, ArrowHelper, Audio, AudioListener, Line, LineSegments, AxesHelper, Bone, Box3Helper, BufferGeometry, BoxGeometry, BoxHelper, CameraHelper, Texture, CanvasTexture, CapsuleGeometry, CircleGeometry, CompressedTexture, CompressedArrayTexture, CylinderGeometry, ConeGeometry, CubeCamera, CubeTexture, Data3DTexture, DataArrayTexture, DataTexture, DepthTexture, DirectionalLight, DirectionalLightHelper, PolyhedronGeometry, DodecahedronGeometry, EdgesGeometry, ExtrudeGeometry, FramebufferTexture, GridHelper, Group, HemisphereLight, HemisphereLightHelper, HemisphereLightProbe, IcosahedronGeometry, InstancedBufferGeometry, Mesh, InstancedMesh, LatheGeometry, Material, LineBasicMaterial, LineDashedMaterial, LineLoop, LOD, MeshBasicMaterial, MeshDepthMaterial, MeshDistanceMaterial, MeshLambertMaterial, MeshMatcapMaterial, MeshNormalMaterial, MeshPhongMaterial, MeshStandardMaterial, MeshPhysicalMaterial, MeshToonMaterial, OctahedronGeometry, OrthographicCamera, PlaneGeometry, PlaneHelper, PointLight, PointLightHelper, Points, PointsMaterial, PolarGridHelper, PositionalAudio, ShaderMaterial, RawShaderMaterial, RectAreaLight, RingGeometry, ShadowMaterial, ShapeGeometry, SkeletonHelper, SkinnedMesh, SphereGeometry, SpotLight, SpotLightHelper, Sprite, SpriteMaterial, StereoCamera, TetrahedronGeometry, TorusGeometry, TorusKnotGeometry, TubeGeometry, VideoTexture, WireframeGeometry, CubeTextureLoader, TextureLoader, Color, Fog, Vector2, Vector3, Plane } from 'three';
import { ReplaySubject, Subject, takeUntil } from 'rxjs';
import { EffectComposer } from 'three/examples/jsm/postprocessing/EffectComposer';
import { RenderPass } from 'three/examples/jsm/postprocessing/RenderPass';
import { Pass } from 'three/examples/jsm/postprocessing/Pass';
import { TransformControls } from 'three/examples/jsm/controls/TransformControls';
import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import { AdaptiveToneMappingPass } from 'three/examples/jsm/postprocessing/AdaptiveToneMappingPass';
import { AfterimagePass } from 'three/examples/jsm/postprocessing/AfterimagePass';
import { ArcballControls } from 'three/examples/jsm/controls/ArcballControls';
import { BloomPass } from 'three/examples/jsm/postprocessing/BloomPass';
import { BokehPass } from 'three/examples/jsm/postprocessing/BokehPass';
import { BoxLineGeometry } from 'three/examples/jsm/geometries/BoxLineGeometry';
import { ClearMaskPass, MaskPass } from 'three/examples/jsm/postprocessing/MaskPass';
import { ClearPass } from 'three/examples/jsm/postprocessing/ClearPass';
import { ConvexGeometry } from 'three/examples/jsm/geometries/ConvexGeometry';
import { CubeTexturePass } from 'three/examples/jsm/postprocessing/CubeTexturePass';
import { DecalGeometry } from 'three/examples/jsm/geometries/DecalGeometry';
import { DotScreenPass } from 'three/examples/jsm/postprocessing/DotScreenPass';
import { DragControls } from 'three/examples/jsm/controls/DragControls';
import { FilmPass } from 'three/examples/jsm/postprocessing/FilmPass';
import { FirstPersonControls } from 'three/examples/jsm/controls/FirstPersonControls';
import { FlyControls } from 'three/examples/jsm/controls/FlyControls';
import { GlitchPass } from 'three/examples/jsm/postprocessing/GlitchPass';
import { HalftonePass } from 'three/examples/jsm/postprocessing/HalftonePass';
import { LightningStrike } from 'three/examples/jsm/geometries/LightningStrike';
import { LUTPass } from 'three/examples/jsm/postprocessing/LUTPass';
import { ShaderPass } from 'three/examples/jsm/postprocessing/ShaderPass';
import { MapControls } from 'three/examples/jsm/controls/MapControls';
import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls';
import { OutlinePass } from 'three/examples/jsm/postprocessing/OutlinePass';
import { ParametricGeometry } from 'three/examples/jsm/geometries/ParametricGeometry';
import { PointerLockControls } from 'three/examples/jsm/controls/PointerLockControls';
import { RoundedBoxGeometry } from 'three/examples/jsm/geometries/RoundedBoxGeometry';
import { SAOPass } from 'three/examples/jsm/postprocessing/SAOPass';
import { SavePass } from 'three/examples/jsm/postprocessing/SavePass';
import { SMAAPass } from 'three/examples/jsm/postprocessing/SMAAPass';
import { SSAARenderPass } from 'three/examples/jsm/postprocessing/SSAARenderPass';
import { SSAOPass } from 'three/examples/jsm/postprocessing/SSAOPass';
import { SSRPass } from 'three/examples/jsm/postprocessing/SSRPass';
import { TAARenderPass } from 'three/examples/jsm/postprocessing/TAARenderPass';
import { TeapotGeometry } from 'three/examples/jsm/geometries/TeapotGeometry';
import { TextGeometry } from 'three/examples/jsm/geometries/TextGeometry';
import { TexturePass } from 'three/examples/jsm/postprocessing/TexturePass';
import { TrackballControls } from 'three/examples/jsm/controls/TrackballControls';
import { UnrealBloomPass } from 'three/examples/jsm/postprocessing/UnrealBloomPass';
import { DDSLoader } from 'three/examples/jsm/loaders/DDSLoader';
import { __awaiter } from 'tslib';
import { KTX2Loader } from 'three/examples/jsm/loaders/KTX2Loader';
import { KTXLoader } from 'three/examples/jsm/loaders/KTXLoader';
import { PVRLoader } from 'three/examples/jsm/loaders/PVRLoader';
import { EXRLoader } from 'three/examples/jsm/loaders/EXRLoader';
import { RGBELoader } from 'three/examples/jsm/loaders/RGBELoader';
import { RGBMLoader } from 'three/examples/jsm/loaders/RGBMLoader';
import { TGALoader } from 'three/examples/jsm/loaders/TGALoader';
import { GLTFLoader } from 'three/examples/jsm/loaders/GLTFLoader';
import { DRACOLoader } from 'three/examples/jsm/loaders/DRACOLoader';
import Stats from 'three/examples/jsm/libs/stats.module';
import { OBJLoader } from 'three/examples/jsm/loaders/OBJLoader';
import { FBXLoader } from 'three/examples/jsm/loaders/FBXLoader';
import { LogLuvLoader } from 'three/examples/jsm/loaders/LogLuvLoader';
import { PLYLoader } from 'three/examples/jsm/loaders/PLYLoader';

// eslint-disable-next-line no-shadow
var RaycasterEvent;
(function (RaycasterEvent) {
    RaycasterEvent["mouseEnter"] = "mouseEnter";
    RaycasterEvent["mouseExit"] = "mouseExit";
    RaycasterEvent["click"] = "click";
    RaycasterEvent["pointerDown"] = "pointerDown";
    RaycasterEvent["pointerUp"] = "pointerUp";
})(RaycasterEvent || (RaycasterEvent = {}));
const RAYCASTER = new InjectionToken('A reference to the raycaster object', {
    factory: () => new Raycaster()
});
class RaycasterService {
    constructor() {
        this.raycaster = inject(RAYCASTER);
        this.selected = null;
        this.enabled = true;
        this.groups = [];
        this.paused = false;
        this.maxClickDistance = 23;
        this.nid = RaycasterService.instanceCnt++;
        this.onPointerMove = this.onPointerMove.bind(this);
        this.onPointerDown = this.onPointerDown.bind(this);
        this.onPointerUp = this.onPointerUp.bind(this);
    }
    ngOnDestroy() {
        this.disable();
        this.unsubscribe();
    }
    subscribe() {
        if (!this.canvas) {
            throw new Error('missing canvas');
        }
        this.canvas.addEventListener('pointermove', this.onPointerMove);
        this.canvas.addEventListener('pointerdown', this.onPointerDown);
        this.canvas.addEventListener('pointerup', this.onPointerUp);
    }
    unsubscribe() {
        if (!this.canvas) {
            throw new Error('missing canvas');
        }
        this.canvas.removeEventListener('pointermove', this.onPointerMove);
        this.canvas.removeEventListener('pointerdown', this.onPointerDown);
        this.canvas.removeEventListener('pointerup', this.onPointerUp);
    }
    enable() {
        this.enabled = true;
    }
    disable() {
        this.enabled = false;
    }
    pause() {
        this.paused = true;
    }
    resume() {
        this.paused = false;
    }
    get isEnabled() {
        return this.enabled;
    }
    init(camera, canvas) {
        // console.log('Add camera to raycaster', camera);
        this.camera = camera;
        this.canvas = canvas;
        this.subscribe();
    }
    addEventTarget(target) {
        // console.log('RaycasterService.addGroup', group.name, group);
        this.groups.push(target);
    }
    removeEventTarget(target) {
        const index = this.groups.indexOf(target);
        if (index >= 0) {
            this.groups.splice(index, 1);
        }
    }
    onPointerMove(event /*MouseEvent  & { layerX: number, layerY: number}*/) {
        var _a, _b;
        if (!this.isReady()) {
            return;
        }
        const i = this.getFirstIntersectedGroup(event.layerX, event.layerY, RaycasterEvent.mouseEnter);
        if (!this.selected || this.selected !== (i === null || i === void 0 ? void 0 : i.target)) {
            if (this.selected) {
                (_a = this.selected.host.objRef) === null || _a === void 0 ? void 0 : _a.dispatchEvent({
                    type: RaycasterEvent.mouseExit,
                    component: this.selected.host
                });
                this.selected.emitOnMouseExit();
                this.selected = null;
            }
            if (i && i.target) {
                this.selected = i.target;
                const evt = Object.assign({ type: RaycasterEvent.mouseEnter, component: i.target.host }, i);
                (_b = this.selected.host.objRef) === null || _b === void 0 ? void 0 : _b.dispatchEvent(evt);
                this.selected.emitOnMouseEnter(evt);
            }
        }
    }
    onPointerDown(event) {
        this.maxClickDistance = event.width;
        this.pointerDownEvent = event;
        if (!this.isReady()) {
            return;
        }
        const i = this.getFirstIntersectedGroup(event.layerX, event.layerY, RaycasterEvent.pointerDown);
        if (i && i.target && i.target.host.objRef) {
            const evt = Object.assign({ type: RaycasterEvent.pointerDown, component: i.target.host }, i);
            i.target.host.objRef.dispatchEvent(evt);
            i.target.emitOnPointerDown(evt);
        }
    }
    onPointerUp(event) {
        const downEvent = this.pointerDownEvent;
        this.pointerDownEvent = undefined;
        if (!this.isReady()) {
            return;
        }
        // pointer up
        let i = this.getFirstIntersectedGroup(event.layerX, event.layerY, RaycasterEvent.pointerUp);
        if (i && i.target && i.target.host.objRef) {
            const evt = Object.assign({ type: RaycasterEvent.pointerUp, component: i.target.host }, i);
            i.target.host.objRef.dispatchEvent(evt);
            i.target.emitOnPointerUp(evt);
        }
        // click
        if (this.calcPointerDownUpDinstance(event, downEvent) > this.maxClickDistance) {
            return;
        }
        i = this.getFirstIntersectedGroup(event.layerX, event.layerY, RaycasterEvent.click);
        if (i && i.target && i.target.host.objRef) {
            const evt = Object.assign({ type: RaycasterEvent.click, component: i.target.host }, i);
            i.target.host.objRef.dispatchEvent(evt);
            i.target.emitOnClick(evt);
        }
    }
    isReady(ignorePaused) {
        return !!(this.enabled &&
            (ignorePaused || !this.paused) &&
            this.camera &&
            this.camera.objRef &&
            this.groups &&
            this.groups.length > 0);
    }
    calcPointerDownUpDinstance(upEvent, downEvent) {
        if (!downEvent) {
            return Number.MAX_VALUE;
        }
        const xDist = upEvent.layerX - downEvent.layerX;
        const yDist = upEvent.layerY - downEvent.layerY;
        return Math.sqrt(xDist * xDist + yDist * yDist);
    }
    getFirstIntersectedGroup(x, y, event) {
        if (!this.camera || !this.canvas || !this.camera.objRef) {
            return;
        }
        x = (x / this.canvas.clientWidth) * 2 - 1;
        y = -(y / this.canvas.clientHeight) * 2 + 1;
        const mouseVector = new THREE.Vector2(x, y);
        this.raycaster.setFromCamera(mouseVector, this.camera.objRef);
        // loop across all groups. Try to find the group with nearest distance.
        let nearestIntersection;
        let nearestGroup;
        for (const group of this.groups) {
            const i = group.host.objRef;
            if (!group[event] || !i) {
                continue;
            }
            const intersection = this.raycaster.intersectObject(i, true);
            if (intersection.length > 0 &&
                (!nearestIntersection || nearestIntersection.distance > intersection[0].distance)) {
                nearestIntersection = intersection[0];
                nearestGroup = group;
            }
        }
        // return the group with nearest distance
        if (nearestGroup && nearestIntersection) {
            return Object.assign({ target: nearestGroup }, nearestIntersection);
        }
        else {
            return undefined;
        }
    }
}
RaycasterService.instanceCnt = 0;
RaycasterService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RaycasterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
RaycasterService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RaycasterService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RaycasterService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

function isSettable(obj) {
    return !!(obj && obj.set); // && obj.copy;
}
/**
 * tries to apply the new value to the target.
 * if the new value is 'setter arguments' then it uses set on the target.
 * else it tries to use the 'copy' method of the target if available
 * else it return the newValue as new target
 * if newValue is undefined the old target is returned
 *
 * @param target the target for the new value
 * @param newValue the value to be set
 * @returns the new target(value)
 */
function applyValue(target, newValue) {
    if (isSettable(target)) {
        if (newValue === undefined) {
            return target;
        }
        if (Array.isArray(newValue)) {
            target.set(...newValue);
            return target;
        }
        if (target.copy && newValue) {
            target.copy(newValue);
            return target;
        }
        // just set the value
        if (newValue !== undefined) {
            target.set(newValue);
            return target;
        }
    }
    else {
        // apply the value
        return newValue;
    }
    // nothing to do
    return target;
}
function isDisposable(obj) {
    if (obj && typeof obj.dispose === 'function') {
        return true;
    }
    return false;
}
/**
 * compatibility function for checking if a subject is observed
 * works with RxJs 6.x.x and RxJs 7+
 *
 * @param s the subject
 * @returns true if the subject is observed
 */
function isObserved(s) {
    var _a;
    return (s !== undefined &&
        (s.observed /* <-- needs at least RxJs 7.x.x */ || ((_a = s.observers) === null || _a === void 0 ? void 0 : _a.length) > 0) /* <-- for RxJs < 7.x.x */);
}
// This can live anywhere in your codebase:
function applyMixins(derivedCtor, constructors) {
    constructors.forEach((baseCtor) => {
        Object.getOwnPropertyNames(baseCtor.prototype).forEach((name) => {
            Object.defineProperty(derivedCtor.prototype, name, Object.getOwnPropertyDescriptor(baseCtor.prototype, name) || Object.create(null));
        });
    });
}

class Object3DProxyHandler {
    constructor(target) {
        this.memberMap = new Map();
        this.children = [];
        this.eventListener = {};
        this.loaded = false;
        this.add = (...object) => {
            if (this.objRef) {
                this.objRef.add(...object);
            }
            this.children.push(...object);
            return this;
        };
        this.remove = (...object) => {
            if (this.objRef) {
                this.objRef.remove(...object);
            }
            for (const obj of object) {
                const index = this.children.indexOf(obj);
                if (index >= 0) {
                    this.children = this.children.splice(index, 1);
                }
            }
            return this;
        };
        this.applyToObject3D = (objRef) => {
            var _a, _b;
            this.memberMap.forEach((value, key) => {
                const member = objRef[key];
                if (isSettable(member)) {
                    applyValue(member, value);
                }
                else {
                    objRef[key] = value;
                }
            });
            this.children.forEach((child) => objRef.add(child));
            if ((_a = this.objRef) === null || _a === void 0 ? void 0 : _a.parent) {
                const parent = (_b = this.objRef) === null || _b === void 0 ? void 0 : _b.parent;
                parent.remove(this.objRef);
                parent.add(objRef);
            }
        };
        /**
         * Adds a listener to an event type.
         *
         * @param type The type of event to listen to.
         * @param listener The function that gets called when the event is fired.
         */
        this.addEventListener = (type, listener) => {
            let arr = this.eventListener[type];
            if (!arr) {
                arr = [];
                this.eventListener[type] = arr;
            }
            arr.push(listener);
            if (this.objRef) {
                this.objRef.addEventListener(type, listener);
            }
        };
        /**
         * Removes a listener from an event type.
         *
         * @param type The type of the listener that gets removed.
         * @param listener The listener function that gets removed.
         */
        this.removeEventListener = (type, listener) => {
            const arr = this.eventListener[type];
            if (!arr) {
                return;
            }
            const index = arr.indexOf(listener);
            if (index >= 0) {
                arr.splice(index, 1);
            }
        };
        this.objRef = target;
    }
    get(_target, p, receiver) {
        switch (p) {
            case '__isProxy':
                return true;
            case 'applyToObject3D':
                return this.applyToObject3D;
            case 'objRef':
                if (this.loaded) {
                    return this.objRef;
                }
                else {
                    return undefined;
                }
            case 'add':
                return this.add;
            case 'remove':
                return this.remove;
            case 'children':
                return this.objRef ? this.objRef.children : this.children;
            default: {
                const objKey = p;
                const value = this.objRef[objKey];
                if (value !== undefined) {
                    // this is necessary for complex members
                    // (returned by reference, they might be altered, we have to reapply them to the real object )
                    this.memberMap.set(objKey, value);
                }
                return value;
            }
        }
    }
    set(_target, p, value, _receiver) {
        if (p === 'objRef') {
            if (value) {
                this.applyToObject3D(value);
            }
            this.loaded = true;
            this.objRef = value;
        }
        else {
            // store to the member map
            this.memberMap.set(p, value);
            if (this.objRef) {
                // and apply to the real object if present
                this.objRef[p] = value;
            }
        }
        return true;
    }
}
function createLazyObject3DProxy(target = new Object3D()) {
    const handler = new Object3DProxyHandler(target);
    return new Proxy(handler, handler);
}
function isLazyObject3dProxy(object) {
    return (
    // eslint-disable-next-line no-underscore-dangle
    object.__isProxy === true && object.objRef === undefined);
}

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThWrapperBase {
    set objRef(ref) {
        this.applyObjRef(ref);
    }
    get objRef() {
        return this._objRef;
    }
    constructor() {
        this.autoAddToParent = true;
        this.autoDispose = true;
        // nothing to do
    }
    addToParent() {
        // nothing to do, implement it in a derived class
    }
    removeFromParent() {
        // nothing to do, implement it in a derived class
    }
    set threeEvents(eventMap) {
        this.removeEvents();
        this.eventListeners = eventMap;
        this.applyEvents();
    }
    get threeEvents() {
        return this.eventListeners;
    }
    get onUpdate() {
        if (!this.updateEmitter) {
            this.updateEmitter = new EventEmitter();
        }
        return this.updateEmitter;
    }
    /**
     * emits the last assigned object ref
     */
    get objRef$() {
        if (!this._objRef$) {
            this._objRef$ = new ReplaySubject(1);
        }
        return this._objRef$;
    }
    ngOnInit() {
        if (!this.objRef) {
            this.objRef = this.createThreeInstance(this.args);
        }
    }
    // Override this
    getType() {
        throw new Error('derive me');
    }
    createThreeInstance(args) {
        if (Array.isArray(args)) {
            return new (this.getType())(...args);
        }
        else {
            return new (this.getType())(args);
        }
    }
    ngOnChanges(changes) {
        var _a;
        // console.log('on changes');
        if (this.objRef && !isLazyObject3dProxy(this.objRef)) {
            // the object is already set and it is no proxy
            // emit the changes
            this.emitPropertyChanges(changes);
            // TODO: request animation frame
            return;
        }
        if (!this.objRef) {
            // no object and no proxy is set --> create an instance
            this.objRef = this.createThreeInstance((_a = changes.args) === null || _a === void 0 ? void 0 : _a.currentValue);
        }
        // eslint-disable-next-line guard-for-in
        for (const key in changes) {
            this[key] = changes[key].currentValue;
        }
        this.emitPropertyChanges(changes);
    }
    disposeObjRef() {
        if (isDisposable(this.objRef)) {
            this.objRef.dispose();
        }
    }
    ngOnDestroy() {
        this.removeEvents();
        this.removeFromParent();
        if (this.autoDispose) {
            this.disposeObjRef();
        }
    }
    applyObjRef(objRef) {
        if (this._objRef !== objRef) {
            this.removeFromParent();
            this._objRef = objRef;
            if (this.autoAddToParent) {
                this.addToParent();
            }
        }
        this.emitObjRefChange();
    }
    emitObjRefChange() {
        var _a, _b;
        // only emit change if _objRef is no proxy,
        // and trigger emit over objRef event emitter
        if (this._objRef && !isLazyObject3dProxy(this._objRef)) {
            (_b = (_a = this._objRef).dispatchEvent) === null || _b === void 0 ? void 0 : _b.call(_a, { type: 'loaded', object: this._objRef });
            if (this._objRef$) {
                this._objRef$.next(this._objRef);
            }
        }
    }
    emitPropertyChanges(changes) {
        var _a, _b;
        if (this._objRef) {
            (_b = (_a = this._objRef).dispatchEvent) === null || _b === void 0 ? void 0 : _b.call(_a, { type: 'changes', changes });
        }
        if (this.updateEmitter) {
            this.updateEmitter.next(changes);
        }
    }
    removeEvents() {
        if (this.eventListeners && this._objRef) {
            for (const entry of Object.entries(this.eventListeners)) {
                this._objRef.removeEventListener(entry[0], entry[1]);
            }
            this.eventListeners = undefined;
        }
    }
    applyEvents() {
        if (this.eventListeners && this._objRef) {
            for (const entry of Object.entries(this.eventListeners)) {
                this._objRef.addEventListener(entry[0], entry[1]);
            }
        }
    }
}
ThWrapperBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThWrapperBase, deps: [], target: i0.ɵɵFactoryTarget.Component });
ThWrapperBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThWrapperBase, selector: "th-abs-wrapper", inputs: { autoAddToParent: "autoAddToParent", autoDispose: "autoDispose", objRef: "objRef", args: "args", threeEvents: "threeEvents" }, outputs: { onUpdate: "onUpdate", objRef$: "objRef$" }, usesOnChanges: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThWrapperBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-wrapper',
                    template: ''
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { autoAddToParent: [{
                type: Input
            }], autoDispose: [{
                type: Input
            }], objRef: [{
                type: Input
            }], args: [{
                type: Input
            }], threeEvents: [{
                type: Input
            }], onUpdate: [{
                type: Output
            }], objRef$: [{
                type: Output
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThObjectBase extends ThWrapperBase {
    constructor(parent) {
        super();
        this.parent = parent;
    }
    addToParent() {
        if (this._objRef &&
            this.parent.objRef &&
            (!this._objRef.parent || this._objRef.parent.uuid !== this.parent.objRef.uuid)) {
            this.parent.objRef.add(this._objRef);
        }
    }
    removeFromParent() {
        var _a, _b;
        (_b = (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.remove(this._objRef);
    }
    applyObjRef(objRef) {
        var _a, _b;
        if (this._objRef !== objRef || ((_b = (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.uuid) !== this.parent.objRef.uuid) {
            this.removeFromParent();
            this._objRef = objRef;
            if (this.autoAddToParent) {
                this.addToParent();
            }
        }
        this.emitObjRefChange();
    }
    attachToParent(newRef, oldRef) {
        var _a;
        if (!this.parent.objRef || (newRef === oldRef && ((_a = oldRef === null || oldRef === void 0 ? void 0 : oldRef.parent) === null || _a === void 0 ? void 0 : _a.uuid) === this.parent.objRef.uuid)) {
            return;
        }
        // remove old obj from parent
        if (oldRef && oldRef.parent) {
            oldRef.parent.remove(oldRef);
        }
        // add new obj to parent
        if (newRef && (!newRef.parent || (newRef.parent && newRef.parent.uuid !== this.parent.objRef.uuid))) {
            this.parent.objRef.add(newRef);
        }
    }
    // object 3d methods
    set lookAt(vector) {
        Promise.resolve().then(() => {
            // execute next microtick, to assume all
            // position changes already happend,
            // because lookAt triggers a world matrix calculation
            if (!this.objRef) {
                return;
            }
            if (Array.isArray(vector)) {
                this.objRef.lookAt(...vector);
            }
            else {
                this.objRef.lookAt(vector);
            }
        });
    }
}
ThObjectBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjectBase, deps: [{ token: ThObjectBase }], target: i0.ɵɵFactoryTarget.Component });
ThObjectBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThObjectBase, selector: "th-abs-object", inputs: { lookAt: "lookAt" }, usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjectBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-object',
                    template: '<ng-content/>'
                }]
        }], ctorParameters: function () { return [{ type: ThObjectBase }]; }, propDecorators: { lookAt: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThObject3D extends ThObjectBase {
    getType() {
        return Object3D;
    }
    // @ts-ignore
    get isObject3D() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isObject3D;
    }
    // @ts-ignore
    get id() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.id;
    }
    set uuid(value) {
        if (this._objRef) {
            this._objRef.uuid = value;
        }
    }
    // @ts-ignore
    get uuid() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uuid;
    }
    set name(value) {
        if (this._objRef) {
            this._objRef.name = value;
        }
    }
    // @ts-ignore
    get name() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.name;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set children(value) {
        if (this._objRef) {
            this._objRef.children = value;
        }
    }
    // @ts-ignore
    get children() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.children;
    }
    set up(value) {
        if (this._objRef) {
            this._objRef.up = applyValue(this._objRef.up, value);
        }
    }
    // @ts-ignore
    get up() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.up;
    }
    set position(value) {
        if (this._objRef) {
            applyValue(this._objRef.position, value);
        }
    }
    // @ts-ignore
    get position() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position;
    }
    set rotation(value) {
        if (this._objRef) {
            applyValue(this._objRef.rotation, value);
        }
    }
    // @ts-ignore
    get rotation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotation;
    }
    set quaternion(value) {
        if (this._objRef) {
            applyValue(this._objRef.quaternion, value);
        }
    }
    // @ts-ignore
    get quaternion() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.quaternion;
    }
    set scale(value) {
        if (this._objRef) {
            applyValue(this._objRef.scale, value);
        }
    }
    // @ts-ignore
    get scale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scale;
    }
    set modelViewMatrix(value) {
        if (this._objRef) {
            applyValue(this._objRef.modelViewMatrix, value);
        }
    }
    // @ts-ignore
    get modelViewMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.modelViewMatrix;
    }
    set normalMatrix(value) {
        if (this._objRef) {
            applyValue(this._objRef.normalMatrix, value);
        }
    }
    // @ts-ignore
    get normalMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMatrix;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixWorld(value) {
        if (this._objRef) {
            this._objRef.matrixWorld = applyValue(this._objRef.matrixWorld, value);
        }
    }
    // @ts-ignore
    get matrixWorld() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixWorld;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
    set matrixWorldAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixWorldAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixWorldAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixWorldAutoUpdate;
    }
    set matrixWorldNeedsUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixWorldNeedsUpdate = value;
        }
    }
    // @ts-ignore
    get matrixWorldNeedsUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixWorldNeedsUpdate;
    }
    set layers(value) {
        if (this._objRef) {
            this._objRef.layers = applyValue(this._objRef.layers, value);
        }
    }
    // @ts-ignore
    get layers() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.layers;
    }
    set visible(value) {
        if (this._objRef) {
            this._objRef.visible = value;
        }
    }
    // @ts-ignore
    get visible() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.visible;
    }
    set castShadow(value) {
        if (this._objRef) {
            this._objRef.castShadow = value;
        }
    }
    // @ts-ignore
    get castShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.castShadow;
    }
    set receiveShadow(value) {
        if (this._objRef) {
            this._objRef.receiveShadow = value;
        }
    }
    // @ts-ignore
    get receiveShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.receiveShadow;
    }
    set frustumCulled(value) {
        if (this._objRef) {
            this._objRef.frustumCulled = value;
        }
    }
    // @ts-ignore
    get frustumCulled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.frustumCulled;
    }
    set renderOrder(value) {
        if (this._objRef) {
            this._objRef.renderOrder = value;
        }
    }
    // @ts-ignore
    get renderOrder() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderOrder;
    }
    set animations(value) {
        if (this._objRef) {
            this._objRef.animations = value;
        }
    }
    // @ts-ignore
    get animations() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.animations;
    }
    set userData(value) {
        if (this._objRef) {
            this._objRef.userData = value;
        }
    }
    // @ts-ignore
    get userData() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.userData;
    }
    set customDepthMaterial(value) {
        if (this._objRef) {
            this._objRef.customDepthMaterial = value;
        }
    }
    // @ts-ignore
    get customDepthMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.customDepthMaterial;
    }
    set customDistanceMaterial(value) {
        if (this._objRef) {
            this._objRef.customDistanceMaterial = value;
        }
    }
    // @ts-ignore
    get customDistanceMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.customDistanceMaterial;
    }
    set onBeforeRender(value) {
        if (this._objRef) {
            this._objRef.onBeforeRender = value;
        }
    }
    // @ts-ignore
    get onBeforeRender() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.onBeforeRender;
    }
    set onAfterRender(value) {
        if (this._objRef) {
            this._objRef.onAfterRender = value;
        }
    }
    // @ts-ignore
    get onAfterRender() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.onAfterRender;
    }
    constructor(parent) {
        super(parent);
    }
}
ThObject3D.DEFAULT_UP = Object3D.DEFAULT_UP;
ThObject3D.DEFAULT_MATRIX_AUTO_UPDATE = Object3D.DEFAULT_MATRIX_AUTO_UPDATE;
ThObject3D.DEFAULT_MATRIX_WORLD_AUTO_UPDATE = Object3D.DEFAULT_MATRIX_WORLD_AUTO_UPDATE;
ThObject3D.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObject3D, deps: [{ token: ThObject3D, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component });
ThObject3D.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThObject3D, selector: "th-object3D", inputs: { uuid: "uuid", name: "name", children: "children", up: "up", position: "position", rotation: "rotation", quaternion: "quaternion", scale: "scale", modelViewMatrix: "modelViewMatrix", normalMatrix: "normalMatrix", matrix: "matrix", matrixWorld: "matrixWorld", matrixAutoUpdate: "matrixAutoUpdate", matrixWorldAutoUpdate: "matrixWorldAutoUpdate", matrixWorldNeedsUpdate: "matrixWorldNeedsUpdate", layers: "layers", visible: "visible", castShadow: "castShadow", receiveShadow: "receiveShadow", frustumCulled: "frustumCulled", renderOrder: "renderOrder", animations: "animations", userData: "userData", customDepthMaterial: "customDepthMaterial", customDistanceMaterial: "customDistanceMaterial", onBeforeRender: "onBeforeRender", onAfterRender: "onAfterRender" }, providers: [], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObject3D, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-object3D',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: []
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: SkipSelf
                    }] }];
    }, propDecorators: { uuid: [{
                type: Input
            }], name: [{
                type: Input
            }], children: [{
                type: Input
            }], up: [{
                type: Input
            }], position: [{
                type: Input
            }], rotation: [{
                type: Input
            }], quaternion: [{
                type: Input
            }], scale: [{
                type: Input
            }], modelViewMatrix: [{
                type: Input
            }], normalMatrix: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixWorld: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }], matrixWorldAutoUpdate: [{
                type: Input
            }], matrixWorldNeedsUpdate: [{
                type: Input
            }], layers: [{
                type: Input
            }], visible: [{
                type: Input
            }], castShadow: [{
                type: Input
            }], receiveShadow: [{
                type: Input
            }], frustumCulled: [{
                type: Input
            }], renderOrder: [{
                type: Input
            }], animations: [{
                type: Input
            }], userData: [{
                type: Input
            }], customDepthMaterial: [{
                type: Input
            }], customDistanceMaterial: [{
                type: Input
            }], onBeforeRender: [{
                type: Input
            }], onAfterRender: [{
                type: Input
            }] } });

class RaycasterEventDirective {
    get onMouseEnter() {
        if (!this.mouseEnter) {
            this.mouseEnter = new EventEmitter();
        }
        return this.mouseEnter;
    }
    get onMouseExit() {
        if (!this.mouseExit) {
            this.mouseExit = new EventEmitter();
        }
        return this.mouseExit;
    }
    get onClick() {
        if (!this.click) {
            this.click = new EventEmitter();
        }
        return this.click;
    }
    get onPointerDown() {
        if (!this.pointerDown) {
            this.pointerDown = new EventEmitter();
        }
        return this.pointerDown;
    }
    get onPointerUp() {
        if (!this.pointerUp) {
            this.pointerUp = new EventEmitter();
        }
        return this.pointerUp;
    }
    constructor(host, raycasterService) {
        this.host = host;
        this.raycasterService = raycasterService;
        this.emitOnMouseEnter = this.emitOnMouseEnter.bind(this);
        this.emitOnMouseExit = this.emitOnMouseExit.bind(this);
        this.emitOnClick = this.emitOnClick.bind(this);
    }
    ngAfterViewInit() {
        this.subscribeEvents();
    }
    subscribeEvents() {
        this.raycasterService.addEventTarget(this);
    }
    unSubscribeEvents() {
        this.raycasterService.removeEventTarget(this);
    }
    emitOnMouseExit() {
        var _a;
        (_a = this.mouseExit) === null || _a === void 0 ? void 0 : _a.emit({
            component: this.host,
            type: RaycasterEvent.mouseExit
        });
    }
    emitOnMouseEnter(event) {
        var _a;
        // console.log('RaycasterGroupDirective.onMouseEnter', event);
        (_a = this.mouseEnter) === null || _a === void 0 ? void 0 : _a.emit(event);
    }
    emitOnClick(event) {
        var _a;
        // console.log('onClick', event);
        (_a = this.click) === null || _a === void 0 ? void 0 : _a.emit(event);
    }
    emitOnPointerDown(event) {
        var _a;
        // console.log('onClick', event);
        (_a = this.pointerDown) === null || _a === void 0 ? void 0 : _a.emit(event);
    }
    emitOnPointerUp(event) {
        var _a;
        // console.log('onClick', event);
        (_a = this.pointerUp) === null || _a === void 0 ? void 0 : _a.emit(event);
    }
    ngOnDestroy() {
        this.unSubscribeEvents();
    }
}
RaycasterEventDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RaycasterEventDirective, deps: [{ token: ThObject3D, host: true }, { token: RaycasterService }], target: i0.ɵɵFactoryTarget.Directive });
RaycasterEventDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: RaycasterEventDirective, selector: "[onClick], [onMouseEnter], [onMouseExit], [onPointerDown], [onPointerUp]", outputs: { onMouseEnter: "onMouseEnter", onMouseExit: "onMouseExit", onClick: "onClick", onPointerDown: "onPointerDown", onPointerUp: "onPointerUp" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RaycasterEventDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[onClick], [onMouseEnter], [onMouseExit], [onPointerDown], [onPointerUp]' }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: Host
                    }] }, { type: RaycasterService }];
    }, propDecorators: { onMouseEnter: [{
                type: Output
            }], onMouseExit: [{
                type: Output
            }], onClick: [{
                type: Output
            }], onPointerDown: [{
                type: Output
            }], onPointerUp: [{
                type: Output
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThEffectComposerGen extends ThWrapperBase {
    getType() {
        return EffectComposer;
    }
    set renderer(value) {
        if (this._objRef) {
            this._objRef.renderer = value;
        }
    }
    // @ts-ignore
    get renderer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderer;
    }
    set renderTarget1(value) {
        if (this._objRef) {
            this._objRef.renderTarget1 = value;
        }
    }
    // @ts-ignore
    get renderTarget1() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTarget1;
    }
    set renderTarget2(value) {
        if (this._objRef) {
            this._objRef.renderTarget2 = value;
        }
    }
    // @ts-ignore
    get renderTarget2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTarget2;
    }
    set writeBuffer(value) {
        if (this._objRef) {
            this._objRef.writeBuffer = value;
        }
    }
    // @ts-ignore
    get writeBuffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.writeBuffer;
    }
    set readBuffer(value) {
        if (this._objRef) {
            this._objRef.readBuffer = value;
        }
    }
    // @ts-ignore
    get readBuffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.readBuffer;
    }
    set passes(value) {
        if (this._objRef) {
            this._objRef.passes = value;
        }
    }
    // @ts-ignore
    get passes() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.passes;
    }
    set copyPass(value) {
        if (this._objRef) {
            this._objRef.copyPass = value;
        }
    }
    // @ts-ignore
    get copyPass() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyPass;
    }
    set clock(value) {
        if (this._objRef) {
            this._objRef.clock = value;
        }
    }
    // @ts-ignore
    get clock() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clock;
    }
    set renderToScreen(value) {
        if (this._objRef) {
            this._objRef.renderToScreen = value;
        }
    }
    // @ts-ignore
    get renderToScreen() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderToScreen;
    }
}
ThEffectComposerGen.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEffectComposerGen, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThEffectComposerGen.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThEffectComposerGen, selector: "th-effectComposerGen", inputs: { renderer: "renderer", renderTarget1: "renderTarget1", renderTarget2: "renderTarget2", writeBuffer: "writeBuffer", readBuffer: "readBuffer", passes: "passes", copyPass: "copyPass", clock: "clock", renderToScreen: "renderToScreen" }, providers: [], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEffectComposerGen, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-effectComposerGen',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: []
                }]
        }], propDecorators: { renderer: [{
                type: Input
            }], renderTarget1: [{
                type: Input
            }], renderTarget2: [{
                type: Input
            }], writeBuffer: [{
                type: Input
            }], readBuffer: [{
                type: Input
            }], passes: [{
                type: Input
            }], copyPass: [{
                type: Input
            }], clock: [{
                type: Input
            }], renderToScreen: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCamera extends ThObject3D {
    // @ts-ignore
    get isCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isCamera;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set layers(value) {
        if (this._objRef) {
            this._objRef.layers = applyValue(this._objRef.layers, value);
        }
    }
    // @ts-ignore
    get layers() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.layers;
    }
    set matrixWorldInverse(value) {
        if (this._objRef) {
            this._objRef.matrixWorldInverse = applyValue(this._objRef.matrixWorldInverse, value);
        }
    }
    // @ts-ignore
    get matrixWorldInverse() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixWorldInverse;
    }
    set projectionMatrix(value) {
        if (this._objRef) {
            this._objRef.projectionMatrix = applyValue(this._objRef.projectionMatrix, value);
        }
    }
    // @ts-ignore
    get projectionMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.projectionMatrix;
    }
    set projectionMatrixInverse(value) {
        if (this._objRef) {
            this._objRef.projectionMatrixInverse = applyValue(this._objRef.projectionMatrixInverse, value);
        }
    }
    // @ts-ignore
    get projectionMatrixInverse() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.projectionMatrixInverse;
    }
}
ThCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCamera, selector: "th-camera", inputs: { layers: "layers", matrixWorldInverse: "matrixWorldInverse", projectionMatrix: "projectionMatrix", projectionMatrixInverse: "projectionMatrixInverse" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCamera) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-camera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCamera) }]
                }]
        }], propDecorators: { layers: [{
                type: Input
            }], matrixWorldInverse: [{
                type: Input
            }], projectionMatrix: [{
                type: Input
            }], projectionMatrixInverse: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThScene extends ThObject3D {
    getType() {
        return Scene;
    }
    // @ts-ignore
    get isScene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isScene;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
    set backgroundBlurriness(value) {
        if (this._objRef) {
            this._objRef.backgroundBlurriness = value;
        }
    }
    // @ts-ignore
    get backgroundBlurriness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.backgroundBlurriness;
    }
    set backgroundIntensity(value) {
        if (this._objRef) {
            this._objRef.backgroundIntensity = value;
        }
    }
    // @ts-ignore
    get backgroundIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.backgroundIntensity;
    }
    set overrideMaterial(value) {
        if (this._objRef) {
            this._objRef.overrideMaterial = value;
        }
    }
    // @ts-ignore
    get overrideMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.overrideMaterial;
    }
    set background(value) {
        if (this._objRef) {
            this._objRef.background = applyValue(this._objRef.background, value);
        }
    }
    // @ts-ignore
    get background() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.background;
    }
    set environment(value) {
        if (this._objRef) {
            this._objRef.environment = value;
        }
    }
    // @ts-ignore
    get environment() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.environment;
    }
}
ThScene.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThScene, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThScene.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThScene, selector: "th-scene", inputs: { type: "type", fog: "fog", backgroundBlurriness: "backgroundBlurriness", backgroundIntensity: "backgroundIntensity", overrideMaterial: "overrideMaterial", background: "background", environment: "environment" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThScene) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThScene, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-scene',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThScene) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], fog: [{
                type: Input
            }], backgroundBlurriness: [{
                type: Input
            }], backgroundIntensity: [{
                type: Input
            }], overrideMaterial: [{
                type: Input
            }], background: [{
                type: Input
            }], environment: [{
                type: Input
            }] } });

const RENDERER_DEFAULTS = {
    alpha: true,
    antialias: true,
    preserveDrawingBuffer: true
};
class ThEngineService {
    get canvas() {
        var _a;
        return (_a = this.rendererParameters) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    constructor(ngZone) {
        this.ngZone = ngZone;
        this.clock = new Clock();
        this.destroyed$ = new Subject();
        this.resizeEmitter = new EventEmitter();
        this.beforeRenderEmitter = new EventEmitter();
        this.views = [];
        this.beforeRender$ = this.beforeRenderEmitter.pipe(takeUntil(this.destroyed$));
        this.resize$ = this.resizeEmitter.pipe(takeUntil(this.destroyed$));
    }
    get renderer() {
        return this._renderer;
    }
    ngOnDestroy() {
        if (this.resizeObserver && this.canvas) {
            this.resizeObserver.unobserve(this.canvas);
        }
    }
    initResizeObserver() {
        // We have to run this outside angular zones,
        // because it could trigger heavy changeDetection cycles.
        this.ngZone.runOutsideAngular(() => {
            if (!this.canvas) {
                throw new Error('missing canvas element');
            }
            this.resize();
            if (!this.resizeObserver) {
                // @ts-ignore
                this.resizeObserver = new ResizeObserver(() => {
                    this.resize();
                });
            }
            this.resizeObserver.observe(this.canvas);
        });
    }
    initRenderer() {
        var _a;
        if (this._renderer) {
            return;
        }
        this._renderer = new THREE.WebGLRenderer(Object.assign({ canvas: (_a = this.rendererParameters) === null || _a === void 0 ? void 0 : _a.domElement }, RENDERER_DEFAULTS));
        Object.assign(this._renderer, Object.assign(Object.assign({}, RENDERER_DEFAULTS), this.rendererParameters));
        this.resize();
    }
    setRenderer(options) {
        this.rendererParameters = options;
        this.initRenderer();
        this.initResizeObserver();
    }
    addView(view) {
        this.views.push(view);
        const canvasDimensions = this.calcRendererSize();
        if (canvasDimensions) {
            this.adjustViewDimensions(view, canvasDimensions.width, canvasDimensions.height);
        }
    }
    render() {
        this.beforeRenderEmitter.emit({ engine: this, delta: this.clock.getDelta() });
        for (const view of this.views) {
            this.renderView(view);
        }
    }
    renderView(view) {
        if (!this._renderer) {
            return;
        }
        const camera = view.camera;
        const scene = view.scene;
        if (!camera || !scene || !camera.objRef || !scene.objRef) {
            return;
        }
        const renderer = this._renderer;
        if (isObserved(view.onRender)) {
            this.ngZone.run(() => view.onRender.emit({
                renderer,
                scene,
                camera
            }));
        }
        this.applyRendererParametersFromView(view);
        if (view.effectComposer) {
            view.effectComposer.render();
        }
        else {
            this._renderer.render(scene.objRef, camera.objRef);
        }
    }
    applyRendererParametersFromView(view) {
        if (!this._renderer) {
            return;
        }
        if (view.viewPort) {
            if (view.viewPort instanceof Vector4) {
                this._renderer.setViewport(view.viewPort);
            }
            else {
                this._renderer.setViewport(view.viewPort.x, view.viewPort.y, view.viewPort.width, view.viewPort.height);
            }
        }
        if (view.scissor) {
            if (view.scissor instanceof Vector4) {
                this._renderer.setScissor(view.scissor);
            }
            else {
                this._renderer.setScissor(view.scissor.x, view.scissor.y, view.scissor.width, view.scissor.height);
            }
        }
        if (view.scissorTest !== undefined) {
            this._renderer.setScissorTest(view.scissorTest);
        }
        if (view.clearColor) {
            this._renderer.setClearColor(view.clearColor);
        }
        if (view.clearAlpha !== undefined) {
            this._renderer.setClearAlpha(view.clearAlpha);
        }
        if (view.shadow !== undefined) {
            this._renderer.shadowMap.enabled = true;
        }
    }
    resize() {
        if (!this._renderer || !this.canvas) {
            return false;
        }
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        const { width, height } = this.calcRendererSize();
        this._renderer.setSize(width, height, false);
        for (const view of this.views) {
            this.adjustViewDimensions(view, width, height);
        }
        this.resizeEmitter.emit({ width, height });
        return true;
    }
    calcRendererSize() {
        var _a, _b;
        if (!this._renderer || !this.canvas) {
            return;
        }
        const pixelRatio = window.devicePixelRatio;
        return {
            width: ((_a = this.canvas.clientWidth) !== null && _a !== void 0 ? _a : 0) * pixelRatio,
            height: ((_b = this.canvas.clientHeight) !== null && _b !== void 0 ? _b : 0) * pixelRatio
        };
    }
    adjustViewDimensions(view, width, height) {
        var _a;
        if (!view.viewPort) {
            if (view.camera && view.camera.objRef.aspect) {
                view.camera.objRef.aspect = width / height;
                view.camera.objRef.updateProjectionMatrix();
            }
            (_a = view.effectComposer) === null || _a === void 0 ? void 0 : _a.setSize(width, height);
        }
    }
}
ThEngineService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEngineService, deps: [{ token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Injectable });
ThEngineService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEngineService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEngineService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.NgZone }]; } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThView {
    constructor(engServ, raycaster) {
        this.engServ = engServ;
        this.raycaster = raycaster;
        // -----------------------------------------------------------------------------------------------
        // eslint-disable-next-line @angular-eslint/no-output-on-prefix
        this.onRender = new EventEmitter();
    }
    set contentScene(scene) {
        if (scene) {
            this.scene = scene;
        }
    }
    set effectComposer(effectComposer) {
        this._effectComposer = effectComposer;
        this.configureEffectComposerRenderTarget();
    }
    get effectComposer() {
        return this._effectComposer;
    }
    set camera(camera) {
        this._camera = camera;
        this.initRaycaster();
    }
    get camera() {
        return this._camera;
    }
    set contentCamera(camera) {
        if (camera) {
            this.camera = camera;
        }
    }
    set viewPort(viewPort) {
        this._viewPort = viewPort;
        this.configureEffectComposerRenderTarget();
    }
    get viewPort() {
        return this._viewPort;
    }
    ngOnInit() {
        this.initRaycaster();
    }
    initRaycaster() {
        if (this.camera && this.engServ.canvas) {
            this.raycaster.init(this.camera, this.engServ.canvas);
        }
    }
    add(scene) {
        // nothing to do here
    }
    remove(scene) {
        // norhing to do
    }
    configureEffectComposerRenderTarget() {
        var _a;
        if (!this.viewPort || !this.effectComposer) {
            return;
        }
        else {
            let width;
            let height;
            if (this.viewPort instanceof Vector4) {
                width = this.viewPort.z;
                height = (_a = this.viewPort) === null || _a === void 0 ? void 0 : _a.width;
            }
            else {
                width = this.viewPort.width;
                height = this.viewPort.height;
            }
            //TODO: check if pixel ration ha
            this.effectComposer.setSize(width, height);
        }
    }
}
ThView.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThView, deps: [{ token: ThEngineService }, { token: RaycasterService }], target: i0.ɵɵFactoryTarget.Component });
ThView.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThView, selector: "th-view", inputs: { scene: "scene", effectComposer: "effectComposer", camera: "camera", shadow: "shadow", viewPort: "viewPort", scissor: "scissor", scissorTest: "scissorTest", clearColor: "clearColor", clearAlpha: "clearAlpha" }, outputs: { onRender: "onRender" }, providers: [
        { provide: ThObject3D, useExisting: forwardRef(() => ThView) },
        { provide: RAYCASTER, useValue: new Raycaster() },
        RaycasterService
    ], queries: [{ propertyName: "contentScene", first: true, predicate: ThScene, descendants: true }, { propertyName: "contentCamera", first: true, predicate: ThCamera, descendants: true }], ngImport: i0, template: '<ng-content/>', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThView, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-view',
                    template: '<ng-content/>',
                    providers: [
                        { provide: ThObject3D, useExisting: forwardRef(() => ThView) },
                        { provide: RAYCASTER, useValue: new Raycaster() },
                        RaycasterService
                    ]
                }]
        }], ctorParameters: function () { return [{ type: ThEngineService }, { type: RaycasterService }]; }, propDecorators: { scene: [{
                type: Input
            }], contentScene: [{
                type: ContentChild,
                args: [ThScene]
            }], effectComposer: [{
                type: Input
            }], camera: [{
                type: Input
            }], contentCamera: [{
                type: ContentChild,
                args: [ThCamera]
            }], shadow: [{
                type: Input
            }], viewPort: [{
                type: Input
            }], scissor: [{
                type: Input
            }], scissorTest: [{
                type: Input
            }], clearColor: [{
                type: Input
            }], clearAlpha: [{
                type: Input
            }], onRender: [{
                type: Output
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThEffectComposer extends ThEffectComposerGen {
    constructor(view, engineService) {
        super();
        this.view = view;
        this.engineService = engineService;
    }
    createThreeInstance(args) {
        var _a, _b;
        if (!args) {
            args = new Array(5);
        }
        args[0] = (_a = args[0]) !== null && _a !== void 0 ? _a : this.engineService.renderer;
        args[1] = (_b = args[1]) !== null && _b !== void 0 ? _b : this.initRenderTarget();
        return super.createThreeInstance(args);
    }
    initRenderTarget() {
        var _a;
        if (!this.view.viewPort) {
            return;
        }
        else {
            let width;
            let height;
            if (this.view.viewPort instanceof Vector4) {
                width = this.view.viewPort.z;
                height = (_a = this.view.viewPort) === null || _a === void 0 ? void 0 : _a.width;
            }
            else {
                width = this.view.viewPort.width;
                height = this.view.viewPort.height;
            }
            return new WebGLRenderTarget(width, height);
        }
    }
    addToParent() {
        if (this._objRef) {
            this.view.effectComposer = this._objRef;
        }
    }
    removeFromParent() {
        this.view.effectComposer = undefined;
    }
}
ThEffectComposer.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEffectComposer, deps: [{ token: ThView }, { token: ThEngineService }], target: i0.ɵɵFactoryTarget.Component });
ThEffectComposer.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThEffectComposer, selector: "th-effectComposer", providers: [], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEffectComposer, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-effectComposer',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: []
                }]
        }], ctorParameters: function () { return [{ type: ThView }, { type: ThEngineService }]; } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThPassBase extends ThWrapperBase {
    constructor(effectComposer) {
        super();
        this.effectComposer = effectComposer;
    }
    addToParent() {
        if (this._objRef && this.effectComposer && this.effectComposer.objRef) {
            this.effectComposer.objRef.addPass(this._objRef);
        }
    }
    removeFromParent() {
        if (this._objRef && this.effectComposer && this.effectComposer.objRef) {
            this.effectComposer.objRef.removePass(this._objRef);
        }
    }
}
ThPassBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPassBase, deps: [{ token: ThEffectComposer, optional: true }], target: i0.ɵɵFactoryTarget.Component });
ThPassBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPassBase, selector: "th-abs-control", usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPassBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-control',
                    template: ''
                }]
        }], ctorParameters: function () {
        return [{ type: ThEffectComposer, decorators: [{
                        type: Optional
                    }] }];
    } });

/* eslint-disable @typescript-eslint/ban-types */
class ThPass extends ThPassBase {
    getType() {
        return Pass;
    }
    set isPass(value) {
        if (this._objRef) {
            this._objRef.isPass = value;
        }
    }
    // @ts-ignore
    get isPass() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isPass;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set needsSwap(value) {
        if (this._objRef) {
            this._objRef.needsSwap = value;
        }
    }
    // @ts-ignore
    get needsSwap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.needsSwap;
    }
    set clear(value) {
        if (this._objRef) {
            this._objRef.clear = value;
        }
    }
    // @ts-ignore
    get clear() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clear;
    }
    set renderToScreen(value) {
        if (this._objRef) {
            this._objRef.renderToScreen = value;
        }
    }
    // @ts-ignore
    get renderToScreen() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderToScreen;
    }
}
ThPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPass, selector: "th-pass", inputs: { isPass: "isPass", enabled: "enabled", needsSwap: "needsSwap", clear: "clear", renderToScreen: "renderToScreen" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-pass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThPass) }]
                }]
        }], propDecorators: { isPass: [{
                type: Input
            }], enabled: [{
                type: Input
            }], needsSwap: [{
                type: Input
            }], clear: [{
                type: Input
            }], renderToScreen: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThRenderPassGen extends ThPass {
    getType() {
        return RenderPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set overrideMaterial(value) {
        if (this._objRef) {
            this._objRef.overrideMaterial = value;
        }
    }
    // @ts-ignore
    get overrideMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.overrideMaterial;
    }
    set clearColor(value) {
        if (this._objRef) {
            this._objRef.clearColor = applyValue(this._objRef.clearColor, value);
        }
    }
    // @ts-ignore
    get clearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearColor;
    }
    set clearAlpha(value) {
        if (this._objRef) {
            this._objRef.clearAlpha = value;
        }
    }
    // @ts-ignore
    get clearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearAlpha;
    }
    set clearDepth(value) {
        if (this._objRef) {
            this._objRef.clearDepth = value;
        }
    }
    // @ts-ignore
    get clearDepth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearDepth;
    }
}
ThRenderPassGen.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderPassGen, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThRenderPassGen.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRenderPassGen, selector: "th-renderPassGen", inputs: { scene: "scene", camera: "camera", overrideMaterial: "overrideMaterial", clearColor: "clearColor", clearAlpha: "clearAlpha", clearDepth: "clearDepth" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThRenderPassGen) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderPassGen, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-renderPassGen',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThRenderPassGen) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], overrideMaterial: [{
                type: Input
            }], clearColor: [{
                type: Input
            }], clearAlpha: [{
                type: Input
            }], clearDepth: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThRenderPass extends ThRenderPassGen {
    constructor(effectComposer, view) {
        super(effectComposer);
        this.effectComposer = effectComposer;
        this.view = view;
    }
    createThreeInstance(args) {
        var _a, _b, _c, _d, _e;
        if (!args) {
            args = new Array(5);
        }
        args[0] = (_a = args[0]) !== null && _a !== void 0 ? _a : this.view.scene;
        args[1] = (_b = args[1]) !== null && _b !== void 0 ? _b : this.view.camera;
        args[2] = (_c = args[2]) !== null && _c !== void 0 ? _c : this.overrideMaterial;
        args[3] = (_d = args[3]) !== null && _d !== void 0 ? _d : this.clearColor;
        args[4] = (_e = args[4]) !== null && _e !== void 0 ? _e : this.clearAlpha;
        return super.createThreeInstance(args);
    }
    ngAfterContentChecked() {
        if (!this._objRef) {
            return;
        }
        if (this.view.scene && this.view.scene.objRef) {
            this._objRef.scene = this.view.scene.objRef;
        }
        if (this.view.camera && this.view.camera.objRef) {
            this._objRef.camera = this.view.camera.objRef;
        }
    }
}
ThRenderPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderPass, deps: [{ token: ThEffectComposer }, { token: ThView }], target: i0.ɵɵFactoryTarget.Component });
ThRenderPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRenderPass, selector: "th-renderPass", providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThRenderPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-renderPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThRenderPass) }]
                }]
        }], ctorParameters: function () { return [{ type: ThEffectComposer }, { type: ThView }]; } });

class ThAnimationLoopService {
    constructor(engineService, ngZone) {
        this.engineService = engineService;
        this.ngZone = ngZone;
        this.active = true;
        this.destroyed$ = new Subject();
        this.beforeRender$ = this.engineService.beforeRender$;
        this.engineService.resize$.pipe(takeUntil(this.destroyed$)).subscribe(() => this.requestAnimationFrame());
    }
    ngOnDestroy() {
        this.stop();
        this.destroyed$.next();
        this.destroyed$.complete();
    }
    /**
     * start the loop
     */
    start() {
        if (!this.active) {
            this.active = true;
            this.requestAnimationFrame();
        }
    }
    /**
     * stop the loop
     */
    stop() {
        this.active = false;
        if (this.frameId !== undefined) {
            cancelAnimationFrame(this.frameId);
            this.frameId = undefined;
        }
    }
    /**
     *
     * @returns true if the render loop is active
     */
    isActive() {
        return this.active;
    }
    /**
     * trigger an animation frame request
     */
    requestAnimationFrame() {
        if (this.frameId === undefined) {
            this.ngZone.runOutsideAngular(() => (this.frameId = requestAnimationFrame(() => {
                this.frameId = undefined;
                this.engineService.render();
                if (this.active) {
                    this.requestAnimationFrame();
                }
            })));
        }
    }
}
ThAnimationLoopService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAnimationLoopService, deps: [{ token: ThEngineService }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Injectable });
ThAnimationLoopService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAnimationLoopService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAnimationLoopService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: ThEngineService }, { type: i0.NgZone }]; } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThCanvas extends ThView {
    get obj() {
        return this;
    }
    set views(viewList) {
        viewList.forEach((v) => this.engServ.addView(v));
    }
    set rendererCanvas(canvas) {
        if (!canvas) {
            return;
        }
        this._rendererCanvas = canvas;
        canvas.nativeElement.id += this.nid;
    }
    get rendererCanvas() {
        return this._rendererCanvas;
    }
    constructor(engServ, animationLoop, raycaster) {
        super(engServ, raycaster);
        this.engServ = engServ;
        this.animationLoop = animationLoop;
        this.raycaster = raycaster;
        this.isDevMode = isDevMode;
        this.nid = ThCanvas.instanceCnt++;
        /**
         * if true does not use the ThCanvas as view
         * this is esepcially usefull if you have multiple views
         * and want to iterate over all of them with *ngFor
         * use statically (before ngOnInit is triggered)
         */
        this.disableDefaultView = false;
    }
    ngAfterContentChecked() {
        this.animationLoop.requestAnimationFrame();
    }
    ngAfterViewInit() {
        this.animationLoop.requestAnimationFrame();
    }
    ngOnInit() {
        this.applyRendererParameters();
        super.ngOnInit();
        if (!this.disableDefaultView) {
            this.engServ.addView(this);
        }
    }
    applyRendererParameters() {
        if (!this.rendererCanvas) {
            throw new Error('Missing Canvas');
        }
        this.engServ.setRenderer(Object.assign(Object.assign({}, this.rendererParameters), { domElement: this.rendererCanvas.nativeElement }));
    }
}
ThCanvas.instanceCnt = 0;
ThCanvas.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCanvas, deps: [{ token: ThEngineService }, { token: ThAnimationLoopService }, { token: forwardRef(() => RaycasterService) }], target: i0.ɵɵFactoryTarget.Component });
ThCanvas.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCanvas, selector: "th-canvas", inputs: { rendererParameters: "rendererParameters", disableDefaultView: "disableDefaultView" }, providers: [
        { provide: ThObject3D, useExisting: forwardRef(() => ThCanvas) },
        ThEngineService,
        ThAnimationLoopService,
        { provide: RAYCASTER, useValue: new Raycaster() },
        forwardRef(() => RaycasterService),
        { provide: ThView, useExisting: forwardRef(() => ThCanvas) }
    ], queries: [{ propertyName: "views", predicate: ThView }], viewQueries: [{ propertyName: "rendererCanvas", first: true, predicate: ["rendererCanvas"], descendants: true, static: true }], usesInheritance: true, ngImport: i0, template: '<canvas #rendererCanvas id="rendererCanvas"><ng-content *ngIf="isDevMode()" ></ng-content></canvas>', isInline: true, styles: [":host{display:flex;flex:auto;line-height:0;height:100%}canvas{flex:auto;outline:none;width:100%;height:100%}\n"], dependencies: [{ kind: "directive", type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCanvas, decorators: [{
            type: Component,
            args: [{ selector: 'th-canvas', template: '<canvas #rendererCanvas id="rendererCanvas"><ng-content *ngIf="isDevMode()" ></ng-content></canvas>', changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        { provide: ThObject3D, useExisting: forwardRef(() => ThCanvas) },
                        ThEngineService,
                        ThAnimationLoopService,
                        { provide: RAYCASTER, useValue: new Raycaster() },
                        forwardRef(() => RaycasterService),
                        { provide: ThView, useExisting: forwardRef(() => ThCanvas) }
                    ], styles: [":host{display:flex;flex:auto;line-height:0;height:100%}canvas{flex:auto;outline:none;width:100%;height:100%}\n"] }]
        }], ctorParameters: function () {
        return [{ type: ThEngineService }, { type: ThAnimationLoopService }, { type: RaycasterService, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => RaycasterService)]
                    }] }];
    }, propDecorators: { rendererParameters: [{
                type: Input
            }], disableDefaultView: [{
                type: Input
            }], views: [{
                type: ContentChildren,
                args: [ThView]
            }], rendererCanvas: [{
                type: ViewChild,
                args: ['rendererCanvas', { static: true }]
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThControlBase extends ThWrapperBase {
    constructor(_camera, canvas) {
        super();
        this._camera = _camera;
        this.canvas = canvas;
        this.renderLoop = inject(ThAnimationLoopService);
    }
    createThreeInstance(args) {
        var _a, _b;
        if (!args) {
            args = [this._camera.objRef, (_b = (_a = this.canvas) === null || _a === void 0 ? void 0 : _a.rendererCanvas) === null || _b === void 0 ? void 0 : _b.nativeElement];
        }
        const instance = super.createThreeInstance(args);
        this.patchDispatchEvent(instance);
        this.subscribeControlUpdater(instance);
        return instance;
    }
    patchDispatchEvent(dispatcher) {
        if (dispatcher.dispatchEvent) {
            const origMethod = (this.origDispatchEventMethod = dispatcher.dispatchEvent);
            dispatcher.dispatchEvent = (event) => {
                origMethod.call(dispatcher, event);
                // request an animation frame after an event was emitted;
                this.renderLoop.requestAnimationFrame();
            };
        }
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.unpatchDispatchEvent();
        this.unsubscribeControlUpdater();
    }
    unpatchDispatchEvent() {
        if (this.origDispatchEventMethod && this._objRef) {
            this._objRef.dispatchEvent = this.origDispatchEventMethod;
        }
    }
    subscribeControlUpdater(control) {
        if (control.update !== undefined) {
            this.beforeRenderSubscription = this.renderLoop.beforeRender$.subscribe((state) => {
                control.update(state.delta);
            });
        }
    }
    unsubscribeControlUpdater() {
        if (this.beforeRenderSubscription) {
            this.beforeRenderSubscription.unsubscribe();
        }
    }
}
ThControlBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThControlBase, deps: [{ token: ThObject3D }, { token: ThCanvas }], target: i0.ɵɵFactoryTarget.Component });
ThControlBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThControlBase, selector: "th-abs-control", usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThControlBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-control',
                    template: ''
                }]
        }], ctorParameters: function () { return [{ type: ThObject3D }, { type: ThCanvas }]; } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTransformControlsGen extends ThControlBase {
    getType() {
        return TransformControls;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set axis(value) {
        if (this._objRef) {
            this._objRef.axis = value;
        }
    }
    // @ts-ignore
    get axis() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.axis;
    }
    set mode(value) {
        if (this._objRef) {
            this._objRef.mode = value;
        }
    }
    // @ts-ignore
    get mode() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mode;
    }
    set translationSnap(value) {
        if (this._objRef) {
            this._objRef.translationSnap = value;
        }
    }
    // @ts-ignore
    get translationSnap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.translationSnap;
    }
    set rotationSnap(value) {
        if (this._objRef) {
            this._objRef.rotationSnap = value;
        }
    }
    // @ts-ignore
    get rotationSnap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotationSnap;
    }
    set space(value) {
        if (this._objRef) {
            this._objRef.space = value;
        }
    }
    // @ts-ignore
    get space() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.space;
    }
    set size(value) {
        if (this._objRef) {
            this._objRef.size = value;
        }
    }
    // @ts-ignore
    get size() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.size;
    }
    set dragging(value) {
        if (this._objRef) {
            this._objRef.dragging = value;
        }
    }
    // @ts-ignore
    get dragging() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dragging;
    }
    set showX(value) {
        if (this._objRef) {
            this._objRef.showX = value;
        }
    }
    // @ts-ignore
    get showX() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.showX;
    }
    set showY(value) {
        if (this._objRef) {
            this._objRef.showY = value;
        }
    }
    // @ts-ignore
    get showY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.showY;
    }
    set showZ(value) {
        if (this._objRef) {
            this._objRef.showZ = value;
        }
    }
    // @ts-ignore
    get showZ() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.showZ;
    }
    // @ts-ignore
    get isTransformControls() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isTransformControls;
    }
    set mouseButtons(value) {
        if (this._objRef) {
            this._objRef.mouseButtons = value;
        }
    }
    // @ts-ignore
    get mouseButtons() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mouseButtons;
    }
}
ThTransformControlsGen.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTransformControlsGen, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTransformControlsGen.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTransformControlsGen, selector: "th-transformControlsGen", inputs: { domElement: "domElement", camera: "camera", object: "object", enabled: "enabled", axis: "axis", mode: "mode", translationSnap: "translationSnap", rotationSnap: "rotationSnap", space: "space", size: "size", dragging: "dragging", showX: "showX", showY: "showY", showZ: "showZ", mouseButtons: "mouseButtons" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThTransformControlsGen)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTransformControlsGen, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-transformControlsGen',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThTransformControlsGen)
                        }
                    ]
                }]
        }], propDecorators: { domElement: [{
                type: Input
            }], camera: [{
                type: Input
            }], object: [{
                type: Input
            }], enabled: [{
                type: Input
            }], axis: [{
                type: Input
            }], mode: [{
                type: Input
            }], translationSnap: [{
                type: Input
            }], rotationSnap: [{
                type: Input
            }], space: [{
                type: Input
            }], size: [{
                type: Input
            }], dragging: [{
                type: Input
            }], showX: [{
                type: Input
            }], showY: [{
                type: Input
            }], showZ: [{
                type: Input
            }], mouseButtons: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTransformControls extends ThTransformControlsGen {
    getType() {
        return TransformControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
            if (value) {
                this._objRef.attach(value);
            }
            else {
                this._objRef.detach();
            }
        }
    }
    addToParent() {
        var _a, _b, _c;
        if (this._objRef) {
            (_c = (_b = (_a = this.canvas) === null || _a === void 0 ? void 0 : _a.scene) === null || _b === void 0 ? void 0 : _b.objRef) === null || _c === void 0 ? void 0 : _c.add(this._objRef);
        }
    }
    removeFromParent() {
        var _a, _b, _c;
        if (this._objRef) {
            (_c = (_b = (_a = this.canvas) === null || _a === void 0 ? void 0 : _a.scene) === null || _b === void 0 ? void 0 : _b.objRef) === null || _c === void 0 ? void 0 : _c.remove(this._objRef);
        }
    }
}
ThTransformControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTransformControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTransformControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTransformControls, selector: "th-transformControls", inputs: { object: "object" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThTransformControls)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTransformControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-transformControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThTransformControls)
                        }
                    ]
                }]
        }], propDecorators: { object: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThAdaptiveToneMappingPass extends ThPass {
    getType() {
        return AdaptiveToneMappingPass;
    }
    set adaptive(value) {
        if (this._objRef) {
            this._objRef.adaptive = value;
        }
    }
    // @ts-ignore
    get adaptive() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.adaptive;
    }
    set resolution(value) {
        if (this._objRef) {
            this._objRef.resolution = value;
        }
    }
    // @ts-ignore
    get resolution() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.resolution;
    }
    set needsInit(value) {
        if (this._objRef) {
            this._objRef.needsInit = value;
        }
    }
    // @ts-ignore
    get needsInit() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.needsInit;
    }
    set luminanceRT(value) {
        if (this._objRef) {
            this._objRef.luminanceRT = value;
        }
    }
    // @ts-ignore
    get luminanceRT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.luminanceRT;
    }
    set previousLuminanceRT(value) {
        if (this._objRef) {
            this._objRef.previousLuminanceRT = value;
        }
    }
    // @ts-ignore
    get previousLuminanceRT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.previousLuminanceRT;
    }
    set currentLuminanceRT(value) {
        if (this._objRef) {
            this._objRef.currentLuminanceRT = value;
        }
    }
    // @ts-ignore
    get currentLuminanceRT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.currentLuminanceRT;
    }
    set copyUniforms(value) {
        if (this._objRef) {
            this._objRef.copyUniforms = value;
        }
    }
    // @ts-ignore
    get copyUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyUniforms;
    }
    set materialCopy(value) {
        if (this._objRef) {
            this._objRef.materialCopy = value;
        }
    }
    // @ts-ignore
    get materialCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialCopy;
    }
    set materialLuminance(value) {
        if (this._objRef) {
            this._objRef.materialLuminance = value;
        }
    }
    // @ts-ignore
    get materialLuminance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialLuminance;
    }
    set adaptLuminanceShader(value) {
        if (this._objRef) {
            this._objRef.adaptLuminanceShader = value;
        }
    }
    // @ts-ignore
    get adaptLuminanceShader() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.adaptLuminanceShader;
    }
    set materialAdaptiveLum(value) {
        if (this._objRef) {
            this._objRef.materialAdaptiveLum = value;
        }
    }
    // @ts-ignore
    get materialAdaptiveLum() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialAdaptiveLum;
    }
    set materialToneMap(value) {
        if (this._objRef) {
            this._objRef.materialToneMap = value;
        }
    }
    // @ts-ignore
    get materialToneMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialToneMap;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThAdaptiveToneMappingPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAdaptiveToneMappingPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAdaptiveToneMappingPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAdaptiveToneMappingPass, selector: "th-adaptiveToneMappingPass", inputs: { adaptive: "adaptive", resolution: "resolution", needsInit: "needsInit", luminanceRT: "luminanceRT", previousLuminanceRT: "previousLuminanceRT", currentLuminanceRT: "currentLuminanceRT", copyUniforms: "copyUniforms", materialCopy: "materialCopy", materialLuminance: "materialLuminance", adaptLuminanceShader: "adaptLuminanceShader", materialAdaptiveLum: "materialAdaptiveLum", materialToneMap: "materialToneMap", fsQuad: "fsQuad" }, providers: [
        {
            provide: ThPassBase,
            useExisting: forwardRef(() => ThAdaptiveToneMappingPass)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAdaptiveToneMappingPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-adaptiveToneMappingPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThPassBase,
                            useExisting: forwardRef(() => ThAdaptiveToneMappingPass)
                        }
                    ]
                }]
        }], propDecorators: { adaptive: [{
                type: Input
            }], resolution: [{
                type: Input
            }], needsInit: [{
                type: Input
            }], luminanceRT: [{
                type: Input
            }], previousLuminanceRT: [{
                type: Input
            }], currentLuminanceRT: [{
                type: Input
            }], copyUniforms: [{
                type: Input
            }], materialCopy: [{
                type: Input
            }], materialLuminance: [{
                type: Input
            }], adaptLuminanceShader: [{
                type: Input
            }], materialAdaptiveLum: [{
                type: Input
            }], materialToneMap: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThAfterimagePass extends ThPass {
    getType() {
        return AfterimagePass;
    }
    set shader(value) {
        if (this._objRef) {
            this._objRef.shader = value;
        }
    }
    // @ts-ignore
    get shader() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shader;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set textureComp(value) {
        if (this._objRef) {
            this._objRef.textureComp = value;
        }
    }
    // @ts-ignore
    get textureComp() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.textureComp;
    }
    set textureOld(value) {
        if (this._objRef) {
            this._objRef.textureOld = value;
        }
    }
    // @ts-ignore
    get textureOld() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.textureOld;
    }
    set shaderMaterial(value) {
        if (this._objRef) {
            this._objRef.shaderMaterial = value;
        }
    }
    // @ts-ignore
    get shaderMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shaderMaterial;
    }
    set compFsQuad(value) {
        if (this._objRef) {
            this._objRef.compFsQuad = value;
        }
    }
    // @ts-ignore
    get compFsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.compFsQuad;
    }
    set copyFsQuad(value) {
        if (this._objRef) {
            this._objRef.copyFsQuad = value;
        }
    }
    // @ts-ignore
    get copyFsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyFsQuad;
    }
}
ThAfterimagePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAfterimagePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAfterimagePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAfterimagePass, selector: "th-afterimagePass", inputs: { shader: "shader", uniforms: "uniforms", textureComp: "textureComp", textureOld: "textureOld", shaderMaterial: "shaderMaterial", compFsQuad: "compFsQuad", copyFsQuad: "copyFsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThAfterimagePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAfterimagePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-afterimagePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThAfterimagePass) }]
                }]
        }], propDecorators: { shader: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], textureComp: [{
                type: Input
            }], textureOld: [{
                type: Input
            }], shaderMaterial: [{
                type: Input
            }], compFsQuad: [{
                type: Input
            }], copyFsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLight extends ThObject3D {
    // @ts-ignore
    get isLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set intensity(value) {
        if (this._objRef) {
            this._objRef.intensity = value;
        }
    }
    // @ts-ignore
    get intensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.intensity;
    }
    set shadow(value) {
        if (this._objRef) {
            this._objRef.shadow = value;
        }
    }
    // @ts-ignore
    get shadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shadow;
    }
}
ThLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLight, selector: "th-light", inputs: { color: "color", intensity: "intensity", shadow: "shadow" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-light',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLight) }]
                }]
        }], propDecorators: { color: [{
                type: Input
            }], intensity: [{
                type: Input
            }], shadow: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThAmbientLight extends ThLight {
    getType() {
        return AmbientLight;
    }
    // @ts-ignore
    get isAmbientLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isAmbientLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThAmbientLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAmbientLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAmbientLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAmbientLight, selector: "th-ambientLight", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAmbientLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAmbientLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-ambientLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAmbientLight) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLightProbe extends ThLight {
    getType() {
        return LightProbe;
    }
    // @ts-ignore
    get isLightProbe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLightProbe;
    }
    set sh(value) {
        if (this._objRef) {
            this._objRef.sh = applyValue(this._objRef.sh, value);
        }
    }
    // @ts-ignore
    get sh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sh;
    }
}
ThLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLightProbe, selector: "th-lightProbe", inputs: { sh: "sh" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLightProbe) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lightProbe',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLightProbe) }]
                }]
        }], propDecorators: { sh: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThAmbientLightProbe extends ThLightProbe {
    getType() {
        return AmbientLightProbe;
    }
    // @ts-ignore
    get isAmbientLightProbe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isAmbientLightProbe;
    }
}
ThAmbientLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAmbientLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAmbientLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAmbientLightProbe, selector: "th-ambientLightProbe", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAmbientLightProbe) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAmbientLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-ambientLightProbe',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAmbientLightProbe) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThArcballControls extends ThControlBase {
    getType() {
        return ArcballControls;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set focusAnimationTime(value) {
        if (this._objRef) {
            this._objRef.focusAnimationTime = value;
        }
    }
    // @ts-ignore
    get focusAnimationTime() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.focusAnimationTime;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set enablePan(value) {
        if (this._objRef) {
            this._objRef.enablePan = value;
        }
    }
    // @ts-ignore
    get enablePan() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enablePan;
    }
    set enableRotate(value) {
        if (this._objRef) {
            this._objRef.enableRotate = value;
        }
    }
    // @ts-ignore
    get enableRotate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableRotate;
    }
    set enableZoom(value) {
        if (this._objRef) {
            this._objRef.enableZoom = value;
        }
    }
    // @ts-ignore
    get enableZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableZoom;
    }
    set enableGizmos(value) {
        if (this._objRef) {
            this._objRef.enableGizmos = value;
        }
    }
    // @ts-ignore
    get enableGizmos() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableGizmos;
    }
    set adjustNearFar(value) {
        if (this._objRef) {
            this._objRef.adjustNearFar = value;
        }
    }
    // @ts-ignore
    get adjustNearFar() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.adjustNearFar;
    }
    set scaleFactor(value) {
        if (this._objRef) {
            this._objRef.scaleFactor = value;
        }
    }
    // @ts-ignore
    get scaleFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scaleFactor;
    }
    set dampingFactor(value) {
        if (this._objRef) {
            this._objRef.dampingFactor = value;
        }
    }
    // @ts-ignore
    get dampingFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dampingFactor;
    }
    set wMax(value) {
        if (this._objRef) {
            this._objRef.wMax = value;
        }
    }
    // @ts-ignore
    get wMax() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wMax;
    }
    set enableAnimations(value) {
        if (this._objRef) {
            this._objRef.enableAnimations = value;
        }
    }
    // @ts-ignore
    get enableAnimations() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableAnimations;
    }
    set enableGrid(value) {
        if (this._objRef) {
            this._objRef.enableGrid = value;
        }
    }
    // @ts-ignore
    get enableGrid() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableGrid;
    }
    set cursorZoom(value) {
        if (this._objRef) {
            this._objRef.cursorZoom = value;
        }
    }
    // @ts-ignore
    get cursorZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cursorZoom;
    }
    set minFov(value) {
        if (this._objRef) {
            this._objRef.minFov = value;
        }
    }
    // @ts-ignore
    get minFov() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFov;
    }
    set maxFov(value) {
        if (this._objRef) {
            this._objRef.maxFov = value;
        }
    }
    // @ts-ignore
    get maxFov() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxFov;
    }
    set minDistance(value) {
        if (this._objRef) {
            this._objRef.minDistance = value;
        }
    }
    // @ts-ignore
    get minDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minDistance;
    }
    set maxDistance(value) {
        if (this._objRef) {
            this._objRef.maxDistance = value;
        }
    }
    // @ts-ignore
    get maxDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxDistance;
    }
    set minZoom(value) {
        if (this._objRef) {
            this._objRef.minZoom = value;
        }
    }
    // @ts-ignore
    get minZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minZoom;
    }
    set maxZoom(value) {
        if (this._objRef) {
            this._objRef.maxZoom = value;
        }
    }
    // @ts-ignore
    get maxZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxZoom;
    }
    set target(value) {
        if (this._objRef) {
            this._objRef.target = applyValue(this._objRef.target, value);
        }
    }
    // @ts-ignore
    get target() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target;
    }
    set radiusFactor(value) {
        if (this._objRef) {
            this._objRef.radiusFactor = value;
        }
    }
    // @ts-ignore
    get radiusFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.radiusFactor;
    }
}
ThArcballControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArcballControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThArcballControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThArcballControls, selector: "th-arcballControls", inputs: { camera: "camera", domElement: "domElement", scene: "scene", focusAnimationTime: "focusAnimationTime", enabled: "enabled", enablePan: "enablePan", enableRotate: "enableRotate", enableZoom: "enableZoom", enableGizmos: "enableGizmos", adjustNearFar: "adjustNearFar", scaleFactor: "scaleFactor", dampingFactor: "dampingFactor", wMax: "wMax", enableAnimations: "enableAnimations", enableGrid: "enableGrid", cursorZoom: "cursorZoom", minFov: "minFov", maxFov: "maxFov", minDistance: "minDistance", maxDistance: "maxDistance", minZoom: "minZoom", maxZoom: "maxZoom", target: "target", radiusFactor: "radiusFactor" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThArcballControls)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArcballControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-arcballControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThArcballControls)
                        }
                    ]
                }]
        }], propDecorators: { camera: [{
                type: Input
            }], domElement: [{
                type: Input
            }], scene: [{
                type: Input
            }], focusAnimationTime: [{
                type: Input
            }], enabled: [{
                type: Input
            }], enablePan: [{
                type: Input
            }], enableRotate: [{
                type: Input
            }], enableZoom: [{
                type: Input
            }], enableGizmos: [{
                type: Input
            }], adjustNearFar: [{
                type: Input
            }], scaleFactor: [{
                type: Input
            }], dampingFactor: [{
                type: Input
            }], wMax: [{
                type: Input
            }], enableAnimations: [{
                type: Input
            }], enableGrid: [{
                type: Input
            }], cursorZoom: [{
                type: Input
            }], minFov: [{
                type: Input
            }], maxFov: [{
                type: Input
            }], minDistance: [{
                type: Input
            }], maxDistance: [{
                type: Input
            }], minZoom: [{
                type: Input
            }], maxZoom: [{
                type: Input
            }], target: [{
                type: Input
            }], radiusFactor: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPerspectiveCamera extends ThCamera {
    getType() {
        return PerspectiveCamera;
    }
    // @ts-ignore
    get isPerspectiveCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isPerspectiveCamera;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set zoom(value) {
        if (this._objRef) {
            this._objRef.zoom = value;
        }
    }
    // @ts-ignore
    get zoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.zoom;
    }
    set fov(value) {
        if (this._objRef) {
            this._objRef.fov = value;
        }
    }
    // @ts-ignore
    get fov() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fov;
    }
    set aspect(value) {
        if (this._objRef) {
            this._objRef.aspect = value;
        }
    }
    // @ts-ignore
    get aspect() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aspect;
    }
    set near(value) {
        if (this._objRef) {
            this._objRef.near = value;
        }
    }
    // @ts-ignore
    get near() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.near;
    }
    set far(value) {
        if (this._objRef) {
            this._objRef.far = value;
        }
    }
    // @ts-ignore
    get far() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.far;
    }
    set focus(value) {
        if (this._objRef) {
            this._objRef.focus = value;
        }
    }
    // @ts-ignore
    get focus() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.focus;
    }
    set view(value) {
        if (this._objRef) {
            this._objRef.view = value;
        }
    }
    // @ts-ignore
    get view() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.view;
    }
    set filmGauge(value) {
        if (this._objRef) {
            this._objRef.filmGauge = value;
        }
    }
    // @ts-ignore
    get filmGauge() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.filmGauge;
    }
    set filmOffset(value) {
        if (this._objRef) {
            this._objRef.filmOffset = value;
        }
    }
    // @ts-ignore
    get filmOffset() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.filmOffset;
    }
}
ThPerspectiveCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPerspectiveCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPerspectiveCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPerspectiveCamera, selector: "th-perspectiveCamera", inputs: { zoom: "zoom", fov: "fov", aspect: "aspect", near: "near", far: "far", focus: "focus", view: "view", filmGauge: "filmGauge", filmOffset: "filmOffset" }, providers: [
        { provide: ThObject3D, useExisting: forwardRef(() => ThPerspectiveCamera) },
        { provide: ThCamera, useExisting: forwardRef(() => ThPerspectiveCamera) }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPerspectiveCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-perspectiveCamera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: ThObject3D, useExisting: forwardRef(() => ThPerspectiveCamera) },
                        { provide: ThCamera, useExisting: forwardRef(() => ThPerspectiveCamera) }
                    ]
                }]
        }], propDecorators: { zoom: [{
                type: Input
            }], fov: [{
                type: Input
            }], aspect: [{
                type: Input
            }], near: [{
                type: Input
            }], far: [{
                type: Input
            }], focus: [{
                type: Input
            }], view: [{
                type: Input
            }], filmGauge: [{
                type: Input
            }], filmOffset: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThArrayCamera extends ThPerspectiveCamera {
    getType() {
        return ArrayCamera;
    }
    // @ts-ignore
    get isArrayCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isArrayCamera;
    }
    set cameras(value) {
        if (this._objRef) {
            this._objRef.cameras = value;
        }
    }
    // @ts-ignore
    get cameras() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cameras;
    }
}
ThArrayCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArrayCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThArrayCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThArrayCamera, selector: "th-arrayCamera", inputs: { cameras: "cameras" }, providers: [
        { provide: ThObject3D, useExisting: forwardRef(() => ThArrayCamera) },
        { provide: ThCamera, useExisting: forwardRef(() => ThArrayCamera) }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArrayCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-arrayCamera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: ThObject3D, useExisting: forwardRef(() => ThArrayCamera) },
                        { provide: ThCamera, useExisting: forwardRef(() => ThArrayCamera) }
                    ]
                }]
        }], propDecorators: { cameras: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThArrowHelper extends ThObject3D {
    getType() {
        return ArrowHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set line(value) {
        if (this._objRef) {
            this._objRef.line = value;
        }
    }
    // @ts-ignore
    get line() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.line;
    }
    set cone(value) {
        if (this._objRef) {
            this._objRef.cone = value;
        }
    }
    // @ts-ignore
    get cone() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cone;
    }
}
ThArrowHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArrowHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThArrowHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThArrowHelper, selector: "th-arrowHelper", inputs: { line: "line", cone: "cone" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThArrowHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThArrowHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-arrowHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThArrowHelper) }]
                }]
        }], propDecorators: { line: [{
                type: Input
            }], cone: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThAudio extends ThObject3D {
    getType() {
        return Audio;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set listener(value) {
        if (this._objRef) {
            this._objRef.listener = value;
        }
    }
    // @ts-ignore
    get listener() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.listener;
    }
    set context(value) {
        if (this._objRef) {
            this._objRef.context = value;
        }
    }
    // @ts-ignore
    get context() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.context;
    }
    set gain(value) {
        if (this._objRef) {
            this._objRef.gain = value;
        }
    }
    // @ts-ignore
    get gain() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.gain;
    }
    set autoplay(value) {
        if (this._objRef) {
            this._objRef.autoplay = value;
        }
    }
    // @ts-ignore
    get autoplay() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoplay;
    }
    set buffer(value) {
        if (this._objRef) {
            this._objRef.buffer = value;
        }
    }
    // @ts-ignore
    get buffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.buffer;
    }
    set detune(value) {
        if (this._objRef) {
            this._objRef.detune = value;
        }
    }
    // @ts-ignore
    get detune() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.detune;
    }
    set loop(value) {
        if (this._objRef) {
            this._objRef.loop = value;
        }
    }
    // @ts-ignore
    get loop() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.loop;
    }
    set loopStart(value) {
        if (this._objRef) {
            this._objRef.loopStart = value;
        }
    }
    // @ts-ignore
    get loopStart() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.loopStart;
    }
    set loopEnd(value) {
        if (this._objRef) {
            this._objRef.loopEnd = value;
        }
    }
    // @ts-ignore
    get loopEnd() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.loopEnd;
    }
    set offset(value) {
        if (this._objRef) {
            this._objRef.offset = value;
        }
    }
    // @ts-ignore
    get offset() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.offset;
    }
    set duration(value) {
        if (this._objRef) {
            this._objRef.duration = value;
        }
    }
    // @ts-ignore
    get duration() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.duration;
    }
    set playbackRate(value) {
        if (this._objRef) {
            this._objRef.playbackRate = value;
        }
    }
    // @ts-ignore
    get playbackRate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.playbackRate;
    }
    set isPlaying(value) {
        if (this._objRef) {
            this._objRef.isPlaying = value;
        }
    }
    // @ts-ignore
    get isPlaying() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isPlaying;
    }
    set hasPlaybackControl(value) {
        if (this._objRef) {
            this._objRef.hasPlaybackControl = value;
        }
    }
    // @ts-ignore
    get hasPlaybackControl() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.hasPlaybackControl;
    }
    set sourceType(value) {
        if (this._objRef) {
            this._objRef.sourceType = value;
        }
    }
    // @ts-ignore
    get sourceType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sourceType;
    }
    set source(value) {
        if (this._objRef) {
            this._objRef.source = value;
        }
    }
    // @ts-ignore
    get source() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.source;
    }
    set filters(value) {
        if (this._objRef) {
            this._objRef.filters = value;
        }
    }
    // @ts-ignore
    get filters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.filters;
    }
}
ThAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAudio, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAudio.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAudio, selector: "th-audio", inputs: { listener: "listener", context: "context", gain: "gain", autoplay: "autoplay", buffer: "buffer", detune: "detune", loop: "loop", loopStart: "loopStart", loopEnd: "loopEnd", offset: "offset", duration: "duration", playbackRate: "playbackRate", isPlaying: "isPlaying", hasPlaybackControl: "hasPlaybackControl", sourceType: "sourceType", source: "source", filters: "filters" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAudio) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAudio, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-audio',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAudio) }]
                }]
        }], propDecorators: { listener: [{
                type: Input
            }], context: [{
                type: Input
            }], gain: [{
                type: Input
            }], autoplay: [{
                type: Input
            }], buffer: [{
                type: Input
            }], detune: [{
                type: Input
            }], loop: [{
                type: Input
            }], loopStart: [{
                type: Input
            }], loopEnd: [{
                type: Input
            }], offset: [{
                type: Input
            }], duration: [{
                type: Input
            }], playbackRate: [{
                type: Input
            }], isPlaying: [{
                type: Input
            }], hasPlaybackControl: [{
                type: Input
            }], sourceType: [{
                type: Input
            }], source: [{
                type: Input
            }], filters: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThAudioListener extends ThObject3D {
    getType() {
        return AudioListener;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set context(value) {
        if (this._objRef) {
            this._objRef.context = value;
        }
    }
    // @ts-ignore
    get context() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.context;
    }
    set gain(value) {
        if (this._objRef) {
            this._objRef.gain = value;
        }
    }
    // @ts-ignore
    get gain() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.gain;
    }
    set filter(value) {
        if (this._objRef) {
            this._objRef.filter = value;
        }
    }
    // @ts-ignore
    get filter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.filter;
    }
    set timeDelta(value) {
        if (this._objRef) {
            this._objRef.timeDelta = value;
        }
    }
    // @ts-ignore
    get timeDelta() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.timeDelta;
    }
}
ThAudioListener.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAudioListener, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAudioListener.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAudioListener, selector: "th-audioListener", inputs: { context: "context", gain: "gain", filter: "filter", timeDelta: "timeDelta" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAudioListener) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAudioListener, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-audioListener',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAudioListener) }]
                }]
        }], propDecorators: { context: [{
                type: Input
            }], gain: [{
                type: Input
            }], filter: [{
                type: Input
            }], timeDelta: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLine extends ThObject3D {
    getType() {
        return Line;
    }
    // @ts-ignore
    get isLine() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLine;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set geometry(value) {
        if (this._objRef) {
            this._objRef.geometry = value;
        }
    }
    // @ts-ignore
    get geometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.geometry;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set morphTargetInfluences(value) {
        if (this._objRef) {
            this._objRef.morphTargetInfluences = value;
        }
    }
    // @ts-ignore
    get morphTargetInfluences() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetInfluences;
    }
    set morphTargetDictionary(value) {
        if (this._objRef) {
            this._objRef.morphTargetDictionary = value;
        }
    }
    // @ts-ignore
    get morphTargetDictionary() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetDictionary;
    }
}
ThLine.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLine, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLine.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLine, selector: "th-line", inputs: { geometry: "geometry", material: "material", morphTargetInfluences: "morphTargetInfluences", morphTargetDictionary: "morphTargetDictionary" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLine) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLine, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-line',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLine) }]
                }]
        }], propDecorators: { geometry: [{
                type: Input
            }], material: [{
                type: Input
            }], morphTargetInfluences: [{
                type: Input
            }], morphTargetDictionary: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLineSegments extends ThLine {
    getType() {
        return LineSegments;
    }
    // @ts-ignore
    get isLineSegments() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLineSegments;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThLineSegments.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineSegments, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLineSegments.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLineSegments, selector: "th-lineSegments", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLineSegments) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineSegments, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lineSegments',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLineSegments) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThAxesHelper extends ThLineSegments {
    getType() {
        return AxesHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThAxesHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAxesHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThAxesHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThAxesHelper, selector: "th-axesHelper", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAxesHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAxesHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-axesHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThAxesHelper) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThBloomPass extends ThPass {
    getType() {
        return BloomPass;
    }
    set renderTargetX(value) {
        if (this._objRef) {
            this._objRef.renderTargetX = value;
        }
    }
    // @ts-ignore
    get renderTargetX() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetX;
    }
    set renderTargetY(value) {
        if (this._objRef) {
            this._objRef.renderTargetY = value;
        }
    }
    // @ts-ignore
    get renderTargetY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetY;
    }
    set copyUniforms(value) {
        if (this._objRef) {
            this._objRef.copyUniforms = value;
        }
    }
    // @ts-ignore
    get copyUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyUniforms;
    }
    set materialCopy(value) {
        if (this._objRef) {
            this._objRef.materialCopy = value;
        }
    }
    // @ts-ignore
    get materialCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialCopy;
    }
    set convolutionUniforms(value) {
        if (this._objRef) {
            this._objRef.convolutionUniforms = value;
        }
    }
    // @ts-ignore
    get convolutionUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.convolutionUniforms;
    }
    set materialConvolution(value) {
        if (this._objRef) {
            this._objRef.materialConvolution = value;
        }
    }
    // @ts-ignore
    get materialConvolution() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialConvolution;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThBloomPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBloomPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBloomPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBloomPass, selector: "th-bloomPass", inputs: { renderTargetX: "renderTargetX", renderTargetY: "renderTargetY", copyUniforms: "copyUniforms", materialCopy: "materialCopy", convolutionUniforms: "convolutionUniforms", materialConvolution: "materialConvolution", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThBloomPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBloomPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-bloomPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThBloomPass) }]
                }]
        }], propDecorators: { renderTargetX: [{
                type: Input
            }], renderTargetY: [{
                type: Input
            }], copyUniforms: [{
                type: Input
            }], materialCopy: [{
                type: Input
            }], convolutionUniforms: [{
                type: Input
            }], materialConvolution: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThBokehPass extends ThPass {
    getType() {
        return BokehPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set renderTargetColor(value) {
        if (this._objRef) {
            this._objRef.renderTargetColor = value;
        }
    }
    // @ts-ignore
    get renderTargetColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetColor;
    }
    set renderTargetDepth(value) {
        if (this._objRef) {
            this._objRef.renderTargetDepth = value;
        }
    }
    // @ts-ignore
    get renderTargetDepth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetDepth;
    }
    set materialDepth(value) {
        if (this._objRef) {
            this._objRef.materialDepth = value;
        }
    }
    // @ts-ignore
    get materialDepth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialDepth;
    }
    set materialBokeh(value) {
        if (this._objRef) {
            this._objRef.materialBokeh = value;
        }
    }
    // @ts-ignore
    get materialBokeh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialBokeh;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set oldClearColor(value) {
        if (this._objRef) {
            this._objRef.oldClearColor = applyValue(this._objRef.oldClearColor, value);
        }
    }
    // @ts-ignore
    get oldClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearColor;
    }
}
ThBokehPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBokehPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBokehPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBokehPass, selector: "th-bokehPass", inputs: { scene: "scene", camera: "camera", renderTargetColor: "renderTargetColor", renderTargetDepth: "renderTargetDepth", materialDepth: "materialDepth", materialBokeh: "materialBokeh", uniforms: "uniforms", fsQuad: "fsQuad", oldClearColor: "oldClearColor" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThBokehPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBokehPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-bokehPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThBokehPass) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], renderTargetColor: [{
                type: Input
            }], renderTargetDepth: [{
                type: Input
            }], materialDepth: [{
                type: Input
            }], materialBokeh: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], oldClearColor: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBone extends ThObject3D {
    getType() {
        return Bone;
    }
    // @ts-ignore
    get isBone() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isBone;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThBone.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBone, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBone.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBone, selector: "th-bone", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBone) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBone, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-bone',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBone) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBox3Helper extends ThLineSegments {
    getType() {
        return Box3Helper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set box(value) {
        if (this._objRef) {
            this._objRef.box = applyValue(this._objRef.box, value);
        }
    }
    // @ts-ignore
    get box() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.box;
    }
}
ThBox3Helper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBox3Helper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBox3Helper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBox3Helper, selector: "th-box3Helper", inputs: { box: "box" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBox3Helper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBox3Helper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-box3Helper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBox3Helper) }]
                }]
        }], propDecorators: { box: [{
                type: Input
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThGeometryBase extends ThWrapperBase {
    constructor(parent) {
        super();
        this.parent = parent;
    }
    addToParent() {
        if (!this.parent.objRef) {
            return;
            //throw new Error("parent object doesn't hold a three js object instance");
        }
        this.parent.objRef.geometry = this.objRef;
        if (this.parent.objRef.updateMorphTargets) {
            this.parent.objRef.updateMorphTargets();
        }
    }
    removeFromParent() {
        if (this._objRef && this.parent && this.parent.objRef) {
            this.parent.objRef.geometry = undefined;
        }
    }
}
ThGeometryBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGeometryBase, deps: [{ token: ThObject3D }], target: i0.ɵɵFactoryTarget.Component });
ThGeometryBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThGeometryBase, selector: "th-abs-geometry", usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGeometryBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-geometry',
                    template: ''
                }]
        }], ctorParameters: function () { return [{ type: ThObject3D }]; } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBufferGeometry extends ThGeometryBase {
    getType() {
        return BufferGeometry;
    }
    set id(value) {
        if (this._objRef) {
            this._objRef.id = value;
        }
    }
    // @ts-ignore
    get id() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.id;
    }
    set uuid(value) {
        if (this._objRef) {
            this._objRef.uuid = value;
        }
    }
    // @ts-ignore
    get uuid() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uuid;
    }
    set name(value) {
        if (this._objRef) {
            this._objRef.name = value;
        }
    }
    // @ts-ignore
    get name() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.name;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set index(value) {
        if (this._objRef) {
            this._objRef.index = applyValue(this._objRef.index, value);
        }
    }
    // @ts-ignore
    get index() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.index;
    }
    set attributes(value) {
        if (this._objRef) {
            this._objRef.attributes = value;
        }
    }
    // @ts-ignore
    get attributes() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.attributes;
    }
    set morphAttributes(value) {
        if (this._objRef) {
            this._objRef.morphAttributes = value;
        }
    }
    // @ts-ignore
    get morphAttributes() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphAttributes;
    }
    set morphTargetsRelative(value) {
        if (this._objRef) {
            this._objRef.morphTargetsRelative = value;
        }
    }
    // @ts-ignore
    get morphTargetsRelative() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetsRelative;
    }
    set groups(value) {
        if (this._objRef) {
            this._objRef.groups = value;
        }
    }
    // @ts-ignore
    get groups() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.groups;
    }
    set boundingBox(value) {
        if (this._objRef) {
            this._objRef.boundingBox = applyValue(this._objRef.boundingBox, value);
        }
    }
    // @ts-ignore
    get boundingBox() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingBox;
    }
    set boundingSphere(value) {
        if (this._objRef) {
            this._objRef.boundingSphere = applyValue(this._objRef.boundingSphere, value);
        }
    }
    // @ts-ignore
    get boundingSphere() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingSphere;
    }
    set drawRange(value) {
        if (this._objRef) {
            this._objRef.drawRange = value;
        }
    }
    // @ts-ignore
    get drawRange() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.drawRange;
    }
    set userData(value) {
        if (this._objRef) {
            this._objRef.userData = value;
        }
    }
    // @ts-ignore
    get userData() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.userData;
    }
    // @ts-ignore
    get isBufferGeometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isBufferGeometry;
    }
    constructor(hostObject) {
        super(hostObject);
    }
}
ThBufferGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBufferGeometry, deps: [{ token: ThObject3D, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component });
ThBufferGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBufferGeometry, selector: "th-bufferGeometry", inputs: { id: "id", uuid: "uuid", name: "name", index: "index", attributes: "attributes", morphAttributes: "morphAttributes", morphTargetsRelative: "morphTargetsRelative", groups: "groups", boundingBox: "boundingBox", boundingSphere: "boundingSphere", drawRange: "drawRange", userData: "userData" }, providers: [], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBufferGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-bufferGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: []
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: SkipSelf
                    }] }];
    }, propDecorators: { id: [{
                type: Input
            }], uuid: [{
                type: Input
            }], name: [{
                type: Input
            }], index: [{
                type: Input
            }], attributes: [{
                type: Input
            }], morphAttributes: [{
                type: Input
            }], morphTargetsRelative: [{
                type: Input
            }], groups: [{
                type: Input
            }], boundingBox: [{
                type: Input
            }], boundingSphere: [{
                type: Input
            }], drawRange: [{
                type: Input
            }], userData: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBoxGeometry extends ThBufferGeometry {
    getType() {
        return BoxGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThBoxGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBoxGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBoxGeometry, selector: "th-boxGeometry", providers: [{ provide: ThBufferGeometry, useExisting: forwardRef(() => ThBoxGeometry) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-boxGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThBufferGeometry, useExisting: forwardRef(() => ThBoxGeometry) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBoxHelper extends ThLineSegments {
    getType() {
        return BoxHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThBoxHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBoxHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBoxHelper, selector: "th-boxHelper", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBoxHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-boxHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThBoxHelper) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThBoxLineGeometry extends ThBufferGeometry {
    getType() {
        return BoxLineGeometry;
    }
}
ThBoxLineGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxLineGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThBoxLineGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThBoxLineGeometry, selector: "th-boxLineGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThBoxLineGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThBoxLineGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-boxLineGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThBoxLineGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCameraHelper extends ThLineSegments {
    getType() {
        return CameraHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set pointMap(value) {
        if (this._objRef) {
            this._objRef.pointMap = value;
        }
    }
    // @ts-ignore
    get pointMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.pointMap;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
}
ThCameraHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCameraHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCameraHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCameraHelper, selector: "th-cameraHelper", inputs: { camera: "camera", pointMap: "pointMap", matrix: "matrix", matrixAutoUpdate: "matrixAutoUpdate" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCameraHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCameraHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-cameraHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCameraHelper) }]
                }]
        }], propDecorators: { camera: [{
                type: Input
            }], pointMap: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThTextureBase extends ThWrapperBase {
}
ThTextureBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureBase, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTextureBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTextureBase, selector: "th-abs-texture", usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-texture',
                    template: ''
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTexture extends ThTextureBase {
    getType() {
        return Texture;
    }
    // @ts-ignore
    get isTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isTexture;
    }
    // @ts-ignore
    get id() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.id;
    }
    set uuid(value) {
        if (this._objRef) {
            this._objRef.uuid = value;
        }
    }
    // @ts-ignore
    get uuid() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uuid;
    }
    set name(value) {
        if (this._objRef) {
            this._objRef.name = value;
        }
    }
    // @ts-ignore
    get name() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.name;
    }
    set source(value) {
        if (this._objRef) {
            this._objRef.source = value;
        }
    }
    // @ts-ignore
    get source() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.source;
    }
    set mipmaps(value) {
        if (this._objRef) {
            this._objRef.mipmaps = value;
        }
    }
    // @ts-ignore
    get mipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mipmaps;
    }
    set mapping(value) {
        if (this._objRef) {
            this._objRef.mapping = value;
        }
    }
    // @ts-ignore
    get mapping() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mapping;
    }
    set channel(value) {
        if (this._objRef) {
            this._objRef.channel = value;
        }
    }
    // @ts-ignore
    get channel() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.channel;
    }
    set wrapS(value) {
        if (this._objRef) {
            this._objRef.wrapS = value;
        }
    }
    // @ts-ignore
    get wrapS() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wrapS;
    }
    set wrapT(value) {
        if (this._objRef) {
            this._objRef.wrapT = value;
        }
    }
    // @ts-ignore
    get wrapT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wrapT;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set anisotropy(value) {
        if (this._objRef) {
            this._objRef.anisotropy = value;
        }
    }
    // @ts-ignore
    get anisotropy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.anisotropy;
    }
    set format(value) {
        if (this._objRef) {
            this._objRef.format = value;
        }
    }
    // @ts-ignore
    get format() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.format;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set internalFormat(value) {
        if (this._objRef) {
            this._objRef.internalFormat = value;
        }
    }
    // @ts-ignore
    get internalFormat() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.internalFormat;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
    set offset(value) {
        if (this._objRef) {
            this._objRef.offset = applyValue(this._objRef.offset, value);
        }
    }
    // @ts-ignore
    get offset() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.offset;
    }
    set repeat(value) {
        if (this._objRef) {
            this._objRef.repeat = applyValue(this._objRef.repeat, value);
        }
    }
    // @ts-ignore
    get repeat() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.repeat;
    }
    set center(value) {
        if (this._objRef) {
            this._objRef.center = applyValue(this._objRef.center, value);
        }
    }
    // @ts-ignore
    get center() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.center;
    }
    set rotation(value) {
        if (this._objRef) {
            this._objRef.rotation = value;
        }
    }
    // @ts-ignore
    get rotation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotation;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
    set premultiplyAlpha(value) {
        if (this._objRef) {
            this._objRef.premultiplyAlpha = value;
        }
    }
    // @ts-ignore
    get premultiplyAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.premultiplyAlpha;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set unpackAlignment(value) {
        if (this._objRef) {
            this._objRef.unpackAlignment = value;
        }
    }
    // @ts-ignore
    get unpackAlignment() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.unpackAlignment;
    }
    set encoding(value) {
        if (this._objRef) {
            this._objRef.encoding = value;
        }
    }
    // @ts-ignore
    get encoding() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.encoding;
    }
    set isRenderTargetTexture(value) {
        if (this._objRef) {
            this._objRef.isRenderTargetTexture = value;
        }
    }
    // @ts-ignore
    get isRenderTargetTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isRenderTargetTexture;
    }
    set needsPMREMUpdate(value) {
        if (this._objRef) {
            this._objRef.needsPMREMUpdate = value;
        }
    }
    // @ts-ignore
    get needsPMREMUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.needsPMREMUpdate;
    }
    set userData(value) {
        if (this._objRef) {
            this._objRef.userData = value;
        }
    }
    // @ts-ignore
    get userData() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.userData;
    }
    set version(value) {
        if (this._objRef) {
            this._objRef.version = value;
        }
    }
    // @ts-ignore
    get version() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.version;
    }
}
ThTexture.DEFAULT_ANISOTROPY = Texture.DEFAULT_ANISOTROPY;
ThTexture.DEFAULT_IMAGE = Texture.DEFAULT_IMAGE;
ThTexture.DEFAULT_MAPPING = Texture.DEFAULT_MAPPING;
ThTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTexture, selector: "th-texture", inputs: { uuid: "uuid", name: "name", source: "source", mipmaps: "mipmaps", mapping: "mapping", channel: "channel", wrapS: "wrapS", wrapT: "wrapT", magFilter: "magFilter", minFilter: "minFilter", anisotropy: "anisotropy", format: "format", type: "type", internalFormat: "internalFormat", matrix: "matrix", matrixAutoUpdate: "matrixAutoUpdate", offset: "offset", repeat: "repeat", center: "center", rotation: "rotation", generateMipmaps: "generateMipmaps", premultiplyAlpha: "premultiplyAlpha", flipY: "flipY", unpackAlignment: "unpackAlignment", encoding: "encoding", isRenderTargetTexture: "isRenderTargetTexture", needsPMREMUpdate: "needsPMREMUpdate", userData: "userData", version: "version" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-texture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThTexture) }]
                }]
        }], propDecorators: { uuid: [{
                type: Input
            }], name: [{
                type: Input
            }], source: [{
                type: Input
            }], mipmaps: [{
                type: Input
            }], mapping: [{
                type: Input
            }], channel: [{
                type: Input
            }], wrapS: [{
                type: Input
            }], wrapT: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], anisotropy: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }], internalFormat: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }], offset: [{
                type: Input
            }], repeat: [{
                type: Input
            }], center: [{
                type: Input
            }], rotation: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }], premultiplyAlpha: [{
                type: Input
            }], flipY: [{
                type: Input
            }], unpackAlignment: [{
                type: Input
            }], encoding: [{
                type: Input
            }], isRenderTargetTexture: [{
                type: Input
            }], needsPMREMUpdate: [{
                type: Input
            }], userData: [{
                type: Input
            }], version: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCanvasTexture extends ThTexture {
    getType() {
        return CanvasTexture;
    }
    // @ts-ignore
    get isCanvasTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isCanvasTexture;
    }
}
ThCanvasTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCanvasTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCanvasTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCanvasTexture, selector: "th-canvasTexture", providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThCanvasTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCanvasTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-canvasTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThCanvasTexture) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCapsuleGeometry extends ThBufferGeometry {
    getType() {
        return CapsuleGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThCapsuleGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCapsuleGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCapsuleGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCapsuleGeometry, selector: "th-capsuleGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThCapsuleGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCapsuleGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-capsuleGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThCapsuleGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCircleGeometry extends ThBufferGeometry {
    getType() {
        return CircleGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThCircleGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCircleGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCircleGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCircleGeometry, selector: "th-circleGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThCircleGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCircleGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-circleGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThCircleGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThClearMaskPass extends ThPass {
    getType() {
        return ClearMaskPass;
    }
}
ThClearMaskPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThClearMaskPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThClearMaskPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThClearMaskPass, selector: "th-clearMaskPass", providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThClearMaskPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThClearMaskPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-clearMaskPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThClearMaskPass) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThClearPass extends ThPass {
    getType() {
        return ClearPass;
    }
    set clearColor(value) {
        if (this._objRef) {
            this._objRef.clearColor = value;
        }
    }
    // @ts-ignore
    get clearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearColor;
    }
    set clearAlpha(value) {
        if (this._objRef) {
            this._objRef.clearAlpha = value;
        }
    }
    // @ts-ignore
    get clearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearAlpha;
    }
}
ThClearPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThClearPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThClearPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThClearPass, selector: "th-clearPass", inputs: { clearColor: "clearColor", clearAlpha: "clearAlpha" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThClearPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThClearPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-clearPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThClearPass) }]
                }]
        }], propDecorators: { clearColor: [{
                type: Input
            }], clearAlpha: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCompressedTexture extends ThTexture {
    getType() {
        return CompressedTexture;
    }
    // @ts-ignore
    get isCompressedTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isCompressedTexture;
    }
    set mipmaps(value) {
        if (this._objRef) {
            this._objRef.mipmaps = value;
        }
    }
    // @ts-ignore
    get mipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mipmaps;
    }
    set format(value) {
        if (this._objRef) {
            this._objRef.format = value;
        }
    }
    // @ts-ignore
    get format() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.format;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
}
ThCompressedTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCompressedTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCompressedTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCompressedTexture, selector: "th-compressedTexture", inputs: { mipmaps: "mipmaps", format: "format", flipY: "flipY", generateMipmaps: "generateMipmaps" }, providers: [
        {
            provide: ThTextureBase,
            useExisting: forwardRef(() => ThCompressedTexture)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCompressedTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-compressedTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThTextureBase,
                            useExisting: forwardRef(() => ThCompressedTexture)
                        }
                    ]
                }]
        }], propDecorators: { mipmaps: [{
                type: Input
            }], format: [{
                type: Input
            }], flipY: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCompressedArrayTexture extends ThCompressedTexture {
    getType() {
        return CompressedArrayTexture;
    }
    // @ts-ignore
    get isCompressedArrayTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isCompressedArrayTexture;
    }
    set wrapR(value) {
        if (this._objRef) {
            this._objRef.wrapR = value;
        }
    }
    // @ts-ignore
    get wrapR() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wrapR;
    }
}
ThCompressedArrayTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCompressedArrayTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCompressedArrayTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCompressedArrayTexture, selector: "th-compressedArrayTexture", inputs: { wrapR: "wrapR" }, providers: [
        {
            provide: ThTextureBase,
            useExisting: forwardRef(() => ThCompressedArrayTexture)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCompressedArrayTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-compressedArrayTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThTextureBase,
                            useExisting: forwardRef(() => ThCompressedArrayTexture)
                        }
                    ]
                }]
        }], propDecorators: { wrapR: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCylinderGeometry extends ThBufferGeometry {
    getType() {
        return CylinderGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThCylinderGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCylinderGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCylinderGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCylinderGeometry, selector: "th-cylinderGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThCylinderGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCylinderGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-cylinderGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThCylinderGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThConeGeometry extends ThCylinderGeometry {
    getType() {
        return ConeGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThConeGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThConeGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThConeGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThConeGeometry, selector: "th-coneGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThConeGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThConeGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-coneGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThConeGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThConvexGeometry extends ThBufferGeometry {
    getType() {
        return ConvexGeometry;
    }
}
ThConvexGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThConvexGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThConvexGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThConvexGeometry, selector: "th-convexGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThConvexGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThConvexGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-convexGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThConvexGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCubeCamera extends ThObject3D {
    getType() {
        return CubeCamera;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set renderTarget(value) {
        if (this._objRef) {
            this._objRef.renderTarget = value;
        }
    }
    // @ts-ignore
    get renderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTarget;
    }
}
ThCubeCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCubeCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCubeCamera, selector: "th-cubeCamera", inputs: { renderTarget: "renderTarget" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCubeCamera) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-cubeCamera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThCubeCamera) }]
                }]
        }], propDecorators: { renderTarget: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThCubeTexture extends ThTexture {
    getType() {
        return CubeTexture;
    }
    // @ts-ignore
    get isCubeTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isCubeTexture;
    }
    set mapping(value) {
        if (this._objRef) {
            this._objRef.mapping = value;
        }
    }
    // @ts-ignore
    get mapping() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mapping;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
}
ThCubeTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCubeTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCubeTexture, selector: "th-cubeTexture", inputs: { mapping: "mapping", flipY: "flipY" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThCubeTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-cubeTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThCubeTexture) }]
                }]
        }], propDecorators: { mapping: [{
                type: Input
            }], flipY: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThCubeTexturePass extends ThPass {
    getType() {
        return CubeTexturePass;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set cubeShader(value) {
        if (this._objRef) {
            this._objRef.cubeShader = value;
        }
    }
    // @ts-ignore
    get cubeShader() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cubeShader;
    }
    set cubeMesh(value) {
        if (this._objRef) {
            this._objRef.cubeMesh = value;
        }
    }
    // @ts-ignore
    get cubeMesh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cubeMesh;
    }
    set envMap(value) {
        if (this._objRef) {
            this._objRef.envMap = value;
        }
    }
    // @ts-ignore
    get envMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMap;
    }
    set opacity(value) {
        if (this._objRef) {
            this._objRef.opacity = value;
        }
    }
    // @ts-ignore
    get opacity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.opacity;
    }
    set cubeScene(value) {
        if (this._objRef) {
            this._objRef.cubeScene = value;
        }
    }
    // @ts-ignore
    get cubeScene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cubeScene;
    }
    set cubeCamera(value) {
        if (this._objRef) {
            this._objRef.cubeCamera = value;
        }
    }
    // @ts-ignore
    get cubeCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cubeCamera;
    }
}
ThCubeTexturePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTexturePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThCubeTexturePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThCubeTexturePass, selector: "th-cubeTexturePass", inputs: { camera: "camera", cubeShader: "cubeShader", cubeMesh: "cubeMesh", envMap: "envMap", opacity: "opacity", cubeScene: "cubeScene", cubeCamera: "cubeCamera" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThCubeTexturePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTexturePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-cubeTexturePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThCubeTexturePass) }]
                }]
        }], propDecorators: { camera: [{
                type: Input
            }], cubeShader: [{
                type: Input
            }], cubeMesh: [{
                type: Input
            }], envMap: [{
                type: Input
            }], opacity: [{
                type: Input
            }], cubeScene: [{
                type: Input
            }], cubeCamera: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThData3DTexture extends ThTexture {
    getType() {
        return Data3DTexture;
    }
    // @ts-ignore
    get isData3DTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isData3DTexture;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set wrapR(value) {
        if (this._objRef) {
            this._objRef.wrapR = value;
        }
    }
    // @ts-ignore
    get wrapR() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wrapR;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
    set unpackAlignment(value) {
        if (this._objRef) {
            this._objRef.unpackAlignment = value;
        }
    }
    // @ts-ignore
    get unpackAlignment() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.unpackAlignment;
    }
}
ThData3DTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThData3DTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThData3DTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThData3DTexture, selector: "th-data3DTexture", inputs: { magFilter: "magFilter", minFilter: "minFilter", wrapR: "wrapR", flipY: "flipY", generateMipmaps: "generateMipmaps", unpackAlignment: "unpackAlignment" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThData3DTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThData3DTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-data3DTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThData3DTexture) }]
                }]
        }], propDecorators: { magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], wrapR: [{
                type: Input
            }], flipY: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }], unpackAlignment: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDataArrayTexture extends ThTexture {
    getType() {
        return DataArrayTexture;
    }
    // @ts-ignore
    get isDataArrayTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isDataArrayTexture;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set wrapR(value) {
        if (this._objRef) {
            this._objRef.wrapR = value;
        }
    }
    // @ts-ignore
    get wrapR() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wrapR;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
    set unpackAlignment(value) {
        if (this._objRef) {
            this._objRef.unpackAlignment = value;
        }
    }
    // @ts-ignore
    get unpackAlignment() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.unpackAlignment;
    }
}
ThDataArrayTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDataArrayTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDataArrayTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDataArrayTexture, selector: "th-dataArrayTexture", inputs: { magFilter: "magFilter", minFilter: "minFilter", wrapR: "wrapR", flipY: "flipY", generateMipmaps: "generateMipmaps", unpackAlignment: "unpackAlignment" }, providers: [
        {
            provide: ThTextureBase,
            useExisting: forwardRef(() => ThDataArrayTexture)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDataArrayTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-dataArrayTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThTextureBase,
                            useExisting: forwardRef(() => ThDataArrayTexture)
                        }
                    ]
                }]
        }], propDecorators: { magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], wrapR: [{
                type: Input
            }], flipY: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }], unpackAlignment: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDataTexture extends ThTexture {
    getType() {
        return DataTexture;
    }
    // @ts-ignore
    get isDataTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isDataTexture;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
    set unpackAlignment(value) {
        if (this._objRef) {
            this._objRef.unpackAlignment = value;
        }
    }
    // @ts-ignore
    get unpackAlignment() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.unpackAlignment;
    }
}
ThDataTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDataTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDataTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDataTexture, selector: "th-dataTexture", inputs: { magFilter: "magFilter", minFilter: "minFilter", flipY: "flipY", generateMipmaps: "generateMipmaps", unpackAlignment: "unpackAlignment" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThDataTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDataTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-dataTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThDataTexture) }]
                }]
        }], propDecorators: { magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], flipY: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }], unpackAlignment: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDecalGeometry extends ThBufferGeometry {
    getType() {
        return DecalGeometry;
    }
}
ThDecalGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDecalGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDecalGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDecalGeometry, selector: "th-decalGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThDecalGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDecalGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-decalGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThDecalGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDepthTexture extends ThTexture {
    getType() {
        return DepthTexture;
    }
    // @ts-ignore
    get isDepthTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isDepthTexture;
    }
    set flipY(value) {
        if (this._objRef) {
            this._objRef.flipY = value;
        }
    }
    // @ts-ignore
    get flipY() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flipY;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
    set format(value) {
        if (this._objRef) {
            this._objRef.format = value;
        }
    }
    // @ts-ignore
    get format() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.format;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThDepthTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDepthTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDepthTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDepthTexture, selector: "th-depthTexture", inputs: { flipY: "flipY", magFilter: "magFilter", minFilter: "minFilter", generateMipmaps: "generateMipmaps", format: "format", type: "type" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThDepthTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDepthTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-depthTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThDepthTexture) }]
                }]
        }], propDecorators: { flipY: [{
                type: Input
            }], magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }], format: [{
                type: Input
            }], type: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDirectionalLight extends ThLight {
    getType() {
        return DirectionalLight;
    }
    // @ts-ignore
    get isDirectionalLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isDirectionalLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set castShadow(value) {
        if (this._objRef) {
            this._objRef.castShadow = value;
        }
    }
    // @ts-ignore
    get castShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.castShadow;
    }
    set position(value) {
        if (this._objRef) {
            applyValue(this._objRef.position, value);
        }
    }
    // @ts-ignore
    get position() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position;
    }
    set shadow(value) {
        if (this._objRef) {
            this._objRef.shadow = value;
        }
    }
    // @ts-ignore
    get shadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shadow;
    }
    set target(value) {
        if (this._objRef) {
            this._objRef.target = value;
        }
    }
    // @ts-ignore
    get target() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target;
    }
}
ThDirectionalLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDirectionalLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDirectionalLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDirectionalLight, selector: "th-directionalLight", inputs: { castShadow: "castShadow", position: "position", shadow: "shadow", target: "target" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThDirectionalLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDirectionalLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-directionalLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThDirectionalLight) }]
                }]
        }], propDecorators: { castShadow: [{
                type: Input
            }], position: [{
                type: Input
            }], shadow: [{
                type: Input
            }], target: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDirectionalLightHelper extends ThObject3D {
    getType() {
        return DirectionalLightHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set lightPlane(value) {
        if (this._objRef) {
            this._objRef.lightPlane = value;
        }
    }
    // @ts-ignore
    get lightPlane() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightPlane;
    }
    set light(value) {
        if (this._objRef) {
            this._objRef.light = value;
        }
    }
    // @ts-ignore
    get light() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.light;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = value;
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set targetLine(value) {
        if (this._objRef) {
            this._objRef.targetLine = value;
        }
    }
    // @ts-ignore
    get targetLine() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.targetLine;
    }
}
ThDirectionalLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDirectionalLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDirectionalLightHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDirectionalLightHelper, selector: "th-directionalLightHelper", inputs: { lightPlane: "lightPlane", light: "light", matrix: "matrix", matrixAutoUpdate: "matrixAutoUpdate", color: "color", targetLine: "targetLine" }, providers: [
        {
            provide: ThObject3D,
            useExisting: forwardRef(() => ThDirectionalLightHelper)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDirectionalLightHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-directionalLightHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThObject3D,
                            useExisting: forwardRef(() => ThDirectionalLightHelper)
                        }
                    ]
                }]
        }], propDecorators: { lightPlane: [{
                type: Input
            }], light: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }], color: [{
                type: Input
            }], targetLine: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPolyhedronGeometry extends ThBufferGeometry {
    getType() {
        return PolyhedronGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThPolyhedronGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPolyhedronGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPolyhedronGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPolyhedronGeometry, selector: "th-polyhedronGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThPolyhedronGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPolyhedronGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-polyhedronGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThPolyhedronGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDodecahedronGeometry extends ThPolyhedronGeometry {
    getType() {
        return DodecahedronGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThDodecahedronGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDodecahedronGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDodecahedronGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDodecahedronGeometry, selector: "th-dodecahedronGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThDodecahedronGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDodecahedronGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-dodecahedronGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThDodecahedronGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThDotScreenPass extends ThPass {
    getType() {
        return DotScreenPass;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThDotScreenPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDotScreenPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDotScreenPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDotScreenPass, selector: "th-dotScreenPass", inputs: { uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThDotScreenPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDotScreenPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-dotScreenPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThDotScreenPass) }]
                }]
        }], propDecorators: { uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThDragControls extends ThControlBase {
    getType() {
        return DragControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set transformGroup(value) {
        if (this._objRef) {
            this._objRef.transformGroup = value;
        }
    }
    // @ts-ignore
    get transformGroup() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transformGroup;
    }
}
ThDragControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDragControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThDragControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThDragControls, selector: "th-dragControls", inputs: { object: "object", enabled: "enabled", transformGroup: "transformGroup" }, providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThDragControls) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDragControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-dragControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThDragControls) }]
                }]
        }], propDecorators: { object: [{
                type: Input
            }], enabled: [{
                type: Input
            }], transformGroup: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThEdgesGeometry extends ThBufferGeometry {
    getType() {
        return EdgesGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThEdgesGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEdgesGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThEdgesGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThEdgesGeometry, selector: "th-edgesGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThEdgesGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEdgesGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-edgesGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThEdgesGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThExtrudeGeometry extends ThBufferGeometry {
    getType() {
        return ExtrudeGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThExtrudeGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThExtrudeGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThExtrudeGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThExtrudeGeometry, selector: "th-extrudeGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThExtrudeGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThExtrudeGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-extrudeGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThExtrudeGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThFilmPass extends ThPass {
    getType() {
        return FilmPass;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThFilmPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFilmPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThFilmPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThFilmPass, selector: "th-filmPass", inputs: { uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThFilmPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFilmPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-filmPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThFilmPass) }]
                }]
        }], propDecorators: { uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThFirstPersonControls extends ThControlBase {
    getType() {
        return FirstPersonControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set movementSpeed(value) {
        if (this._objRef) {
            this._objRef.movementSpeed = value;
        }
    }
    // @ts-ignore
    get movementSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.movementSpeed;
    }
    set lookSpeed(value) {
        if (this._objRef) {
            this._objRef.lookSpeed = value;
        }
    }
    // @ts-ignore
    get lookSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lookSpeed;
    }
    set lookVertical(value) {
        if (this._objRef) {
            this._objRef.lookVertical = value;
        }
    }
    // @ts-ignore
    get lookVertical() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lookVertical;
    }
    set autoForward(value) {
        if (this._objRef) {
            this._objRef.autoForward = value;
        }
    }
    // @ts-ignore
    get autoForward() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoForward;
    }
    set activeLook(value) {
        if (this._objRef) {
            this._objRef.activeLook = value;
        }
    }
    // @ts-ignore
    get activeLook() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.activeLook;
    }
    set heightSpeed(value) {
        if (this._objRef) {
            this._objRef.heightSpeed = value;
        }
    }
    // @ts-ignore
    get heightSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.heightSpeed;
    }
    set heightCoef(value) {
        if (this._objRef) {
            this._objRef.heightCoef = value;
        }
    }
    // @ts-ignore
    get heightCoef() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.heightCoef;
    }
    set heightMin(value) {
        if (this._objRef) {
            this._objRef.heightMin = value;
        }
    }
    // @ts-ignore
    get heightMin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.heightMin;
    }
    set heightMax(value) {
        if (this._objRef) {
            this._objRef.heightMax = value;
        }
    }
    // @ts-ignore
    get heightMax() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.heightMax;
    }
    set constrainVertical(value) {
        if (this._objRef) {
            this._objRef.constrainVertical = value;
        }
    }
    // @ts-ignore
    get constrainVertical() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.constrainVertical;
    }
    set verticalMin(value) {
        if (this._objRef) {
            this._objRef.verticalMin = value;
        }
    }
    // @ts-ignore
    get verticalMin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.verticalMin;
    }
    set verticalMax(value) {
        if (this._objRef) {
            this._objRef.verticalMax = value;
        }
    }
    // @ts-ignore
    get verticalMax() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.verticalMax;
    }
    set mouseDragOn(value) {
        if (this._objRef) {
            this._objRef.mouseDragOn = value;
        }
    }
    // @ts-ignore
    get mouseDragOn() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mouseDragOn;
    }
}
ThFirstPersonControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFirstPersonControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThFirstPersonControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThFirstPersonControls, selector: "th-firstPersonControls", inputs: { object: "object", domElement: "domElement", enabled: "enabled", movementSpeed: "movementSpeed", lookSpeed: "lookSpeed", lookVertical: "lookVertical", autoForward: "autoForward", activeLook: "activeLook", heightSpeed: "heightSpeed", heightCoef: "heightCoef", heightMin: "heightMin", heightMax: "heightMax", constrainVertical: "constrainVertical", verticalMin: "verticalMin", verticalMax: "verticalMax", mouseDragOn: "mouseDragOn" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThFirstPersonControls)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFirstPersonControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-firstPersonControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThFirstPersonControls)
                        }
                    ]
                }]
        }], propDecorators: { object: [{
                type: Input
            }], domElement: [{
                type: Input
            }], enabled: [{
                type: Input
            }], movementSpeed: [{
                type: Input
            }], lookSpeed: [{
                type: Input
            }], lookVertical: [{
                type: Input
            }], autoForward: [{
                type: Input
            }], activeLook: [{
                type: Input
            }], heightSpeed: [{
                type: Input
            }], heightCoef: [{
                type: Input
            }], heightMin: [{
                type: Input
            }], heightMax: [{
                type: Input
            }], constrainVertical: [{
                type: Input
            }], verticalMin: [{
                type: Input
            }], verticalMax: [{
                type: Input
            }], mouseDragOn: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThFlyControls extends ThControlBase {
    getType() {
        return FlyControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set movementSpeed(value) {
        if (this._objRef) {
            this._objRef.movementSpeed = value;
        }
    }
    // @ts-ignore
    get movementSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.movementSpeed;
    }
    set rollSpeed(value) {
        if (this._objRef) {
            this._objRef.rollSpeed = value;
        }
    }
    // @ts-ignore
    get rollSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rollSpeed;
    }
    set dragToLook(value) {
        if (this._objRef) {
            this._objRef.dragToLook = value;
        }
    }
    // @ts-ignore
    get dragToLook() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dragToLook;
    }
    set autoForward(value) {
        if (this._objRef) {
            this._objRef.autoForward = value;
        }
    }
    // @ts-ignore
    get autoForward() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoForward;
    }
}
ThFlyControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFlyControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThFlyControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThFlyControls, selector: "th-flyControls", inputs: { object: "object", domElement: "domElement", movementSpeed: "movementSpeed", rollSpeed: "rollSpeed", dragToLook: "dragToLook", autoForward: "autoForward" }, providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThFlyControls) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFlyControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-flyControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThFlyControls) }]
                }]
        }], propDecorators: { object: [{
                type: Input
            }], domElement: [{
                type: Input
            }], movementSpeed: [{
                type: Input
            }], rollSpeed: [{
                type: Input
            }], dragToLook: [{
                type: Input
            }], autoForward: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThFramebufferTexture extends ThTexture {
    getType() {
        return FramebufferTexture;
    }
    // @ts-ignore
    get isFramebufferTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isFramebufferTexture;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
}
ThFramebufferTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFramebufferTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThFramebufferTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThFramebufferTexture, selector: "th-framebufferTexture", inputs: { magFilter: "magFilter", minFilter: "minFilter", generateMipmaps: "generateMipmaps" }, providers: [
        {
            provide: ThTextureBase,
            useExisting: forwardRef(() => ThFramebufferTexture)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFramebufferTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-framebufferTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThTextureBase,
                            useExisting: forwardRef(() => ThFramebufferTexture)
                        }
                    ]
                }]
        }], propDecorators: { magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThGlitchPass extends ThPass {
    getType() {
        return GlitchPass;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set goWild(value) {
        if (this._objRef) {
            this._objRef.goWild = value;
        }
    }
    // @ts-ignore
    get goWild() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.goWild;
    }
    set curF(value) {
        if (this._objRef) {
            this._objRef.curF = value;
        }
    }
    // @ts-ignore
    get curF() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.curF;
    }
    set randX(value) {
        if (this._objRef) {
            this._objRef.randX = value;
        }
    }
    // @ts-ignore
    get randX() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.randX;
    }
}
ThGlitchPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGlitchPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThGlitchPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThGlitchPass, selector: "th-glitchPass", inputs: { uniforms: "uniforms", material: "material", fsQuad: "fsQuad", goWild: "goWild", curF: "curF", randX: "randX" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThGlitchPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGlitchPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-glitchPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThGlitchPass) }]
                }]
        }], propDecorators: { uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], goWild: [{
                type: Input
            }], curF: [{
                type: Input
            }], randX: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThGridHelper extends ThLineSegments {
    getType() {
        return GridHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThGridHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGridHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThGridHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThGridHelper, selector: "th-gridHelper", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThGridHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGridHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-gridHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThGridHelper) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThGroup extends ThObject3D {
    getType() {
        return Group;
    }
    // @ts-ignore
    get isGroup() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isGroup;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThGroup.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGroup, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThGroup.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThGroup, selector: "th-group", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThGroup) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGroup, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-group',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThGroup) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThHalftonePass extends ThPass {
    getType() {
        return HalftonePass;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThHalftonePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHalftonePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThHalftonePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThHalftonePass, selector: "th-halftonePass", inputs: { uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThHalftonePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHalftonePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-halftonePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThHalftonePass) }]
                }]
        }], propDecorators: { uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThHemisphereLight extends ThLight {
    getType() {
        return HemisphereLight;
    }
    // @ts-ignore
    get isHemisphereLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isHemisphereLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set position(value) {
        if (this._objRef) {
            applyValue(this._objRef.position, value);
        }
    }
    // @ts-ignore
    get position() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set groundColor(value) {
        if (this._objRef) {
            this._objRef.groundColor = applyValue(this._objRef.groundColor, value);
        }
    }
    // @ts-ignore
    get groundColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.groundColor;
    }
}
ThHemisphereLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThHemisphereLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThHemisphereLight, selector: "th-hemisphereLight", inputs: { position: "position", color: "color", groundColor: "groundColor" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThHemisphereLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-hemisphereLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThHemisphereLight) }]
                }]
        }], propDecorators: { position: [{
                type: Input
            }], color: [{
                type: Input
            }], groundColor: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThHemisphereLightHelper extends ThObject3D {
    getType() {
        return HemisphereLightHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set light(value) {
        if (this._objRef) {
            this._objRef.light = value;
        }
    }
    // @ts-ignore
    get light() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.light;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = value;
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
}
ThHemisphereLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThHemisphereLightHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThHemisphereLightHelper, selector: "th-hemisphereLightHelper", inputs: { light: "light", matrix: "matrix", matrixAutoUpdate: "matrixAutoUpdate", material: "material", color: "color" }, providers: [
        {
            provide: ThObject3D,
            useExisting: forwardRef(() => ThHemisphereLightHelper)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLightHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-hemisphereLightHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThObject3D,
                            useExisting: forwardRef(() => ThHemisphereLightHelper)
                        }
                    ]
                }]
        }], propDecorators: { light: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }], material: [{
                type: Input
            }], color: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThHemisphereLightProbe extends ThLightProbe {
    getType() {
        return HemisphereLightProbe;
    }
    // @ts-ignore
    get isHemisphereLightProbe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isHemisphereLightProbe;
    }
}
ThHemisphereLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThHemisphereLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThHemisphereLightProbe, selector: "th-hemisphereLightProbe", providers: [
        {
            provide: ThObject3D,
            useExisting: forwardRef(() => ThHemisphereLightProbe)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThHemisphereLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-hemisphereLightProbe',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThObject3D,
                            useExisting: forwardRef(() => ThHemisphereLightProbe)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThIcosahedronGeometry extends ThPolyhedronGeometry {
    getType() {
        return IcosahedronGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThIcosahedronGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThIcosahedronGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThIcosahedronGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThIcosahedronGeometry, selector: "th-icosahedronGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThIcosahedronGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThIcosahedronGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-icosahedronGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThIcosahedronGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThInstancedBufferGeometry extends ThBufferGeometry {
    getType() {
        return InstancedBufferGeometry;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get isInstancedBufferGeometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isInstancedBufferGeometry;
    }
    set instanceCount(value) {
        if (this._objRef) {
            this._objRef.instanceCount = value;
        }
    }
    // @ts-ignore
    get instanceCount() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.instanceCount;
    }
}
ThInstancedBufferGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThInstancedBufferGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThInstancedBufferGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThInstancedBufferGeometry, selector: "th-instancedBufferGeometry", inputs: { type: "type", instanceCount: "instanceCount" }, providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThInstancedBufferGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThInstancedBufferGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-instancedBufferGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThInstancedBufferGeometry)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], instanceCount: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMesh extends ThObject3D {
    getType() {
        return Mesh;
    }
    // @ts-ignore
    get isMesh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isMesh;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set geometry(value) {
        if (this._objRef) {
            this._objRef.geometry = value;
        }
    }
    // @ts-ignore
    get geometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.geometry;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set morphTargetInfluences(value) {
        if (this._objRef) {
            this._objRef.morphTargetInfluences = value;
        }
    }
    // @ts-ignore
    get morphTargetInfluences() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetInfluences;
    }
    set morphTargetDictionary(value) {
        if (this._objRef) {
            this._objRef.morphTargetDictionary = value;
        }
    }
    // @ts-ignore
    get morphTargetDictionary() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetDictionary;
    }
}
ThMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMesh, selector: "th-mesh", inputs: { geometry: "geometry", material: "material", morphTargetInfluences: "morphTargetInfluences", morphTargetDictionary: "morphTargetDictionary" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThMesh) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-mesh',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThMesh) }]
                }]
        }], propDecorators: { geometry: [{
                type: Input
            }], material: [{
                type: Input
            }], morphTargetInfluences: [{
                type: Input
            }], morphTargetDictionary: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThInstancedMesh extends ThMesh {
    getType() {
        return InstancedMesh;
    }
    // @ts-ignore
    get isInstancedMesh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isInstancedMesh;
    }
    set boundingBox(value) {
        if (this._objRef) {
            this._objRef.boundingBox = applyValue(this._objRef.boundingBox, value);
        }
    }
    // @ts-ignore
    get boundingBox() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingBox;
    }
    set boundingSphere(value) {
        if (this._objRef) {
            this._objRef.boundingSphere = applyValue(this._objRef.boundingSphere, value);
        }
    }
    // @ts-ignore
    get boundingSphere() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingSphere;
    }
    set count(value) {
        if (this._objRef) {
            this._objRef.count = value;
        }
    }
    // @ts-ignore
    get count() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.count;
    }
    set instanceColor(value) {
        if (this._objRef) {
            this._objRef.instanceColor = applyValue(this._objRef.instanceColor, value);
        }
    }
    // @ts-ignore
    get instanceColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.instanceColor;
    }
    set instanceMatrix(value) {
        if (this._objRef) {
            this._objRef.instanceMatrix = applyValue(this._objRef.instanceMatrix, value);
        }
    }
    // @ts-ignore
    get instanceMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.instanceMatrix;
    }
}
ThInstancedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThInstancedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThInstancedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThInstancedMesh, selector: "th-instancedMesh", inputs: { boundingBox: "boundingBox", boundingSphere: "boundingSphere", count: "count", instanceColor: "instanceColor", instanceMatrix: "instanceMatrix" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThInstancedMesh) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThInstancedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-instancedMesh',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThInstancedMesh) }]
                }]
        }], propDecorators: { boundingBox: [{
                type: Input
            }], boundingSphere: [{
                type: Input
            }], count: [{
                type: Input
            }], instanceColor: [{
                type: Input
            }], instanceMatrix: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLatheGeometry extends ThBufferGeometry {
    getType() {
        return LatheGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThLatheGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLatheGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLatheGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLatheGeometry, selector: "th-latheGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThLatheGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLatheGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-latheGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThLatheGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLightningStrike extends ThBufferGeometry {
    getType() {
        return LightningStrike;
    }
    set state(value) {
        if (this._objRef) {
            this._objRef.state = value;
        }
    }
    // @ts-ignore
    get state() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.state;
    }
}
ThLightningStrike.RAY_INITIALIZED = LightningStrike.RAY_INITIALIZED;
ThLightningStrike.RAY_UNBORN = LightningStrike.RAY_UNBORN;
ThLightningStrike.RAY_PROPAGATING = LightningStrike.RAY_PROPAGATING;
ThLightningStrike.RAY_STEADY = LightningStrike.RAY_STEADY;
ThLightningStrike.RAY_VANISHING = LightningStrike.RAY_VANISHING;
ThLightningStrike.RAY_EXTINGUISHED = LightningStrike.RAY_EXTINGUISHED;
ThLightningStrike.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLightningStrike, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLightningStrike.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLightningStrike, selector: "th-lightningStrike", inputs: { state: "state" }, providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThLightningStrike)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLightningStrike, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lightningStrike',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThLightningStrike)
                        }
                    ]
                }]
        }], propDecorators: { state: [{
                type: Input
            }] } });

// eslint-disable-next-line @angular-eslint/component-class-suffix
class ThMaterialBase extends ThWrapperBase {
    constructor(parent) {
        super();
        this.parent = parent;
    }
    addToParent() {
        if (!this.parent.objRef) {
            throw new Error("parent object doesn't hold a three js object instance");
        }
        this.parent.objRef.material = this.objRef;
    }
    removeFromParent() {
        if (this._objRef && this.parent && this.parent.objRef) {
            this.parent.objRef.material = undefined;
        }
    }
}
ThMaterialBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaterialBase, deps: [{ token: ThObject3D }], target: i0.ɵɵFactoryTarget.Component });
ThMaterialBase.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMaterialBase, selector: "th-abs-material", usesInheritance: true, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaterialBase, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-abs-material',
                    template: ''
                }]
        }], ctorParameters: function () { return [{ type: ThObject3D }]; } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMaterial extends ThMaterialBase {
    getType() {
        return Material;
    }
    set alphaTest(value) {
        if (this._objRef) {
            this._objRef.alphaTest = value;
        }
    }
    // @ts-ignore
    get alphaTest() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaTest;
    }
    set alphaToCoverage(value) {
        if (this._objRef) {
            this._objRef.alphaToCoverage = value;
        }
    }
    // @ts-ignore
    get alphaToCoverage() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaToCoverage;
    }
    set blendDst(value) {
        if (this._objRef) {
            this._objRef.blendDst = value;
        }
    }
    // @ts-ignore
    get blendDst() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendDst;
    }
    set blendDstAlpha(value) {
        if (this._objRef) {
            this._objRef.blendDstAlpha = value;
        }
    }
    // @ts-ignore
    get blendDstAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendDstAlpha;
    }
    set blendEquation(value) {
        if (this._objRef) {
            this._objRef.blendEquation = value;
        }
    }
    // @ts-ignore
    get blendEquation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendEquation;
    }
    set blendEquationAlpha(value) {
        if (this._objRef) {
            this._objRef.blendEquationAlpha = value;
        }
    }
    // @ts-ignore
    get blendEquationAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendEquationAlpha;
    }
    set blending(value) {
        if (this._objRef) {
            this._objRef.blending = value;
        }
    }
    // @ts-ignore
    get blending() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blending;
    }
    set blendSrc(value) {
        if (this._objRef) {
            this._objRef.blendSrc = value;
        }
    }
    // @ts-ignore
    get blendSrc() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendSrc;
    }
    set blendSrcAlpha(value) {
        if (this._objRef) {
            this._objRef.blendSrcAlpha = value;
        }
    }
    // @ts-ignore
    get blendSrcAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blendSrcAlpha;
    }
    set clipIntersection(value) {
        if (this._objRef) {
            this._objRef.clipIntersection = value;
        }
    }
    // @ts-ignore
    get clipIntersection() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clipIntersection;
    }
    set clippingPlanes(value) {
        if (this._objRef) {
            this._objRef.clippingPlanes = value;
        }
    }
    // @ts-ignore
    get clippingPlanes() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clippingPlanes;
    }
    set clipShadows(value) {
        if (this._objRef) {
            this._objRef.clipShadows = value;
        }
    }
    // @ts-ignore
    get clipShadows() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clipShadows;
    }
    set colorWrite(value) {
        if (this._objRef) {
            this._objRef.colorWrite = value;
        }
    }
    // @ts-ignore
    get colorWrite() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.colorWrite;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set depthFunc(value) {
        if (this._objRef) {
            this._objRef.depthFunc = value;
        }
    }
    // @ts-ignore
    get depthFunc() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthFunc;
    }
    set depthTest(value) {
        if (this._objRef) {
            this._objRef.depthTest = value;
        }
    }
    // @ts-ignore
    get depthTest() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthTest;
    }
    set depthWrite(value) {
        if (this._objRef) {
            this._objRef.depthWrite = value;
        }
    }
    // @ts-ignore
    get depthWrite() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthWrite;
    }
    set id(value) {
        if (this._objRef) {
            this._objRef.id = value;
        }
    }
    // @ts-ignore
    get id() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.id;
    }
    set stencilWrite(value) {
        if (this._objRef) {
            this._objRef.stencilWrite = value;
        }
    }
    // @ts-ignore
    get stencilWrite() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilWrite;
    }
    set stencilFunc(value) {
        if (this._objRef) {
            this._objRef.stencilFunc = value;
        }
    }
    // @ts-ignore
    get stencilFunc() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilFunc;
    }
    set stencilRef(value) {
        if (this._objRef) {
            this._objRef.stencilRef = value;
        }
    }
    // @ts-ignore
    get stencilRef() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilRef;
    }
    set stencilWriteMask(value) {
        if (this._objRef) {
            this._objRef.stencilWriteMask = value;
        }
    }
    // @ts-ignore
    get stencilWriteMask() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilWriteMask;
    }
    set stencilFuncMask(value) {
        if (this._objRef) {
            this._objRef.stencilFuncMask = value;
        }
    }
    // @ts-ignore
    get stencilFuncMask() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilFuncMask;
    }
    set stencilFail(value) {
        if (this._objRef) {
            this._objRef.stencilFail = value;
        }
    }
    // @ts-ignore
    get stencilFail() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilFail;
    }
    set stencilZFail(value) {
        if (this._objRef) {
            this._objRef.stencilZFail = value;
        }
    }
    // @ts-ignore
    get stencilZFail() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilZFail;
    }
    set stencilZPass(value) {
        if (this._objRef) {
            this._objRef.stencilZPass = value;
        }
    }
    // @ts-ignore
    get stencilZPass() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.stencilZPass;
    }
    // @ts-ignore
    get isMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isMaterial;
    }
    set name(value) {
        if (this._objRef) {
            this._objRef.name = value;
        }
    }
    // @ts-ignore
    get name() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.name;
    }
    set needsUpdate(value) {
        if (this._objRef) {
            this._objRef.needsUpdate = value;
        }
    }
    // @ts-ignore
    get needsUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.needsUpdate;
    }
    set opacity(value) {
        if (this._objRef) {
            this._objRef.opacity = value;
        }
    }
    // @ts-ignore
    get opacity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.opacity;
    }
    set polygonOffset(value) {
        if (this._objRef) {
            this._objRef.polygonOffset = value;
        }
    }
    // @ts-ignore
    get polygonOffset() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.polygonOffset;
    }
    set polygonOffsetFactor(value) {
        if (this._objRef) {
            this._objRef.polygonOffsetFactor = value;
        }
    }
    // @ts-ignore
    get polygonOffsetFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.polygonOffsetFactor;
    }
    set polygonOffsetUnits(value) {
        if (this._objRef) {
            this._objRef.polygonOffsetUnits = value;
        }
    }
    // @ts-ignore
    get polygonOffsetUnits() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.polygonOffsetUnits;
    }
    set precision(value) {
        if (this._objRef) {
            this._objRef.precision = value;
        }
    }
    // @ts-ignore
    get precision() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.precision;
    }
    set premultipliedAlpha(value) {
        if (this._objRef) {
            this._objRef.premultipliedAlpha = value;
        }
    }
    // @ts-ignore
    get premultipliedAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.premultipliedAlpha;
    }
    set forceSinglePass(value) {
        if (this._objRef) {
            this._objRef.forceSinglePass = value;
        }
    }
    // @ts-ignore
    get forceSinglePass() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.forceSinglePass;
    }
    set dithering(value) {
        if (this._objRef) {
            this._objRef.dithering = value;
        }
    }
    // @ts-ignore
    get dithering() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dithering;
    }
    set side(value) {
        if (this._objRef) {
            this._objRef.side = value;
        }
    }
    // @ts-ignore
    get side() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.side;
    }
    set shadowSide(value) {
        if (this._objRef) {
            this._objRef.shadowSide = value;
        }
    }
    // @ts-ignore
    get shadowSide() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shadowSide;
    }
    set toneMapped(value) {
        if (this._objRef) {
            this._objRef.toneMapped = value;
        }
    }
    // @ts-ignore
    get toneMapped() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.toneMapped;
    }
    set transparent(value) {
        if (this._objRef) {
            this._objRef.transparent = value;
        }
    }
    // @ts-ignore
    get transparent() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transparent;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set uuid(value) {
        if (this._objRef) {
            this._objRef.uuid = value;
        }
    }
    // @ts-ignore
    get uuid() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uuid;
    }
    set vertexColors(value) {
        if (this._objRef) {
            this._objRef.vertexColors = value;
        }
    }
    // @ts-ignore
    get vertexColors() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.vertexColors;
    }
    set visible(value) {
        if (this._objRef) {
            this._objRef.visible = value;
        }
    }
    // @ts-ignore
    get visible() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.visible;
    }
    set userData(value) {
        if (this._objRef) {
            this._objRef.userData = value;
        }
    }
    // @ts-ignore
    get userData() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.userData;
    }
    set version(value) {
        if (this._objRef) {
            this._objRef.version = value;
        }
    }
    // @ts-ignore
    get version() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.version;
    }
    constructor(hostObject) {
        super(hostObject);
    }
}
ThMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaterial, deps: [{ token: ThObject3D, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component });
ThMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMaterial, selector: "th-material", inputs: { alphaTest: "alphaTest", alphaToCoverage: "alphaToCoverage", blendDst: "blendDst", blendDstAlpha: "blendDstAlpha", blendEquation: "blendEquation", blendEquationAlpha: "blendEquationAlpha", blending: "blending", blendSrc: "blendSrc", blendSrcAlpha: "blendSrcAlpha", clipIntersection: "clipIntersection", clippingPlanes: "clippingPlanes", clipShadows: "clipShadows", colorWrite: "colorWrite", defines: "defines", depthFunc: "depthFunc", depthTest: "depthTest", depthWrite: "depthWrite", id: "id", stencilWrite: "stencilWrite", stencilFunc: "stencilFunc", stencilRef: "stencilRef", stencilWriteMask: "stencilWriteMask", stencilFuncMask: "stencilFuncMask", stencilFail: "stencilFail", stencilZFail: "stencilZFail", stencilZPass: "stencilZPass", name: "name", needsUpdate: "needsUpdate", opacity: "opacity", polygonOffset: "polygonOffset", polygonOffsetFactor: "polygonOffsetFactor", polygonOffsetUnits: "polygonOffsetUnits", precision: "precision", premultipliedAlpha: "premultipliedAlpha", forceSinglePass: "forceSinglePass", dithering: "dithering", side: "side", shadowSide: "shadowSide", toneMapped: "toneMapped", transparent: "transparent", type: "type", uuid: "uuid", vertexColors: "vertexColors", visible: "visible", userData: "userData", version: "version" }, providers: [], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-material',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: []
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: SkipSelf
                    }] }];
    }, propDecorators: { alphaTest: [{
                type: Input
            }], alphaToCoverage: [{
                type: Input
            }], blendDst: [{
                type: Input
            }], blendDstAlpha: [{
                type: Input
            }], blendEquation: [{
                type: Input
            }], blendEquationAlpha: [{
                type: Input
            }], blending: [{
                type: Input
            }], blendSrc: [{
                type: Input
            }], blendSrcAlpha: [{
                type: Input
            }], clipIntersection: [{
                type: Input
            }], clippingPlanes: [{
                type: Input
            }], clipShadows: [{
                type: Input
            }], colorWrite: [{
                type: Input
            }], defines: [{
                type: Input
            }], depthFunc: [{
                type: Input
            }], depthTest: [{
                type: Input
            }], depthWrite: [{
                type: Input
            }], id: [{
                type: Input
            }], stencilWrite: [{
                type: Input
            }], stencilFunc: [{
                type: Input
            }], stencilRef: [{
                type: Input
            }], stencilWriteMask: [{
                type: Input
            }], stencilFuncMask: [{
                type: Input
            }], stencilFail: [{
                type: Input
            }], stencilZFail: [{
                type: Input
            }], stencilZPass: [{
                type: Input
            }], name: [{
                type: Input
            }], needsUpdate: [{
                type: Input
            }], opacity: [{
                type: Input
            }], polygonOffset: [{
                type: Input
            }], polygonOffsetFactor: [{
                type: Input
            }], polygonOffsetUnits: [{
                type: Input
            }], precision: [{
                type: Input
            }], premultipliedAlpha: [{
                type: Input
            }], forceSinglePass: [{
                type: Input
            }], dithering: [{
                type: Input
            }], side: [{
                type: Input
            }], shadowSide: [{
                type: Input
            }], toneMapped: [{
                type: Input
            }], transparent: [{
                type: Input
            }], type: [{
                type: Input
            }], uuid: [{
                type: Input
            }], vertexColors: [{
                type: Input
            }], visible: [{
                type: Input
            }], userData: [{
                type: Input
            }], version: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLineBasicMaterial extends ThMaterial {
    getType() {
        return LineBasicMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
    set linewidth(value) {
        if (this._objRef) {
            this._objRef.linewidth = value;
        }
    }
    // @ts-ignore
    get linewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.linewidth;
    }
    set linecap(value) {
        if (this._objRef) {
            this._objRef.linecap = value;
        }
    }
    // @ts-ignore
    get linecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.linecap;
    }
    set linejoin(value) {
        if (this._objRef) {
            this._objRef.linejoin = value;
        }
    }
    // @ts-ignore
    get linejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.linejoin;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
}
ThLineBasicMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineBasicMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLineBasicMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLineBasicMaterial, selector: "th-lineBasicMaterial", inputs: { type: "type", color: "color", fog: "fog", linewidth: "linewidth", linecap: "linecap", linejoin: "linejoin", map: "map" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThLineBasicMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineBasicMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lineBasicMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThLineBasicMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], fog: [{
                type: Input
            }], linewidth: [{
                type: Input
            }], linecap: [{
                type: Input
            }], linejoin: [{
                type: Input
            }], map: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLineDashedMaterial extends ThLineBasicMaterial {
    getType() {
        return LineDashedMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set scale(value) {
        if (this._objRef) {
            this._objRef.scale = value;
        }
    }
    // @ts-ignore
    get scale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scale;
    }
    set dashSize(value) {
        if (this._objRef) {
            this._objRef.dashSize = value;
        }
    }
    // @ts-ignore
    get dashSize() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dashSize;
    }
    set gapSize(value) {
        if (this._objRef) {
            this._objRef.gapSize = value;
        }
    }
    // @ts-ignore
    get gapSize() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.gapSize;
    }
    // @ts-ignore
    get isLineDashedMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLineDashedMaterial;
    }
}
ThLineDashedMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineDashedMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLineDashedMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLineDashedMaterial, selector: "th-lineDashedMaterial", inputs: { type: "type", scale: "scale", dashSize: "dashSize", gapSize: "gapSize" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThLineDashedMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineDashedMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lineDashedMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThLineDashedMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], scale: [{
                type: Input
            }], dashSize: [{
                type: Input
            }], gapSize: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLineLoop extends ThLine {
    getType() {
        return LineLoop;
    }
    // @ts-ignore
    get isLineLoop() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLineLoop;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThLineLoop.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineLoop, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLineLoop.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLineLoop, selector: "th-lineLoop", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLineLoop) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLineLoop, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lineLoop',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLineLoop) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThLOD extends ThObject3D {
    getType() {
        return LOD;
    }
    // @ts-ignore
    get isLOD() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLOD;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set levels(value) {
        if (this._objRef) {
            this._objRef.levels = value;
        }
    }
    // @ts-ignore
    get levels() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.levels;
    }
    set autoUpdate(value) {
        if (this._objRef) {
            this._objRef.autoUpdate = value;
        }
    }
    // @ts-ignore
    get autoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoUpdate;
    }
}
ThLOD.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLOD, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLOD.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLOD, selector: "th-lOD", inputs: { levels: "levels", autoUpdate: "autoUpdate" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLOD) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLOD, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lOD',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThLOD) }]
                }]
        }], propDecorators: { levels: [{
                type: Input
            }], autoUpdate: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThShaderPass extends ThPass {
    getType() {
        return ShaderPass;
    }
    set textureID(value) {
        if (this._objRef) {
            this._objRef.textureID = value;
        }
    }
    // @ts-ignore
    get textureID() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.textureID;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThShaderPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShaderPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThShaderPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThShaderPass, selector: "th-shaderPass", inputs: { textureID: "textureID", uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThShaderPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShaderPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-shaderPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThShaderPass) }]
                }]
        }], propDecorators: { textureID: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThLUTPass extends ThShaderPass {
    getType() {
        return LUTPass;
    }
    set lut(value) {
        if (this._objRef) {
            this._objRef.lut = value;
        }
    }
    // @ts-ignore
    get lut() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lut;
    }
    set intensity(value) {
        if (this._objRef) {
            this._objRef.intensity = value;
        }
    }
    // @ts-ignore
    get intensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.intensity;
    }
}
ThLUTPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLUTPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThLUTPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThLUTPass, selector: "th-lUTPass", inputs: { lut: "lut", intensity: "intensity" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThLUTPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLUTPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-lUTPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThLUTPass) }]
                }]
        }], propDecorators: { lut: [{
                type: Input
            }], intensity: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThOrbitControls extends ThControlBase {
    getType() {
        return OrbitControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set target(value) {
        if (this._objRef) {
            this._objRef.target = applyValue(this._objRef.target, value);
        }
    }
    // @ts-ignore
    get target() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target;
    }
    set center(value) {
        if (this._objRef) {
            this._objRef.center = applyValue(this._objRef.center, value);
        }
    }
    // @ts-ignore
    get center() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.center;
    }
    set minDistance(value) {
        if (this._objRef) {
            this._objRef.minDistance = value;
        }
    }
    // @ts-ignore
    get minDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minDistance;
    }
    set maxDistance(value) {
        if (this._objRef) {
            this._objRef.maxDistance = value;
        }
    }
    // @ts-ignore
    get maxDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxDistance;
    }
    set minZoom(value) {
        if (this._objRef) {
            this._objRef.minZoom = value;
        }
    }
    // @ts-ignore
    get minZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minZoom;
    }
    set maxZoom(value) {
        if (this._objRef) {
            this._objRef.maxZoom = value;
        }
    }
    // @ts-ignore
    get maxZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxZoom;
    }
    set minPolarAngle(value) {
        if (this._objRef) {
            this._objRef.minPolarAngle = value;
        }
    }
    // @ts-ignore
    get minPolarAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minPolarAngle;
    }
    set maxPolarAngle(value) {
        if (this._objRef) {
            this._objRef.maxPolarAngle = value;
        }
    }
    // @ts-ignore
    get maxPolarAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxPolarAngle;
    }
    set minAzimuthAngle(value) {
        if (this._objRef) {
            this._objRef.minAzimuthAngle = value;
        }
    }
    // @ts-ignore
    get minAzimuthAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minAzimuthAngle;
    }
    set maxAzimuthAngle(value) {
        if (this._objRef) {
            this._objRef.maxAzimuthAngle = value;
        }
    }
    // @ts-ignore
    get maxAzimuthAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxAzimuthAngle;
    }
    set enableDamping(value) {
        if (this._objRef) {
            this._objRef.enableDamping = value;
        }
    }
    // @ts-ignore
    get enableDamping() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableDamping;
    }
    set dampingFactor(value) {
        if (this._objRef) {
            this._objRef.dampingFactor = value;
        }
    }
    // @ts-ignore
    get dampingFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dampingFactor;
    }
    set enableZoom(value) {
        if (this._objRef) {
            this._objRef.enableZoom = value;
        }
    }
    // @ts-ignore
    get enableZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableZoom;
    }
    set zoomSpeed(value) {
        if (this._objRef) {
            this._objRef.zoomSpeed = value;
        }
    }
    // @ts-ignore
    get zoomSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.zoomSpeed;
    }
    set enableRotate(value) {
        if (this._objRef) {
            this._objRef.enableRotate = value;
        }
    }
    // @ts-ignore
    get enableRotate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enableRotate;
    }
    set rotateSpeed(value) {
        if (this._objRef) {
            this._objRef.rotateSpeed = value;
        }
    }
    // @ts-ignore
    get rotateSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotateSpeed;
    }
    set enablePan(value) {
        if (this._objRef) {
            this._objRef.enablePan = value;
        }
    }
    // @ts-ignore
    get enablePan() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enablePan;
    }
    set panSpeed(value) {
        if (this._objRef) {
            this._objRef.panSpeed = value;
        }
    }
    // @ts-ignore
    get panSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.panSpeed;
    }
    set screenSpacePanning(value) {
        if (this._objRef) {
            this._objRef.screenSpacePanning = value;
        }
    }
    // @ts-ignore
    get screenSpacePanning() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.screenSpacePanning;
    }
    set keyPanSpeed(value) {
        if (this._objRef) {
            this._objRef.keyPanSpeed = value;
        }
    }
    // @ts-ignore
    get keyPanSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.keyPanSpeed;
    }
    set autoRotate(value) {
        if (this._objRef) {
            this._objRef.autoRotate = value;
        }
    }
    // @ts-ignore
    get autoRotate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoRotate;
    }
    set autoRotateSpeed(value) {
        if (this._objRef) {
            this._objRef.autoRotateSpeed = value;
        }
    }
    // @ts-ignore
    get autoRotateSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.autoRotateSpeed;
    }
    set keys(value) {
        if (this._objRef) {
            this._objRef.keys = value;
        }
    }
    // @ts-ignore
    get keys() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.keys;
    }
    set mouseButtons(value) {
        if (this._objRef) {
            this._objRef.mouseButtons = value;
        }
    }
    // @ts-ignore
    get mouseButtons() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mouseButtons;
    }
    set touches(value) {
        if (this._objRef) {
            this._objRef.touches = value;
        }
    }
    // @ts-ignore
    get touches() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.touches;
    }
    set target0(value) {
        if (this._objRef) {
            this._objRef.target0 = applyValue(this._objRef.target0, value);
        }
    }
    // @ts-ignore
    get target0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target0;
    }
    set position0(value) {
        if (this._objRef) {
            this._objRef.position0 = applyValue(this._objRef.position0, value);
        }
    }
    // @ts-ignore
    get position0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position0;
    }
    set zoom0(value) {
        if (this._objRef) {
            this._objRef.zoom0 = value;
        }
    }
    // @ts-ignore
    get zoom0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.zoom0;
    }
}
ThOrbitControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOrbitControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThOrbitControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThOrbitControls, selector: "th-orbitControls", inputs: { object: "object", domElement: "domElement", enabled: "enabled", target: "target", center: "center", minDistance: "minDistance", maxDistance: "maxDistance", minZoom: "minZoom", maxZoom: "maxZoom", minPolarAngle: "minPolarAngle", maxPolarAngle: "maxPolarAngle", minAzimuthAngle: "minAzimuthAngle", maxAzimuthAngle: "maxAzimuthAngle", enableDamping: "enableDamping", dampingFactor: "dampingFactor", enableZoom: "enableZoom", zoomSpeed: "zoomSpeed", enableRotate: "enableRotate", rotateSpeed: "rotateSpeed", enablePan: "enablePan", panSpeed: "panSpeed", screenSpacePanning: "screenSpacePanning", keyPanSpeed: "keyPanSpeed", autoRotate: "autoRotate", autoRotateSpeed: "autoRotateSpeed", keys: "keys", mouseButtons: "mouseButtons", touches: "touches", target0: "target0", position0: "position0", zoom0: "zoom0" }, providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThOrbitControls) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOrbitControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-orbitControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThOrbitControls) }]
                }]
        }], propDecorators: { object: [{
                type: Input
            }], domElement: [{
                type: Input
            }], enabled: [{
                type: Input
            }], target: [{
                type: Input
            }], center: [{
                type: Input
            }], minDistance: [{
                type: Input
            }], maxDistance: [{
                type: Input
            }], minZoom: [{
                type: Input
            }], maxZoom: [{
                type: Input
            }], minPolarAngle: [{
                type: Input
            }], maxPolarAngle: [{
                type: Input
            }], minAzimuthAngle: [{
                type: Input
            }], maxAzimuthAngle: [{
                type: Input
            }], enableDamping: [{
                type: Input
            }], dampingFactor: [{
                type: Input
            }], enableZoom: [{
                type: Input
            }], zoomSpeed: [{
                type: Input
            }], enableRotate: [{
                type: Input
            }], rotateSpeed: [{
                type: Input
            }], enablePan: [{
                type: Input
            }], panSpeed: [{
                type: Input
            }], screenSpacePanning: [{
                type: Input
            }], keyPanSpeed: [{
                type: Input
            }], autoRotate: [{
                type: Input
            }], autoRotateSpeed: [{
                type: Input
            }], keys: [{
                type: Input
            }], mouseButtons: [{
                type: Input
            }], touches: [{
                type: Input
            }], target0: [{
                type: Input
            }], position0: [{
                type: Input
            }], zoom0: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMapControls extends ThOrbitControls {
    getType() {
        return MapControls;
    }
}
ThMapControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMapControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMapControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMapControls, selector: "th-mapControls", providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThMapControls) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMapControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-mapControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThControlBase, useExisting: forwardRef(() => ThMapControls) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThMaskPass extends ThPass {
    getType() {
        return MaskPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set inverse(value) {
        if (this._objRef) {
            this._objRef.inverse = value;
        }
    }
    // @ts-ignore
    get inverse() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.inverse;
    }
}
ThMaskPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaskPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMaskPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMaskPass, selector: "th-maskPass", inputs: { scene: "scene", camera: "camera", inverse: "inverse" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThMaskPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMaskPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-maskPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThMaskPass) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], inverse: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshBasicMaterial extends ThMaterial {
    getType() {
        return MeshBasicMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set lightMap(value) {
        if (this._objRef) {
            this._objRef.lightMap = value;
        }
    }
    // @ts-ignore
    get lightMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMap;
    }
    set lightMapIntensity(value) {
        if (this._objRef) {
            this._objRef.lightMapIntensity = value;
        }
    }
    // @ts-ignore
    get lightMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMapIntensity;
    }
    set aoMap(value) {
        if (this._objRef) {
            this._objRef.aoMap = value;
        }
    }
    // @ts-ignore
    get aoMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMap;
    }
    set aoMapIntensity(value) {
        if (this._objRef) {
            this._objRef.aoMapIntensity = value;
        }
    }
    // @ts-ignore
    get aoMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMapIntensity;
    }
    set specularMap(value) {
        if (this._objRef) {
            this._objRef.specularMap = value;
        }
    }
    // @ts-ignore
    get specularMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularMap;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set envMap(value) {
        if (this._objRef) {
            this._objRef.envMap = value;
        }
    }
    // @ts-ignore
    get envMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMap;
    }
    set combine(value) {
        if (this._objRef) {
            this._objRef.combine = value;
        }
    }
    // @ts-ignore
    get combine() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.combine;
    }
    set reflectivity(value) {
        if (this._objRef) {
            this._objRef.reflectivity = value;
        }
    }
    // @ts-ignore
    get reflectivity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.reflectivity;
    }
    set refractionRatio(value) {
        if (this._objRef) {
            this._objRef.refractionRatio = value;
        }
    }
    // @ts-ignore
    get refractionRatio() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.refractionRatio;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set wireframeLinecap(value) {
        if (this._objRef) {
            this._objRef.wireframeLinecap = value;
        }
    }
    // @ts-ignore
    get wireframeLinecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinecap;
    }
    set wireframeLinejoin(value) {
        if (this._objRef) {
            this._objRef.wireframeLinejoin = value;
        }
    }
    // @ts-ignore
    get wireframeLinejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinejoin;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshBasicMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshBasicMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshBasicMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshBasicMaterial, selector: "th-meshBasicMaterial", inputs: { type: "type", color: "color", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", specularMap: "specularMap", alphaMap: "alphaMap", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshBasicMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshBasicMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshBasicMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshBasicMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshDepthMaterial extends ThMaterial {
    getType() {
        return MeshDepthMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set depthPacking(value) {
        if (this._objRef) {
            this._objRef.depthPacking = value;
        }
    }
    // @ts-ignore
    get depthPacking() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthPacking;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshDepthMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshDepthMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshDepthMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshDepthMaterial, selector: "th-meshDepthMaterial", inputs: { type: "type", map: "map", alphaMap: "alphaMap", depthPacking: "depthPacking", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshDepthMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshDepthMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshDepthMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshDepthMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], depthPacking: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshDistanceMaterial extends ThMaterial {
    getType() {
        return MeshDistanceMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshDistanceMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshDistanceMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshDistanceMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshDistanceMaterial, selector: "th-meshDistanceMaterial", inputs: { type: "type", map: "map", alphaMap: "alphaMap", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", fog: "fog" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshDistanceMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshDistanceMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshDistanceMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshDistanceMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshLambertMaterial extends ThMaterial {
    getType() {
        return MeshLambertMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set emissive(value) {
        if (this._objRef) {
            this._objRef.emissive = applyValue(this._objRef.emissive, value);
        }
    }
    // @ts-ignore
    get emissive() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissive;
    }
    set emissiveIntensity(value) {
        if (this._objRef) {
            this._objRef.emissiveIntensity = value;
        }
    }
    // @ts-ignore
    get emissiveIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveIntensity;
    }
    set emissiveMap(value) {
        if (this._objRef) {
            this._objRef.emissiveMap = value;
        }
    }
    // @ts-ignore
    get emissiveMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveMap;
    }
    set flatShading(value) {
        if (this._objRef) {
            this._objRef.flatShading = value;
        }
    }
    // @ts-ignore
    get flatShading() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flatShading;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set lightMap(value) {
        if (this._objRef) {
            this._objRef.lightMap = value;
        }
    }
    // @ts-ignore
    get lightMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMap;
    }
    set lightMapIntensity(value) {
        if (this._objRef) {
            this._objRef.lightMapIntensity = value;
        }
    }
    // @ts-ignore
    get lightMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMapIntensity;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set aoMap(value) {
        if (this._objRef) {
            this._objRef.aoMap = value;
        }
    }
    // @ts-ignore
    get aoMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMap;
    }
    set aoMapIntensity(value) {
        if (this._objRef) {
            this._objRef.aoMapIntensity = value;
        }
    }
    // @ts-ignore
    get aoMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMapIntensity;
    }
    set specularMap(value) {
        if (this._objRef) {
            this._objRef.specularMap = value;
        }
    }
    // @ts-ignore
    get specularMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularMap;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set envMap(value) {
        if (this._objRef) {
            this._objRef.envMap = value;
        }
    }
    // @ts-ignore
    get envMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMap;
    }
    set combine(value) {
        if (this._objRef) {
            this._objRef.combine = value;
        }
    }
    // @ts-ignore
    get combine() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.combine;
    }
    set reflectivity(value) {
        if (this._objRef) {
            this._objRef.reflectivity = value;
        }
    }
    // @ts-ignore
    get reflectivity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.reflectivity;
    }
    set refractionRatio(value) {
        if (this._objRef) {
            this._objRef.refractionRatio = value;
        }
    }
    // @ts-ignore
    get refractionRatio() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.refractionRatio;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set wireframeLinecap(value) {
        if (this._objRef) {
            this._objRef.wireframeLinecap = value;
        }
    }
    // @ts-ignore
    get wireframeLinecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinecap;
    }
    set wireframeLinejoin(value) {
        if (this._objRef) {
            this._objRef.wireframeLinejoin = value;
        }
    }
    // @ts-ignore
    get wireframeLinejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinejoin;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshLambertMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshLambertMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshLambertMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshLambertMaterial, selector: "th-meshLambertMaterial", inputs: { type: "type", color: "color", bumpMap: "bumpMap", bumpScale: "bumpScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", flatShading: "flatShading", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", specularMap: "specularMap", alphaMap: "alphaMap", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshLambertMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshLambertMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshLambertMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshLambertMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], flatShading: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshMatcapMaterial extends ThMaterial {
    getType() {
        return MeshMatcapMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set matcap(value) {
        if (this._objRef) {
            this._objRef.matcap = value;
        }
    }
    // @ts-ignore
    get matcap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matcap;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set flatShading(value) {
        if (this._objRef) {
            this._objRef.flatShading = value;
        }
    }
    // @ts-ignore
    get flatShading() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flatShading;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshMatcapMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshMatcapMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshMatcapMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshMatcapMaterial, selector: "th-meshMatcapMaterial", inputs: { type: "type", defines: "defines", color: "color", matcap: "matcap", map: "map", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", alphaMap: "alphaMap", flatShading: "flatShading", fog: "fog" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshMatcapMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshMatcapMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshMatcapMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshMatcapMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], defines: [{
                type: Input
            }], color: [{
                type: Input
            }], matcap: [{
                type: Input
            }], map: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], flatShading: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshNormalMaterial extends ThMaterial {
    getType() {
        return MeshNormalMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set flatShading(value) {
        if (this._objRef) {
            this._objRef.flatShading = value;
        }
    }
    // @ts-ignore
    get flatShading() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flatShading;
    }
}
ThMeshNormalMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshNormalMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshNormalMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshNormalMaterial, selector: "th-meshNormalMaterial", inputs: { type: "type", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", flatShading: "flatShading" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshNormalMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshNormalMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshNormalMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshNormalMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], flatShading: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshPhongMaterial extends ThMaterial {
    getType() {
        return MeshPhongMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set specular(value) {
        if (this._objRef) {
            this._objRef.specular = applyValue(this._objRef.specular, value);
        }
    }
    // @ts-ignore
    get specular() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specular;
    }
    set shininess(value) {
        if (this._objRef) {
            this._objRef.shininess = value;
        }
    }
    // @ts-ignore
    get shininess() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shininess;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set lightMap(value) {
        if (this._objRef) {
            this._objRef.lightMap = value;
        }
    }
    // @ts-ignore
    get lightMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMap;
    }
    set lightMapIntensity(value) {
        if (this._objRef) {
            this._objRef.lightMapIntensity = value;
        }
    }
    // @ts-ignore
    get lightMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMapIntensity;
    }
    set aoMap(value) {
        if (this._objRef) {
            this._objRef.aoMap = value;
        }
    }
    // @ts-ignore
    get aoMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMap;
    }
    set aoMapIntensity(value) {
        if (this._objRef) {
            this._objRef.aoMapIntensity = value;
        }
    }
    // @ts-ignore
    get aoMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMapIntensity;
    }
    set emissive(value) {
        if (this._objRef) {
            this._objRef.emissive = applyValue(this._objRef.emissive, value);
        }
    }
    // @ts-ignore
    get emissive() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissive;
    }
    set emissiveIntensity(value) {
        if (this._objRef) {
            this._objRef.emissiveIntensity = value;
        }
    }
    // @ts-ignore
    get emissiveIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveIntensity;
    }
    set emissiveMap(value) {
        if (this._objRef) {
            this._objRef.emissiveMap = value;
        }
    }
    // @ts-ignore
    get emissiveMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveMap;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set specularMap(value) {
        if (this._objRef) {
            this._objRef.specularMap = value;
        }
    }
    // @ts-ignore
    get specularMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularMap;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set envMap(value) {
        if (this._objRef) {
            this._objRef.envMap = value;
        }
    }
    // @ts-ignore
    get envMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMap;
    }
    set combine(value) {
        if (this._objRef) {
            this._objRef.combine = value;
        }
    }
    // @ts-ignore
    get combine() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.combine;
    }
    set reflectivity(value) {
        if (this._objRef) {
            this._objRef.reflectivity = value;
        }
    }
    // @ts-ignore
    get reflectivity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.reflectivity;
    }
    set refractionRatio(value) {
        if (this._objRef) {
            this._objRef.refractionRatio = value;
        }
    }
    // @ts-ignore
    get refractionRatio() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.refractionRatio;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set wireframeLinecap(value) {
        if (this._objRef) {
            this._objRef.wireframeLinecap = value;
        }
    }
    // @ts-ignore
    get wireframeLinecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinecap;
    }
    set wireframeLinejoin(value) {
        if (this._objRef) {
            this._objRef.wireframeLinejoin = value;
        }
    }
    // @ts-ignore
    get wireframeLinejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinejoin;
    }
    set flatShading(value) {
        if (this._objRef) {
            this._objRef.flatShading = value;
        }
    }
    // @ts-ignore
    get flatShading() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flatShading;
    }
    set metal(value) {
        if (this._objRef) {
            this._objRef.metal = value;
        }
    }
    // @ts-ignore
    get metal() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metal;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshPhongMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshPhongMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshPhongMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshPhongMaterial, selector: "th-meshPhongMaterial", inputs: { type: "type", color: "color", specular: "specular", shininess: "shininess", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", specularMap: "specularMap", alphaMap: "alphaMap", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", flatShading: "flatShading", metal: "metal", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshPhongMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshPhongMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshPhongMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshPhongMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], specular: [{
                type: Input
            }], shininess: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], flatShading: [{
                type: Input
            }], metal: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshStandardMaterial extends ThMaterial {
    getType() {
        return MeshStandardMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set roughness(value) {
        if (this._objRef) {
            this._objRef.roughness = value;
        }
    }
    // @ts-ignore
    get roughness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.roughness;
    }
    set metalness(value) {
        if (this._objRef) {
            this._objRef.metalness = value;
        }
    }
    // @ts-ignore
    get metalness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metalness;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set lightMap(value) {
        if (this._objRef) {
            this._objRef.lightMap = value;
        }
    }
    // @ts-ignore
    get lightMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMap;
    }
    set lightMapIntensity(value) {
        if (this._objRef) {
            this._objRef.lightMapIntensity = value;
        }
    }
    // @ts-ignore
    get lightMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMapIntensity;
    }
    set aoMap(value) {
        if (this._objRef) {
            this._objRef.aoMap = value;
        }
    }
    // @ts-ignore
    get aoMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMap;
    }
    set aoMapIntensity(value) {
        if (this._objRef) {
            this._objRef.aoMapIntensity = value;
        }
    }
    // @ts-ignore
    get aoMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMapIntensity;
    }
    set emissive(value) {
        if (this._objRef) {
            this._objRef.emissive = applyValue(this._objRef.emissive, value);
        }
    }
    // @ts-ignore
    get emissive() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissive;
    }
    set emissiveIntensity(value) {
        if (this._objRef) {
            this._objRef.emissiveIntensity = value;
        }
    }
    // @ts-ignore
    get emissiveIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveIntensity;
    }
    set emissiveMap(value) {
        if (this._objRef) {
            this._objRef.emissiveMap = value;
        }
    }
    // @ts-ignore
    get emissiveMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveMap;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set roughnessMap(value) {
        if (this._objRef) {
            this._objRef.roughnessMap = value;
        }
    }
    // @ts-ignore
    get roughnessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.roughnessMap;
    }
    set metalnessMap(value) {
        if (this._objRef) {
            this._objRef.metalnessMap = value;
        }
    }
    // @ts-ignore
    get metalnessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metalnessMap;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set envMap(value) {
        if (this._objRef) {
            this._objRef.envMap = value;
        }
    }
    // @ts-ignore
    get envMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMap;
    }
    set envMapIntensity(value) {
        if (this._objRef) {
            this._objRef.envMapIntensity = value;
        }
    }
    // @ts-ignore
    get envMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.envMapIntensity;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set wireframeLinecap(value) {
        if (this._objRef) {
            this._objRef.wireframeLinecap = value;
        }
    }
    // @ts-ignore
    get wireframeLinecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinecap;
    }
    set wireframeLinejoin(value) {
        if (this._objRef) {
            this._objRef.wireframeLinejoin = value;
        }
    }
    // @ts-ignore
    get wireframeLinejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinejoin;
    }
    set flatShading(value) {
        if (this._objRef) {
            this._objRef.flatShading = value;
        }
    }
    // @ts-ignore
    get flatShading() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.flatShading;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
    set isMeshStandardMaterial(value) {
        if (this._objRef) {
            this._objRef.isMeshStandardMaterial = value;
        }
    }
    // @ts-ignore
    get isMeshStandardMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isMeshStandardMaterial;
    }
}
ThMeshStandardMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshStandardMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshStandardMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshStandardMaterial, selector: "th-meshStandardMaterial", inputs: { type: "type", defines: "defines", color: "color", roughness: "roughness", metalness: "metalness", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", roughnessMap: "roughnessMap", metalnessMap: "metalnessMap", alphaMap: "alphaMap", envMap: "envMap", envMapIntensity: "envMapIntensity", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", flatShading: "flatShading", fog: "fog", isMeshStandardMaterial: "isMeshStandardMaterial" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshStandardMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshStandardMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshStandardMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshStandardMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], defines: [{
                type: Input
            }], color: [{
                type: Input
            }], roughness: [{
                type: Input
            }], metalness: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], roughnessMap: [{
                type: Input
            }], metalnessMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], envMapIntensity: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], flatShading: [{
                type: Input
            }], fog: [{
                type: Input
            }], isMeshStandardMaterial: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshPhysicalMaterial extends ThMeshStandardMaterial {
    getType() {
        return MeshPhysicalMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set clearcoat(value) {
        if (this._objRef) {
            this._objRef.clearcoat = value;
        }
    }
    // @ts-ignore
    get clearcoat() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoat;
    }
    set clearcoatMap(value) {
        if (this._objRef) {
            this._objRef.clearcoatMap = value;
        }
    }
    // @ts-ignore
    get clearcoatMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoatMap;
    }
    set clearcoatRoughness(value) {
        if (this._objRef) {
            this._objRef.clearcoatRoughness = value;
        }
    }
    // @ts-ignore
    get clearcoatRoughness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoatRoughness;
    }
    set clearcoatRoughnessMap(value) {
        if (this._objRef) {
            this._objRef.clearcoatRoughnessMap = value;
        }
    }
    // @ts-ignore
    get clearcoatRoughnessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoatRoughnessMap;
    }
    set clearcoatNormalScale(value) {
        if (this._objRef) {
            this._objRef.clearcoatNormalScale = applyValue(this._objRef.clearcoatNormalScale, value);
        }
    }
    // @ts-ignore
    get clearcoatNormalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoatNormalScale;
    }
    set clearcoatNormalMap(value) {
        if (this._objRef) {
            this._objRef.clearcoatNormalMap = value;
        }
    }
    // @ts-ignore
    get clearcoatNormalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearcoatNormalMap;
    }
    set reflectivity(value) {
        if (this._objRef) {
            this._objRef.reflectivity = value;
        }
    }
    // @ts-ignore
    get reflectivity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.reflectivity;
    }
    set ior(value) {
        if (this._objRef) {
            this._objRef.ior = value;
        }
    }
    // @ts-ignore
    get ior() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.ior;
    }
    set sheen(value) {
        if (this._objRef) {
            this._objRef.sheen = value;
        }
    }
    // @ts-ignore
    get sheen() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sheen;
    }
    set sheenColor(value) {
        if (this._objRef) {
            this._objRef.sheenColor = applyValue(this._objRef.sheenColor, value);
        }
    }
    // @ts-ignore
    get sheenColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sheenColor;
    }
    set sheenColorMap(value) {
        if (this._objRef) {
            this._objRef.sheenColorMap = value;
        }
    }
    // @ts-ignore
    get sheenColorMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sheenColorMap;
    }
    set sheenRoughness(value) {
        if (this._objRef) {
            this._objRef.sheenRoughness = value;
        }
    }
    // @ts-ignore
    get sheenRoughness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sheenRoughness;
    }
    set sheenRoughnessMap(value) {
        if (this._objRef) {
            this._objRef.sheenRoughnessMap = value;
        }
    }
    // @ts-ignore
    get sheenRoughnessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sheenRoughnessMap;
    }
    set transmission(value) {
        if (this._objRef) {
            this._objRef.transmission = value;
        }
    }
    // @ts-ignore
    get transmission() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transmission;
    }
    set transmissionMap(value) {
        if (this._objRef) {
            this._objRef.transmissionMap = value;
        }
    }
    // @ts-ignore
    get transmissionMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transmissionMap;
    }
    set thickness(value) {
        if (this._objRef) {
            this._objRef.thickness = value;
        }
    }
    // @ts-ignore
    get thickness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.thickness;
    }
    set thicknessMap(value) {
        if (this._objRef) {
            this._objRef.thicknessMap = value;
        }
    }
    // @ts-ignore
    get thicknessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.thicknessMap;
    }
    set attenuationDistance(value) {
        if (this._objRef) {
            this._objRef.attenuationDistance = value;
        }
    }
    // @ts-ignore
    get attenuationDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.attenuationDistance;
    }
    set attenuationColor(value) {
        if (this._objRef) {
            this._objRef.attenuationColor = applyValue(this._objRef.attenuationColor, value);
        }
    }
    // @ts-ignore
    get attenuationColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.attenuationColor;
    }
    set specularIntensity(value) {
        if (this._objRef) {
            this._objRef.specularIntensity = value;
        }
    }
    // @ts-ignore
    get specularIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularIntensity;
    }
    set specularColor(value) {
        if (this._objRef) {
            this._objRef.specularColor = applyValue(this._objRef.specularColor, value);
        }
    }
    // @ts-ignore
    get specularColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularColor;
    }
    set specularIntensityMap(value) {
        if (this._objRef) {
            this._objRef.specularIntensityMap = value;
        }
    }
    // @ts-ignore
    get specularIntensityMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularIntensityMap;
    }
    set specularColorMap(value) {
        if (this._objRef) {
            this._objRef.specularColorMap = value;
        }
    }
    // @ts-ignore
    get specularColorMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.specularColorMap;
    }
    set iridescenceMap(value) {
        if (this._objRef) {
            this._objRef.iridescenceMap = value;
        }
    }
    // @ts-ignore
    get iridescenceMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.iridescenceMap;
    }
    set iridescenceIOR(value) {
        if (this._objRef) {
            this._objRef.iridescenceIOR = value;
        }
    }
    // @ts-ignore
    get iridescenceIOR() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.iridescenceIOR;
    }
    set iridescence(value) {
        if (this._objRef) {
            this._objRef.iridescence = value;
        }
    }
    // @ts-ignore
    get iridescence() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.iridescence;
    }
    set iridescenceThicknessRange(value) {
        if (this._objRef) {
            this._objRef.iridescenceThicknessRange = value;
        }
    }
    // @ts-ignore
    get iridescenceThicknessRange() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.iridescenceThicknessRange;
    }
    set iridescenceThicknessMap(value) {
        if (this._objRef) {
            this._objRef.iridescenceThicknessMap = value;
        }
    }
    // @ts-ignore
    get iridescenceThicknessMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.iridescenceThicknessMap;
    }
}
ThMeshPhysicalMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshPhysicalMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshPhysicalMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshPhysicalMaterial, selector: "th-meshPhysicalMaterial", inputs: { type: "type", defines: "defines", clearcoat: "clearcoat", clearcoatMap: "clearcoatMap", clearcoatRoughness: "clearcoatRoughness", clearcoatRoughnessMap: "clearcoatRoughnessMap", clearcoatNormalScale: "clearcoatNormalScale", clearcoatNormalMap: "clearcoatNormalMap", reflectivity: "reflectivity", ior: "ior", sheen: "sheen", sheenColor: "sheenColor", sheenColorMap: "sheenColorMap", sheenRoughness: "sheenRoughness", sheenRoughnessMap: "sheenRoughnessMap", transmission: "transmission", transmissionMap: "transmissionMap", thickness: "thickness", thicknessMap: "thicknessMap", attenuationDistance: "attenuationDistance", attenuationColor: "attenuationColor", specularIntensity: "specularIntensity", specularColor: "specularColor", specularIntensityMap: "specularIntensityMap", specularColorMap: "specularColorMap", iridescenceMap: "iridescenceMap", iridescenceIOR: "iridescenceIOR", iridescence: "iridescence", iridescenceThicknessRange: "iridescenceThicknessRange", iridescenceThicknessMap: "iridescenceThicknessMap" }, providers: [
        {
            provide: ThMaterial,
            useExisting: forwardRef(() => ThMeshPhysicalMaterial)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshPhysicalMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshPhysicalMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThMaterial,
                            useExisting: forwardRef(() => ThMeshPhysicalMaterial)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], defines: [{
                type: Input
            }], clearcoat: [{
                type: Input
            }], clearcoatMap: [{
                type: Input
            }], clearcoatRoughness: [{
                type: Input
            }], clearcoatRoughnessMap: [{
                type: Input
            }], clearcoatNormalScale: [{
                type: Input
            }], clearcoatNormalMap: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], ior: [{
                type: Input
            }], sheen: [{
                type: Input
            }], sheenColor: [{
                type: Input
            }], sheenColorMap: [{
                type: Input
            }], sheenRoughness: [{
                type: Input
            }], sheenRoughnessMap: [{
                type: Input
            }], transmission: [{
                type: Input
            }], transmissionMap: [{
                type: Input
            }], thickness: [{
                type: Input
            }], thicknessMap: [{
                type: Input
            }], attenuationDistance: [{
                type: Input
            }], attenuationColor: [{
                type: Input
            }], specularIntensity: [{
                type: Input
            }], specularColor: [{
                type: Input
            }], specularIntensityMap: [{
                type: Input
            }], specularColorMap: [{
                type: Input
            }], iridescenceMap: [{
                type: Input
            }], iridescenceIOR: [{
                type: Input
            }], iridescence: [{
                type: Input
            }], iridescenceThicknessRange: [{
                type: Input
            }], iridescenceThicknessMap: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThMeshToonMaterial extends ThMaterial {
    getType() {
        return MeshToonMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set gradientMap(value) {
        if (this._objRef) {
            this._objRef.gradientMap = value;
        }
    }
    // @ts-ignore
    get gradientMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.gradientMap;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set lightMap(value) {
        if (this._objRef) {
            this._objRef.lightMap = value;
        }
    }
    // @ts-ignore
    get lightMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMap;
    }
    set lightMapIntensity(value) {
        if (this._objRef) {
            this._objRef.lightMapIntensity = value;
        }
    }
    // @ts-ignore
    get lightMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lightMapIntensity;
    }
    set aoMap(value) {
        if (this._objRef) {
            this._objRef.aoMap = value;
        }
    }
    // @ts-ignore
    get aoMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMap;
    }
    set aoMapIntensity(value) {
        if (this._objRef) {
            this._objRef.aoMapIntensity = value;
        }
    }
    // @ts-ignore
    get aoMapIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aoMapIntensity;
    }
    set emissive(value) {
        if (this._objRef) {
            this._objRef.emissive = applyValue(this._objRef.emissive, value);
        }
    }
    // @ts-ignore
    get emissive() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissive;
    }
    set emissiveIntensity(value) {
        if (this._objRef) {
            this._objRef.emissiveIntensity = value;
        }
    }
    // @ts-ignore
    get emissiveIntensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveIntensity;
    }
    set emissiveMap(value) {
        if (this._objRef) {
            this._objRef.emissiveMap = value;
        }
    }
    // @ts-ignore
    get emissiveMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.emissiveMap;
    }
    set bumpMap(value) {
        if (this._objRef) {
            this._objRef.bumpMap = value;
        }
    }
    // @ts-ignore
    get bumpMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpMap;
    }
    set bumpScale(value) {
        if (this._objRef) {
            this._objRef.bumpScale = value;
        }
    }
    // @ts-ignore
    get bumpScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bumpScale;
    }
    set normalMap(value) {
        if (this._objRef) {
            this._objRef.normalMap = value;
        }
    }
    // @ts-ignore
    get normalMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMap;
    }
    set normalMapType(value) {
        if (this._objRef) {
            this._objRef.normalMapType = value;
        }
    }
    // @ts-ignore
    get normalMapType() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMapType;
    }
    set normalScale(value) {
        if (this._objRef) {
            this._objRef.normalScale = applyValue(this._objRef.normalScale, value);
        }
    }
    // @ts-ignore
    get normalScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalScale;
    }
    set displacementMap(value) {
        if (this._objRef) {
            this._objRef.displacementMap = value;
        }
    }
    // @ts-ignore
    get displacementMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementMap;
    }
    set displacementScale(value) {
        if (this._objRef) {
            this._objRef.displacementScale = value;
        }
    }
    // @ts-ignore
    get displacementScale() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementScale;
    }
    set displacementBias(value) {
        if (this._objRef) {
            this._objRef.displacementBias = value;
        }
    }
    // @ts-ignore
    get displacementBias() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.displacementBias;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set wireframeLinecap(value) {
        if (this._objRef) {
            this._objRef.wireframeLinecap = value;
        }
    }
    // @ts-ignore
    get wireframeLinecap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinecap;
    }
    set wireframeLinejoin(value) {
        if (this._objRef) {
            this._objRef.wireframeLinejoin = value;
        }
    }
    // @ts-ignore
    get wireframeLinejoin() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinejoin;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThMeshToonMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshToonMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThMeshToonMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThMeshToonMaterial, selector: "th-meshToonMaterial", inputs: { type: "type", defines: "defines", color: "color", gradientMap: "gradientMap", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", alphaMap: "alphaMap", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshToonMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThMeshToonMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-meshToonMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThMeshToonMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], defines: [{
                type: Input
            }], color: [{
                type: Input
            }], gradientMap: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThOctahedronGeometry extends ThPolyhedronGeometry {
    getType() {
        return OctahedronGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThOctahedronGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOctahedronGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThOctahedronGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThOctahedronGeometry, selector: "th-octahedronGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThOctahedronGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOctahedronGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-octahedronGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThOctahedronGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThOrthographicCamera extends ThCamera {
    getType() {
        return OrthographicCamera;
    }
    // @ts-ignore
    get isOrthographicCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isOrthographicCamera;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set zoom(value) {
        if (this._objRef) {
            this._objRef.zoom = value;
        }
    }
    // @ts-ignore
    get zoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.zoom;
    }
    set view(value) {
        if (this._objRef) {
            this._objRef.view = value;
        }
    }
    // @ts-ignore
    get view() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.view;
    }
    set left(value) {
        if (this._objRef) {
            this._objRef.left = value;
        }
    }
    // @ts-ignore
    get left() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.left;
    }
    set right(value) {
        if (this._objRef) {
            this._objRef.right = value;
        }
    }
    // @ts-ignore
    get right() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.right;
    }
    set top(value) {
        if (this._objRef) {
            this._objRef.top = value;
        }
    }
    // @ts-ignore
    get top() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.top;
    }
    set bottom(value) {
        if (this._objRef) {
            this._objRef.bottom = value;
        }
    }
    // @ts-ignore
    get bottom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bottom;
    }
    set near(value) {
        if (this._objRef) {
            this._objRef.near = value;
        }
    }
    // @ts-ignore
    get near() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.near;
    }
    set far(value) {
        if (this._objRef) {
            this._objRef.far = value;
        }
    }
    // @ts-ignore
    get far() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.far;
    }
}
ThOrthographicCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOrthographicCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThOrthographicCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThOrthographicCamera, selector: "th-orthographicCamera", inputs: { zoom: "zoom", view: "view", left: "left", right: "right", top: "top", bottom: "bottom", near: "near", far: "far" }, providers: [
        {
            provide: ThObject3D,
            useExisting: forwardRef(() => ThOrthographicCamera)
        },
        { provide: ThCamera, useExisting: forwardRef(() => ThOrthographicCamera) }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOrthographicCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-orthographicCamera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThObject3D,
                            useExisting: forwardRef(() => ThOrthographicCamera)
                        },
                        { provide: ThCamera, useExisting: forwardRef(() => ThOrthographicCamera) }
                    ]
                }]
        }], propDecorators: { zoom: [{
                type: Input
            }], view: [{
                type: Input
            }], left: [{
                type: Input
            }], right: [{
                type: Input
            }], top: [{
                type: Input
            }], bottom: [{
                type: Input
            }], near: [{
                type: Input
            }], far: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThOutlinePass extends ThPass {
    getType() {
        return OutlinePass;
    }
    set renderScene(value) {
        if (this._objRef) {
            this._objRef.renderScene = value;
        }
    }
    // @ts-ignore
    get renderScene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderScene;
    }
    set renderCamera(value) {
        if (this._objRef) {
            this._objRef.renderCamera = value;
        }
    }
    // @ts-ignore
    get renderCamera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderCamera;
    }
    set selectedObjects(value) {
        if (this._objRef) {
            this._objRef.selectedObjects = value;
        }
    }
    // @ts-ignore
    get selectedObjects() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.selectedObjects;
    }
    set visibleEdgeColor(value) {
        if (this._objRef) {
            this._objRef.visibleEdgeColor = applyValue(this._objRef.visibleEdgeColor, value);
        }
    }
    // @ts-ignore
    get visibleEdgeColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.visibleEdgeColor;
    }
    set hiddenEdgeColor(value) {
        if (this._objRef) {
            this._objRef.hiddenEdgeColor = applyValue(this._objRef.hiddenEdgeColor, value);
        }
    }
    // @ts-ignore
    get hiddenEdgeColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.hiddenEdgeColor;
    }
    set edgeGlow(value) {
        if (this._objRef) {
            this._objRef.edgeGlow = value;
        }
    }
    // @ts-ignore
    get edgeGlow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.edgeGlow;
    }
    set usePatternTexture(value) {
        if (this._objRef) {
            this._objRef.usePatternTexture = value;
        }
    }
    // @ts-ignore
    get usePatternTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.usePatternTexture;
    }
    set edgeThickness(value) {
        if (this._objRef) {
            this._objRef.edgeThickness = value;
        }
    }
    // @ts-ignore
    get edgeThickness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.edgeThickness;
    }
    set edgeStrength(value) {
        if (this._objRef) {
            this._objRef.edgeStrength = value;
        }
    }
    // @ts-ignore
    get edgeStrength() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.edgeStrength;
    }
    set downSampleRatio(value) {
        if (this._objRef) {
            this._objRef.downSampleRatio = value;
        }
    }
    // @ts-ignore
    get downSampleRatio() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.downSampleRatio;
    }
    set pulsePeriod(value) {
        if (this._objRef) {
            this._objRef.pulsePeriod = value;
        }
    }
    // @ts-ignore
    get pulsePeriod() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.pulsePeriod;
    }
    set resolution(value) {
        if (this._objRef) {
            this._objRef.resolution = applyValue(this._objRef.resolution, value);
        }
    }
    // @ts-ignore
    get resolution() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.resolution;
    }
    set patternTexture(value) {
        if (this._objRef) {
            this._objRef.patternTexture = value;
        }
    }
    // @ts-ignore
    get patternTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.patternTexture;
    }
    set maskBufferMaterial(value) {
        if (this._objRef) {
            this._objRef.maskBufferMaterial = value;
        }
    }
    // @ts-ignore
    get maskBufferMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maskBufferMaterial;
    }
    set renderTargetMaskBuffer(value) {
        if (this._objRef) {
            this._objRef.renderTargetMaskBuffer = value;
        }
    }
    // @ts-ignore
    get renderTargetMaskBuffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetMaskBuffer;
    }
    set depthMaterial(value) {
        if (this._objRef) {
            this._objRef.depthMaterial = value;
        }
    }
    // @ts-ignore
    get depthMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthMaterial;
    }
    set prepareMaskMaterial(value) {
        if (this._objRef) {
            this._objRef.prepareMaskMaterial = value;
        }
    }
    // @ts-ignore
    get prepareMaskMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.prepareMaskMaterial;
    }
    set renderTargetDepthBuffer(value) {
        if (this._objRef) {
            this._objRef.renderTargetDepthBuffer = value;
        }
    }
    // @ts-ignore
    get renderTargetDepthBuffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetDepthBuffer;
    }
    set renderTargetMaskDownSampleBuffer(value) {
        if (this._objRef) {
            this._objRef.renderTargetMaskDownSampleBuffer = value;
        }
    }
    // @ts-ignore
    get renderTargetMaskDownSampleBuffer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetMaskDownSampleBuffer;
    }
    set renderTargetBlurBuffer1(value) {
        if (this._objRef) {
            this._objRef.renderTargetBlurBuffer1 = value;
        }
    }
    // @ts-ignore
    get renderTargetBlurBuffer1() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetBlurBuffer1;
    }
    set renderTargetBlurBuffer2(value) {
        if (this._objRef) {
            this._objRef.renderTargetBlurBuffer2 = value;
        }
    }
    // @ts-ignore
    get renderTargetBlurBuffer2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetBlurBuffer2;
    }
    set edgeDetectionMaterial(value) {
        if (this._objRef) {
            this._objRef.edgeDetectionMaterial = value;
        }
    }
    // @ts-ignore
    get edgeDetectionMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.edgeDetectionMaterial;
    }
    set renderTargetEdgeBuffer1(value) {
        if (this._objRef) {
            this._objRef.renderTargetEdgeBuffer1 = value;
        }
    }
    // @ts-ignore
    get renderTargetEdgeBuffer1() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetEdgeBuffer1;
    }
    set renderTargetEdgeBuffer2(value) {
        if (this._objRef) {
            this._objRef.renderTargetEdgeBuffer2 = value;
        }
    }
    // @ts-ignore
    get renderTargetEdgeBuffer2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetEdgeBuffer2;
    }
    set separableBlurMaterial1(value) {
        if (this._objRef) {
            this._objRef.separableBlurMaterial1 = value;
        }
    }
    // @ts-ignore
    get separableBlurMaterial1() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.separableBlurMaterial1;
    }
    set separableBlurMaterial2(value) {
        if (this._objRef) {
            this._objRef.separableBlurMaterial2 = value;
        }
    }
    // @ts-ignore
    get separableBlurMaterial2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.separableBlurMaterial2;
    }
    set overlayMaterial(value) {
        if (this._objRef) {
            this._objRef.overlayMaterial = value;
        }
    }
    // @ts-ignore
    get overlayMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.overlayMaterial;
    }
    set copyUniforms(value) {
        if (this._objRef) {
            this._objRef.copyUniforms = value;
        }
    }
    // @ts-ignore
    get copyUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyUniforms;
    }
    set materialCopy(value) {
        if (this._objRef) {
            this._objRef.materialCopy = value;
        }
    }
    // @ts-ignore
    get materialCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialCopy;
    }
    set oldClearColor(value) {
        if (this._objRef) {
            this._objRef.oldClearColor = applyValue(this._objRef.oldClearColor, value);
        }
    }
    // @ts-ignore
    get oldClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearColor;
    }
    set oldClearAlpha(value) {
        if (this._objRef) {
            this._objRef.oldClearAlpha = value;
        }
    }
    // @ts-ignore
    get oldClearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearAlpha;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set tempPulseColor1(value) {
        if (this._objRef) {
            this._objRef.tempPulseColor1 = applyValue(this._objRef.tempPulseColor1, value);
        }
    }
    // @ts-ignore
    get tempPulseColor1() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.tempPulseColor1;
    }
    set tempPulseColor2(value) {
        if (this._objRef) {
            this._objRef.tempPulseColor2 = applyValue(this._objRef.tempPulseColor2, value);
        }
    }
    // @ts-ignore
    get tempPulseColor2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.tempPulseColor2;
    }
    set textureMatrix(value) {
        if (this._objRef) {
            this._objRef.textureMatrix = applyValue(this._objRef.textureMatrix, value);
        }
    }
    // @ts-ignore
    get textureMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.textureMatrix;
    }
}
ThOutlinePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOutlinePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThOutlinePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThOutlinePass, selector: "th-outlinePass", inputs: { renderScene: "renderScene", renderCamera: "renderCamera", selectedObjects: "selectedObjects", visibleEdgeColor: "visibleEdgeColor", hiddenEdgeColor: "hiddenEdgeColor", edgeGlow: "edgeGlow", usePatternTexture: "usePatternTexture", edgeThickness: "edgeThickness", edgeStrength: "edgeStrength", downSampleRatio: "downSampleRatio", pulsePeriod: "pulsePeriod", resolution: "resolution", patternTexture: "patternTexture", maskBufferMaterial: "maskBufferMaterial", renderTargetMaskBuffer: "renderTargetMaskBuffer", depthMaterial: "depthMaterial", prepareMaskMaterial: "prepareMaskMaterial", renderTargetDepthBuffer: "renderTargetDepthBuffer", renderTargetMaskDownSampleBuffer: "renderTargetMaskDownSampleBuffer", renderTargetBlurBuffer1: "renderTargetBlurBuffer1", renderTargetBlurBuffer2: "renderTargetBlurBuffer2", edgeDetectionMaterial: "edgeDetectionMaterial", renderTargetEdgeBuffer1: "renderTargetEdgeBuffer1", renderTargetEdgeBuffer2: "renderTargetEdgeBuffer2", separableBlurMaterial1: "separableBlurMaterial1", separableBlurMaterial2: "separableBlurMaterial2", overlayMaterial: "overlayMaterial", copyUniforms: "copyUniforms", materialCopy: "materialCopy", oldClearColor: "oldClearColor", oldClearAlpha: "oldClearAlpha", fsQuad: "fsQuad", tempPulseColor1: "tempPulseColor1", tempPulseColor2: "tempPulseColor2", textureMatrix: "textureMatrix" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThOutlinePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThOutlinePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-outlinePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThOutlinePass) }]
                }]
        }], propDecorators: { renderScene: [{
                type: Input
            }], renderCamera: [{
                type: Input
            }], selectedObjects: [{
                type: Input
            }], visibleEdgeColor: [{
                type: Input
            }], hiddenEdgeColor: [{
                type: Input
            }], edgeGlow: [{
                type: Input
            }], usePatternTexture: [{
                type: Input
            }], edgeThickness: [{
                type: Input
            }], edgeStrength: [{
                type: Input
            }], downSampleRatio: [{
                type: Input
            }], pulsePeriod: [{
                type: Input
            }], resolution: [{
                type: Input
            }], patternTexture: [{
                type: Input
            }], maskBufferMaterial: [{
                type: Input
            }], renderTargetMaskBuffer: [{
                type: Input
            }], depthMaterial: [{
                type: Input
            }], prepareMaskMaterial: [{
                type: Input
            }], renderTargetDepthBuffer: [{
                type: Input
            }], renderTargetMaskDownSampleBuffer: [{
                type: Input
            }], renderTargetBlurBuffer1: [{
                type: Input
            }], renderTargetBlurBuffer2: [{
                type: Input
            }], edgeDetectionMaterial: [{
                type: Input
            }], renderTargetEdgeBuffer1: [{
                type: Input
            }], renderTargetEdgeBuffer2: [{
                type: Input
            }], separableBlurMaterial1: [{
                type: Input
            }], separableBlurMaterial2: [{
                type: Input
            }], overlayMaterial: [{
                type: Input
            }], copyUniforms: [{
                type: Input
            }], materialCopy: [{
                type: Input
            }], oldClearColor: [{
                type: Input
            }], oldClearAlpha: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], tempPulseColor1: [{
                type: Input
            }], tempPulseColor2: [{
                type: Input
            }], textureMatrix: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThParametricGeometry extends ThBufferGeometry {
    getType() {
        return ParametricGeometry;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set parameters(value) {
        if (this._objRef) {
            this._objRef.parameters = value;
        }
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThParametricGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThParametricGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThParametricGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThParametricGeometry, selector: "th-parametricGeometry", inputs: { type: "type", parameters: "parameters" }, providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThParametricGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThParametricGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-parametricGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThParametricGeometry)
                        }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], parameters: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPlaneGeometry extends ThBufferGeometry {
    getType() {
        return PlaneGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThPlaneGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPlaneGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPlaneGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPlaneGeometry, selector: "th-planeGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThPlaneGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPlaneGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-planeGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThPlaneGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPlaneHelper extends ThLineSegments {
    getType() {
        return PlaneHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set plane(value) {
        if (this._objRef) {
            this._objRef.plane = applyValue(this._objRef.plane, value);
        }
    }
    // @ts-ignore
    get plane() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.plane;
    }
    set size(value) {
        if (this._objRef) {
            this._objRef.size = value;
        }
    }
    // @ts-ignore
    get size() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.size;
    }
}
ThPlaneHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPlaneHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPlaneHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPlaneHelper, selector: "th-planeHelper", inputs: { plane: "plane", size: "size" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPlaneHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPlaneHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-planeHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPlaneHelper) }]
                }]
        }], propDecorators: { plane: [{
                type: Input
            }], size: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPointerLockControls extends ThControlBase {
    getType() {
        return PointerLockControls;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set isLocked(value) {
        if (this._objRef) {
            this._objRef.isLocked = value;
        }
    }
    // @ts-ignore
    get isLocked() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isLocked;
    }
    set minPolarAngle(value) {
        if (this._objRef) {
            this._objRef.minPolarAngle = value;
        }
    }
    // @ts-ignore
    get minPolarAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minPolarAngle;
    }
    set maxPolarAngle(value) {
        if (this._objRef) {
            this._objRef.maxPolarAngle = value;
        }
    }
    // @ts-ignore
    get maxPolarAngle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxPolarAngle;
    }
    set pointerSpeed(value) {
        if (this._objRef) {
            this._objRef.pointerSpeed = value;
        }
    }
    // @ts-ignore
    get pointerSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.pointerSpeed;
    }
}
ThPointerLockControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointerLockControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPointerLockControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPointerLockControls, selector: "th-pointerLockControls", inputs: { camera: "camera", domElement: "domElement", isLocked: "isLocked", minPolarAngle: "minPolarAngle", maxPolarAngle: "maxPolarAngle", pointerSpeed: "pointerSpeed" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThPointerLockControls)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointerLockControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-pointerLockControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThPointerLockControls)
                        }
                    ]
                }]
        }], propDecorators: { camera: [{
                type: Input
            }], domElement: [{
                type: Input
            }], isLocked: [{
                type: Input
            }], minPolarAngle: [{
                type: Input
            }], maxPolarAngle: [{
                type: Input
            }], pointerSpeed: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPointLight extends ThLight {
    getType() {
        return PointLight;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set intensity(value) {
        if (this._objRef) {
            this._objRef.intensity = value;
        }
    }
    // @ts-ignore
    get intensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.intensity;
    }
    set distance(value) {
        if (this._objRef) {
            this._objRef.distance = value;
        }
    }
    // @ts-ignore
    get distance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.distance;
    }
    set castShadow(value) {
        if (this._objRef) {
            this._objRef.castShadow = value;
        }
    }
    // @ts-ignore
    get castShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.castShadow;
    }
    set decay(value) {
        if (this._objRef) {
            this._objRef.decay = value;
        }
    }
    // @ts-ignore
    get decay() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.decay;
    }
    set shadow(value) {
        if (this._objRef) {
            this._objRef.shadow = value;
        }
    }
    // @ts-ignore
    get shadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shadow;
    }
    set power(value) {
        if (this._objRef) {
            this._objRef.power = value;
        }
    }
    // @ts-ignore
    get power() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.power;
    }
}
ThPointLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPointLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPointLight, selector: "th-pointLight", inputs: { type: "type", intensity: "intensity", distance: "distance", castShadow: "castShadow", decay: "decay", shadow: "shadow", power: "power" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPointLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-pointLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPointLight) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], intensity: [{
                type: Input
            }], distance: [{
                type: Input
            }], castShadow: [{
                type: Input
            }], decay: [{
                type: Input
            }], shadow: [{
                type: Input
            }], power: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPointLightHelper extends ThObject3D {
    getType() {
        return PointLightHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set light(value) {
        if (this._objRef) {
            this._objRef.light = value;
        }
    }
    // @ts-ignore
    get light() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.light;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = value;
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
}
ThPointLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPointLightHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPointLightHelper, selector: "th-pointLightHelper", inputs: { light: "light", matrix: "matrix", color: "color", matrixAutoUpdate: "matrixAutoUpdate" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPointLightHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointLightHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-pointLightHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPointLightHelper) }]
                }]
        }], propDecorators: { light: [{
                type: Input
            }], matrix: [{
                type: Input
            }], color: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPoints extends ThObject3D {
    getType() {
        return Points;
    }
    // @ts-ignore
    get isPoints() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isPoints;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set morphTargetInfluences(value) {
        if (this._objRef) {
            this._objRef.morphTargetInfluences = value;
        }
    }
    // @ts-ignore
    get morphTargetInfluences() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetInfluences;
    }
    set morphTargetDictionary(value) {
        if (this._objRef) {
            this._objRef.morphTargetDictionary = value;
        }
    }
    // @ts-ignore
    get morphTargetDictionary() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.morphTargetDictionary;
    }
    set geometry(value) {
        if (this._objRef) {
            this._objRef.geometry = value;
        }
    }
    // @ts-ignore
    get geometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.geometry;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
}
ThPoints.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPoints, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPoints.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPoints, selector: "th-points", inputs: { morphTargetInfluences: "morphTargetInfluences", morphTargetDictionary: "morphTargetDictionary", geometry: "geometry", material: "material" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPoints) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPoints, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-points',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPoints) }]
                }]
        }], propDecorators: { morphTargetInfluences: [{
                type: Input
            }], morphTargetDictionary: [{
                type: Input
            }], geometry: [{
                type: Input
            }], material: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPointsMaterial extends ThMaterial {
    getType() {
        return PointsMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set size(value) {
        if (this._objRef) {
            this._objRef.size = value;
        }
    }
    // @ts-ignore
    get size() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.size;
    }
    set sizeAttenuation(value) {
        if (this._objRef) {
            this._objRef.sizeAttenuation = value;
        }
    }
    // @ts-ignore
    get sizeAttenuation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sizeAttenuation;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThPointsMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointsMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPointsMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPointsMaterial, selector: "th-pointsMaterial", inputs: { type: "type", color: "color", map: "map", alphaMap: "alphaMap", size: "size", sizeAttenuation: "sizeAttenuation", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThPointsMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPointsMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-pointsMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThPointsMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], size: [{
                type: Input
            }], sizeAttenuation: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPolarGridHelper extends ThLineSegments {
    getType() {
        return PolarGridHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThPolarGridHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPolarGridHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPolarGridHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPolarGridHelper, selector: "th-polarGridHelper", providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPolarGridHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPolarGridHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-polarGridHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPolarGridHelper) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThPositionalAudio extends ThAudio {
    getType() {
        return PositionalAudio;
    }
    set panner(value) {
        if (this._objRef) {
            this._objRef.panner = value;
        }
    }
    // @ts-ignore
    get panner() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.panner;
    }
}
ThPositionalAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPositionalAudio, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThPositionalAudio.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThPositionalAudio, selector: "th-positionalAudio", inputs: { panner: "panner" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPositionalAudio) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPositionalAudio, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-positionalAudio',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThPositionalAudio) }]
                }]
        }], propDecorators: { panner: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThShaderMaterial extends ThMaterial {
    getType() {
        return ShaderMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set defines(value) {
        if (this._objRef) {
            this._objRef.defines = value;
        }
    }
    // @ts-ignore
    get defines() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defines;
    }
    set uniforms(value) {
        if (this._objRef) {
            this._objRef.uniforms = value;
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set vertexShader(value) {
        if (this._objRef) {
            this._objRef.vertexShader = value;
        }
    }
    // @ts-ignore
    get vertexShader() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.vertexShader;
    }
    set fragmentShader(value) {
        if (this._objRef) {
            this._objRef.fragmentShader = value;
        }
    }
    // @ts-ignore
    get fragmentShader() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fragmentShader;
    }
    set linewidth(value) {
        if (this._objRef) {
            this._objRef.linewidth = value;
        }
    }
    // @ts-ignore
    get linewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.linewidth;
    }
    set wireframe(value) {
        if (this._objRef) {
            this._objRef.wireframe = value;
        }
    }
    // @ts-ignore
    get wireframe() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframe;
    }
    set wireframeLinewidth(value) {
        if (this._objRef) {
            this._objRef.wireframeLinewidth = value;
        }
    }
    // @ts-ignore
    get wireframeLinewidth() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.wireframeLinewidth;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
    set lights(value) {
        if (this._objRef) {
            this._objRef.lights = value;
        }
    }
    // @ts-ignore
    get lights() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.lights;
    }
    set clipping(value) {
        if (this._objRef) {
            this._objRef.clipping = value;
        }
    }
    // @ts-ignore
    get clipping() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clipping;
    }
    set derivatives(value) {
        if (this._objRef) {
            this._objRef.derivatives = value;
        }
    }
    // @ts-ignore
    get derivatives() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.derivatives;
    }
    set extensions(value) {
        if (this._objRef) {
            this._objRef.extensions = value;
        }
    }
    // @ts-ignore
    get extensions() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.extensions;
    }
    set defaultAttributeValues(value) {
        if (this._objRef) {
            this._objRef.defaultAttributeValues = value;
        }
    }
    // @ts-ignore
    get defaultAttributeValues() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.defaultAttributeValues;
    }
    set index0AttributeName(value) {
        if (this._objRef) {
            this._objRef.index0AttributeName = value;
        }
    }
    // @ts-ignore
    get index0AttributeName() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.index0AttributeName;
    }
    set uniformsNeedUpdate(value) {
        if (this._objRef) {
            this._objRef.uniformsNeedUpdate = value;
        }
    }
    // @ts-ignore
    get uniformsNeedUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniformsNeedUpdate;
    }
    set glslVersion(value) {
        if (this._objRef) {
            this._objRef.glslVersion = value;
        }
    }
    // @ts-ignore
    get glslVersion() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.glslVersion;
    }
    set isShaderMaterial(value) {
        if (this._objRef) {
            this._objRef.isShaderMaterial = value;
        }
    }
    // @ts-ignore
    get isShaderMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isShaderMaterial;
    }
}
ThShaderMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShaderMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThShaderMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThShaderMaterial, selector: "th-shaderMaterial", inputs: { type: "type", defines: "defines", uniforms: "uniforms", vertexShader: "vertexShader", fragmentShader: "fragmentShader", linewidth: "linewidth", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", fog: "fog", lights: "lights", clipping: "clipping", derivatives: "derivatives", extensions: "extensions", defaultAttributeValues: "defaultAttributeValues", index0AttributeName: "index0AttributeName", uniformsNeedUpdate: "uniformsNeedUpdate", glslVersion: "glslVersion", isShaderMaterial: "isShaderMaterial" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThShaderMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShaderMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-shaderMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThShaderMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], defines: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], vertexShader: [{
                type: Input
            }], fragmentShader: [{
                type: Input
            }], linewidth: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], fog: [{
                type: Input
            }], lights: [{
                type: Input
            }], clipping: [{
                type: Input
            }], derivatives: [{
                type: Input
            }], extensions: [{
                type: Input
            }], defaultAttributeValues: [{
                type: Input
            }], index0AttributeName: [{
                type: Input
            }], uniformsNeedUpdate: [{
                type: Input
            }], glslVersion: [{
                type: Input
            }], isShaderMaterial: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThRawShaderMaterial extends ThShaderMaterial {
    getType() {
        return RawShaderMaterial;
    }
}
ThRawShaderMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRawShaderMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThRawShaderMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRawShaderMaterial, selector: "th-rawShaderMaterial", providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThRawShaderMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRawShaderMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-rawShaderMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThRawShaderMaterial) }]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThRectAreaLight extends ThLight {
    getType() {
        return RectAreaLight;
    }
    // @ts-ignore
    get isRectAreaLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isRectAreaLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set width(value) {
        if (this._objRef) {
            this._objRef.width = value;
        }
    }
    // @ts-ignore
    get width() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.width;
    }
    set height(value) {
        if (this._objRef) {
            this._objRef.height = value;
        }
    }
    // @ts-ignore
    get height() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.height;
    }
    set intensity(value) {
        if (this._objRef) {
            this._objRef.intensity = value;
        }
    }
    // @ts-ignore
    get intensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.intensity;
    }
    set power(value) {
        if (this._objRef) {
            this._objRef.power = value;
        }
    }
    // @ts-ignore
    get power() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.power;
    }
}
ThRectAreaLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRectAreaLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThRectAreaLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRectAreaLight, selector: "th-rectAreaLight", inputs: { width: "width", height: "height", intensity: "intensity", power: "power" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThRectAreaLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRectAreaLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-rectAreaLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThRectAreaLight) }]
                }]
        }], propDecorators: { width: [{
                type: Input
            }], height: [{
                type: Input
            }], intensity: [{
                type: Input
            }], power: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThRingGeometry extends ThBufferGeometry {
    getType() {
        return RingGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThRingGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRingGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThRingGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRingGeometry, selector: "th-ringGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThRingGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRingGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-ringGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThRingGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThRoundedBoxGeometry extends ThBoxGeometry {
    getType() {
        return RoundedBoxGeometry;
    }
}
ThRoundedBoxGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRoundedBoxGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThRoundedBoxGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThRoundedBoxGeometry, selector: "th-roundedBoxGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThRoundedBoxGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRoundedBoxGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-roundedBoxGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThRoundedBoxGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThSAOPass extends ThPass {
    getType() {
        return SAOPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set supportsDepthTextureExtension(value) {
        if (this._objRef) {
            this._objRef.supportsDepthTextureExtension = value;
        }
    }
    // @ts-ignore
    get supportsDepthTextureExtension() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.supportsDepthTextureExtension;
    }
    set supportsNormalTexture(value) {
        if (this._objRef) {
            this._objRef.supportsNormalTexture = value;
        }
    }
    // @ts-ignore
    get supportsNormalTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.supportsNormalTexture;
    }
    set originalClearColor(value) {
        if (this._objRef) {
            this._objRef.originalClearColor = applyValue(this._objRef.originalClearColor, value);
        }
    }
    // @ts-ignore
    get originalClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.originalClearColor;
    }
    set oldClearColor(value) {
        if (this._objRef) {
            this._objRef.oldClearColor = applyValue(this._objRef.oldClearColor, value);
        }
    }
    // @ts-ignore
    get oldClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearColor;
    }
    set oldClearAlpha(value) {
        if (this._objRef) {
            this._objRef.oldClearAlpha = value;
        }
    }
    // @ts-ignore
    get oldClearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearAlpha;
    }
    set resolution(value) {
        if (this._objRef) {
            this._objRef.resolution = applyValue(this._objRef.resolution, value);
        }
    }
    // @ts-ignore
    get resolution() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.resolution;
    }
    set saoRenderTarget(value) {
        if (this._objRef) {
            this._objRef.saoRenderTarget = value;
        }
    }
    // @ts-ignore
    get saoRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.saoRenderTarget;
    }
    set blurIntermediateRenderTarget(value) {
        if (this._objRef) {
            this._objRef.blurIntermediateRenderTarget = value;
        }
    }
    // @ts-ignore
    get blurIntermediateRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurIntermediateRenderTarget;
    }
    set beautyRenderTarget(value) {
        if (this._objRef) {
            this._objRef.beautyRenderTarget = value;
        }
    }
    // @ts-ignore
    get beautyRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.beautyRenderTarget;
    }
    set normalRenderTarget(value) {
        if (this._objRef) {
            this._objRef.normalRenderTarget = value;
        }
    }
    // @ts-ignore
    get normalRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalRenderTarget;
    }
    set depthRenderTarget(value) {
        if (this._objRef) {
            this._objRef.depthRenderTarget = value;
        }
    }
    // @ts-ignore
    get depthRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthRenderTarget;
    }
    set depthMaterial(value) {
        if (this._objRef) {
            this._objRef.depthMaterial = value;
        }
    }
    // @ts-ignore
    get depthMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthMaterial;
    }
    set normalMaterial(value) {
        if (this._objRef) {
            this._objRef.normalMaterial = value;
        }
    }
    // @ts-ignore
    get normalMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMaterial;
    }
    set saoMaterial(value) {
        if (this._objRef) {
            this._objRef.saoMaterial = value;
        }
    }
    // @ts-ignore
    get saoMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.saoMaterial;
    }
    set vBlurMaterial(value) {
        if (this._objRef) {
            this._objRef.vBlurMaterial = value;
        }
    }
    // @ts-ignore
    get vBlurMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.vBlurMaterial;
    }
    set hBlurMaterial(value) {
        if (this._objRef) {
            this._objRef.hBlurMaterial = value;
        }
    }
    // @ts-ignore
    get hBlurMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.hBlurMaterial;
    }
    set materialCopy(value) {
        if (this._objRef) {
            this._objRef.materialCopy = value;
        }
    }
    // @ts-ignore
    get materialCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialCopy;
    }
    set depthCopy(value) {
        if (this._objRef) {
            this._objRef.depthCopy = value;
        }
    }
    // @ts-ignore
    get depthCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthCopy;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set params(value) {
        if (this._objRef) {
            this._objRef.params = value;
        }
    }
    // @ts-ignore
    get params() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.params;
    }
}
ThSAOPass.OUTPUT = SAOPass.OUTPUT;
ThSAOPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSAOPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSAOPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSAOPass, selector: "th-sAOPass", inputs: { scene: "scene", camera: "camera", supportsDepthTextureExtension: "supportsDepthTextureExtension", supportsNormalTexture: "supportsNormalTexture", originalClearColor: "originalClearColor", oldClearColor: "oldClearColor", oldClearAlpha: "oldClearAlpha", resolution: "resolution", saoRenderTarget: "saoRenderTarget", blurIntermediateRenderTarget: "blurIntermediateRenderTarget", beautyRenderTarget: "beautyRenderTarget", normalRenderTarget: "normalRenderTarget", depthRenderTarget: "depthRenderTarget", depthMaterial: "depthMaterial", normalMaterial: "normalMaterial", saoMaterial: "saoMaterial", vBlurMaterial: "vBlurMaterial", hBlurMaterial: "hBlurMaterial", materialCopy: "materialCopy", depthCopy: "depthCopy", fsQuad: "fsQuad", params: "params" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSAOPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSAOPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sAOPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSAOPass) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], supportsDepthTextureExtension: [{
                type: Input
            }], supportsNormalTexture: [{
                type: Input
            }], originalClearColor: [{
                type: Input
            }], oldClearColor: [{
                type: Input
            }], oldClearAlpha: [{
                type: Input
            }], resolution: [{
                type: Input
            }], saoRenderTarget: [{
                type: Input
            }], blurIntermediateRenderTarget: [{
                type: Input
            }], beautyRenderTarget: [{
                type: Input
            }], normalRenderTarget: [{
                type: Input
            }], depthRenderTarget: [{
                type: Input
            }], depthMaterial: [{
                type: Input
            }], normalMaterial: [{
                type: Input
            }], saoMaterial: [{
                type: Input
            }], vBlurMaterial: [{
                type: Input
            }], hBlurMaterial: [{
                type: Input
            }], materialCopy: [{
                type: Input
            }], depthCopy: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], params: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThSavePass extends ThPass {
    getType() {
        return SavePass;
    }
    set textureID(value) {
        if (this._objRef) {
            this._objRef.textureID = value;
        }
    }
    // @ts-ignore
    get textureID() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.textureID;
    }
    set renderTarget(value) {
        if (this._objRef) {
            this._objRef.renderTarget = value;
        }
    }
    // @ts-ignore
    get renderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTarget;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThSavePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSavePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSavePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSavePass, selector: "th-savePass", inputs: { textureID: "textureID", renderTarget: "renderTarget", uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSavePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSavePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-savePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSavePass) }]
                }]
        }], propDecorators: { textureID: [{
                type: Input
            }], renderTarget: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThShadowMaterial extends ThMaterial {
    getType() {
        return ShadowMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set transparent(value) {
        if (this._objRef) {
            this._objRef.transparent = value;
        }
    }
    // @ts-ignore
    get transparent() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transparent;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
}
ThShadowMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShadowMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThShadowMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThShadowMaterial, selector: "th-shadowMaterial", inputs: { type: "type", color: "color", transparent: "transparent", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThShadowMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShadowMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-shadowMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThShadowMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], transparent: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThShapeGeometry extends ThBufferGeometry {
    getType() {
        return ShapeGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThShapeGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShapeGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThShapeGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThShapeGeometry, selector: "th-shapeGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThShapeGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThShapeGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-shapeGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThShapeGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSkeletonHelper extends ThLineSegments {
    getType() {
        return SkeletonHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set bones(value) {
        if (this._objRef) {
            this._objRef.bones = value;
        }
    }
    // @ts-ignore
    get bones() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bones;
    }
    set root(value) {
        if (this._objRef) {
            this._objRef.root = value;
        }
    }
    // @ts-ignore
    get root() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.root;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
}
ThSkeletonHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSkeletonHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSkeletonHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSkeletonHelper, selector: "th-skeletonHelper", inputs: { bones: "bones", root: "root", matrix: "matrix", matrixAutoUpdate: "matrixAutoUpdate" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSkeletonHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSkeletonHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-skeletonHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSkeletonHelper) }]
                }]
        }], propDecorators: { bones: [{
                type: Input
            }], root: [{
                type: Input
            }], matrix: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSkinnedMesh extends ThMesh {
    getType() {
        return SkinnedMesh;
    }
    // @ts-ignore
    get isSkinnedMesh() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isSkinnedMesh;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set bindMode(value) {
        if (this._objRef) {
            this._objRef.bindMode = value;
        }
    }
    // @ts-ignore
    get bindMode() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bindMode;
    }
    set bindMatrix(value) {
        if (this._objRef) {
            this._objRef.bindMatrix = applyValue(this._objRef.bindMatrix, value);
        }
    }
    // @ts-ignore
    get bindMatrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bindMatrix;
    }
    set bindMatrixInverse(value) {
        if (this._objRef) {
            this._objRef.bindMatrixInverse = applyValue(this._objRef.bindMatrixInverse, value);
        }
    }
    // @ts-ignore
    get bindMatrixInverse() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bindMatrixInverse;
    }
    set boundingBox(value) {
        if (this._objRef) {
            this._objRef.boundingBox = applyValue(this._objRef.boundingBox, value);
        }
    }
    // @ts-ignore
    get boundingBox() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingBox;
    }
    set boundingSphere(value) {
        if (this._objRef) {
            this._objRef.boundingSphere = applyValue(this._objRef.boundingSphere, value);
        }
    }
    // @ts-ignore
    get boundingSphere() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.boundingSphere;
    }
    set skeleton(value) {
        if (this._objRef) {
            this._objRef.skeleton = value;
        }
    }
    // @ts-ignore
    get skeleton() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.skeleton;
    }
}
ThSkinnedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSkinnedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSkinnedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSkinnedMesh, selector: "th-skinnedMesh", inputs: { bindMode: "bindMode", bindMatrix: "bindMatrix", bindMatrixInverse: "bindMatrixInverse", boundingBox: "boundingBox", boundingSphere: "boundingSphere", skeleton: "skeleton" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSkinnedMesh) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSkinnedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-skinnedMesh',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSkinnedMesh) }]
                }]
        }], propDecorators: { bindMode: [{
                type: Input
            }], bindMatrix: [{
                type: Input
            }], bindMatrixInverse: [{
                type: Input
            }], boundingBox: [{
                type: Input
            }], boundingSphere: [{
                type: Input
            }], skeleton: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThSMAAPass extends ThPass {
    getType() {
        return SMAAPass;
    }
    set edgesRT(value) {
        if (this._objRef) {
            this._objRef.edgesRT = value;
        }
    }
    // @ts-ignore
    get edgesRT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.edgesRT;
    }
    set weightsRT(value) {
        if (this._objRef) {
            this._objRef.weightsRT = value;
        }
    }
    // @ts-ignore
    get weightsRT() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.weightsRT;
    }
    set areaTexture(value) {
        if (this._objRef) {
            this._objRef.areaTexture = value;
        }
    }
    // @ts-ignore
    get areaTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.areaTexture;
    }
    set searchTexture(value) {
        if (this._objRef) {
            this._objRef.searchTexture = value;
        }
    }
    // @ts-ignore
    get searchTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.searchTexture;
    }
    set uniformsEdges(value) {
        if (this._objRef) {
            this._objRef.uniformsEdges = value;
        }
    }
    // @ts-ignore
    get uniformsEdges() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniformsEdges;
    }
    set materialEdges(value) {
        if (this._objRef) {
            this._objRef.materialEdges = value;
        }
    }
    // @ts-ignore
    get materialEdges() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialEdges;
    }
    set uniformsWeights(value) {
        if (this._objRef) {
            this._objRef.uniformsWeights = value;
        }
    }
    // @ts-ignore
    get uniformsWeights() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniformsWeights;
    }
    set materialWeights(value) {
        if (this._objRef) {
            this._objRef.materialWeights = value;
        }
    }
    // @ts-ignore
    get materialWeights() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialWeights;
    }
    set uniformsBlend(value) {
        if (this._objRef) {
            this._objRef.uniformsBlend = value;
        }
    }
    // @ts-ignore
    get uniformsBlend() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniformsBlend;
    }
    set materialBlend(value) {
        if (this._objRef) {
            this._objRef.materialBlend = value;
        }
    }
    // @ts-ignore
    get materialBlend() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialBlend;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThSMAAPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSMAAPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSMAAPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSMAAPass, selector: "th-sMAAPass", inputs: { edgesRT: "edgesRT", weightsRT: "weightsRT", areaTexture: "areaTexture", searchTexture: "searchTexture", uniformsEdges: "uniformsEdges", materialEdges: "materialEdges", uniformsWeights: "uniformsWeights", materialWeights: "materialWeights", uniformsBlend: "uniformsBlend", materialBlend: "materialBlend", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSMAAPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSMAAPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sMAAPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSMAAPass) }]
                }]
        }], propDecorators: { edgesRT: [{
                type: Input
            }], weightsRT: [{
                type: Input
            }], areaTexture: [{
                type: Input
            }], searchTexture: [{
                type: Input
            }], uniformsEdges: [{
                type: Input
            }], materialEdges: [{
                type: Input
            }], uniformsWeights: [{
                type: Input
            }], materialWeights: [{
                type: Input
            }], uniformsBlend: [{
                type: Input
            }], materialBlend: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSphereGeometry extends ThBufferGeometry {
    getType() {
        return SphereGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThSphereGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSphereGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSphereGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSphereGeometry, selector: "th-sphereGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThSphereGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSphereGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sphereGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThSphereGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSpotLight extends ThLight {
    getType() {
        return SpotLight;
    }
    // @ts-ignore
    get isSpotLight() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isSpotLight;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set position(value) {
        if (this._objRef) {
            this._objRef.position = applyValue(this._objRef.position, value);
        }
    }
    // @ts-ignore
    get position() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position;
    }
    set target(value) {
        if (this._objRef) {
            this._objRef.target = value;
        }
    }
    // @ts-ignore
    get target() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target;
    }
    set castShadow(value) {
        if (this._objRef) {
            this._objRef.castShadow = value;
        }
    }
    // @ts-ignore
    get castShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.castShadow;
    }
    set intensity(value) {
        if (this._objRef) {
            this._objRef.intensity = value;
        }
    }
    // @ts-ignore
    get intensity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.intensity;
    }
    set distance(value) {
        if (this._objRef) {
            this._objRef.distance = value;
        }
    }
    // @ts-ignore
    get distance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.distance;
    }
    set angle(value) {
        if (this._objRef) {
            this._objRef.angle = value;
        }
    }
    // @ts-ignore
    get angle() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.angle;
    }
    set decay(value) {
        if (this._objRef) {
            this._objRef.decay = value;
        }
    }
    // @ts-ignore
    get decay() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.decay;
    }
    set shadow(value) {
        if (this._objRef) {
            this._objRef.shadow = value;
        }
    }
    // @ts-ignore
    get shadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.shadow;
    }
    set power(value) {
        if (this._objRef) {
            this._objRef.power = value;
        }
    }
    // @ts-ignore
    get power() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.power;
    }
    set penumbra(value) {
        if (this._objRef) {
            this._objRef.penumbra = value;
        }
    }
    // @ts-ignore
    get penumbra() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.penumbra;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
}
ThSpotLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpotLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSpotLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSpotLight, selector: "th-spotLight", inputs: { position: "position", target: "target", castShadow: "castShadow", intensity: "intensity", distance: "distance", angle: "angle", decay: "decay", shadow: "shadow", power: "power", penumbra: "penumbra", map: "map" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSpotLight) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpotLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-spotLight',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSpotLight) }]
                }]
        }], propDecorators: { position: [{
                type: Input
            }], target: [{
                type: Input
            }], castShadow: [{
                type: Input
            }], intensity: [{
                type: Input
            }], distance: [{
                type: Input
            }], angle: [{
                type: Input
            }], decay: [{
                type: Input
            }], shadow: [{
                type: Input
            }], power: [{
                type: Input
            }], penumbra: [{
                type: Input
            }], map: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSpotLightHelper extends ThObject3D {
    getType() {
        return SpotLightHelper;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set cone(value) {
        if (this._objRef) {
            this._objRef.cone = value;
        }
    }
    // @ts-ignore
    get cone() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cone;
    }
    set light(value) {
        if (this._objRef) {
            this._objRef.light = value;
        }
    }
    // @ts-ignore
    get light() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.light;
    }
    set matrix(value) {
        if (this._objRef) {
            this._objRef.matrix = applyValue(this._objRef.matrix, value);
        }
    }
    // @ts-ignore
    get matrix() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrix;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = value;
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set matrixAutoUpdate(value) {
        if (this._objRef) {
            this._objRef.matrixAutoUpdate = value;
        }
    }
    // @ts-ignore
    get matrixAutoUpdate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.matrixAutoUpdate;
    }
}
ThSpotLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpotLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSpotLightHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSpotLightHelper, selector: "th-spotLightHelper", inputs: { cone: "cone", light: "light", matrix: "matrix", color: "color", matrixAutoUpdate: "matrixAutoUpdate" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSpotLightHelper) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpotLightHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-spotLightHelper',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSpotLightHelper) }]
                }]
        }], propDecorators: { cone: [{
                type: Input
            }], light: [{
                type: Input
            }], matrix: [{
                type: Input
            }], color: [{
                type: Input
            }], matrixAutoUpdate: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSprite extends ThObject3D {
    getType() {
        return Sprite;
    }
    // @ts-ignore
    get isSprite() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isSprite;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set castShadow(value) {
        if (this._objRef) {
            this._objRef.castShadow = value;
        }
    }
    // @ts-ignore
    get castShadow() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.castShadow;
    }
    set geometry(value) {
        if (this._objRef) {
            this._objRef.geometry = value;
        }
    }
    // @ts-ignore
    get geometry() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.geometry;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set center(value) {
        if (this._objRef) {
            this._objRef.center = applyValue(this._objRef.center, value);
        }
    }
    // @ts-ignore
    get center() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.center;
    }
}
ThSprite.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSprite, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSprite.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSprite, selector: "th-sprite", inputs: { castShadow: "castShadow", geometry: "geometry", material: "material", center: "center" }, providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSprite) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSprite, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sprite',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThObject3D, useExisting: forwardRef(() => ThSprite) }]
                }]
        }], propDecorators: { castShadow: [{
                type: Input
            }], geometry: [{
                type: Input
            }], material: [{
                type: Input
            }], center: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThSpriteMaterial extends ThMaterial {
    getType() {
        return SpriteMaterial;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set color(value) {
        if (this._objRef) {
            this._objRef.color = applyValue(this._objRef.color, value);
        }
    }
    // @ts-ignore
    get color() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.color;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set alphaMap(value) {
        if (this._objRef) {
            this._objRef.alphaMap = value;
        }
    }
    // @ts-ignore
    get alphaMap() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.alphaMap;
    }
    set rotation(value) {
        if (this._objRef) {
            this._objRef.rotation = value;
        }
    }
    // @ts-ignore
    get rotation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotation;
    }
    set sizeAttenuation(value) {
        if (this._objRef) {
            this._objRef.sizeAttenuation = value;
        }
    }
    // @ts-ignore
    get sizeAttenuation() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sizeAttenuation;
    }
    set transparent(value) {
        if (this._objRef) {
            this._objRef.transparent = value;
        }
    }
    // @ts-ignore
    get transparent() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.transparent;
    }
    set fog(value) {
        if (this._objRef) {
            this._objRef.fog = value;
        }
    }
    // @ts-ignore
    get fog() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fog;
    }
    // @ts-ignore
    get isSpriteMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isSpriteMaterial;
    }
}
ThSpriteMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpriteMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSpriteMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSpriteMaterial, selector: "th-spriteMaterial", inputs: { type: "type", color: "color", map: "map", alphaMap: "alphaMap", rotation: "rotation", sizeAttenuation: "sizeAttenuation", transparent: "transparent", fog: "fog" }, providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThSpriteMaterial) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSpriteMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-spriteMaterial',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThMaterial, useExisting: forwardRef(() => ThSpriteMaterial) }]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], color: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], rotation: [{
                type: Input
            }], sizeAttenuation: [{
                type: Input
            }], transparent: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThSSAARenderPass extends ThPass {
    getType() {
        return SSAARenderPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set sampleLevel(value) {
        if (this._objRef) {
            this._objRef.sampleLevel = value;
        }
    }
    // @ts-ignore
    get sampleLevel() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sampleLevel;
    }
    set unbiased(value) {
        if (this._objRef) {
            this._objRef.unbiased = value;
        }
    }
    // @ts-ignore
    get unbiased() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.unbiased;
    }
    set clearColor(value) {
        if (this._objRef) {
            this._objRef.clearColor = value;
        }
    }
    // @ts-ignore
    get clearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearColor;
    }
    set clearAlpha(value) {
        if (this._objRef) {
            this._objRef.clearAlpha = value;
        }
    }
    // @ts-ignore
    get clearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearAlpha;
    }
    set copyUniforms(value) {
        if (this._objRef) {
            this._objRef.copyUniforms = value;
        }
    }
    // @ts-ignore
    get copyUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyUniforms;
    }
    set copyMaterial(value) {
        if (this._objRef) {
            this._objRef.copyMaterial = value;
        }
    }
    // @ts-ignore
    get copyMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyMaterial;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set sampleRenderTarget(value) {
        if (this._objRef) {
            this._objRef.sampleRenderTarget = value;
        }
    }
    // @ts-ignore
    get sampleRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.sampleRenderTarget;
    }
}
ThSSAARenderPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSAARenderPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSSAARenderPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSSAARenderPass, selector: "th-sSAARenderPass", inputs: { scene: "scene", camera: "camera", sampleLevel: "sampleLevel", unbiased: "unbiased", clearColor: "clearColor", clearAlpha: "clearAlpha", copyUniforms: "copyUniforms", copyMaterial: "copyMaterial", fsQuad: "fsQuad", sampleRenderTarget: "sampleRenderTarget" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSAARenderPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSAARenderPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sSAARenderPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSAARenderPass) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], sampleLevel: [{
                type: Input
            }], unbiased: [{
                type: Input
            }], clearColor: [{
                type: Input
            }], clearAlpha: [{
                type: Input
            }], copyUniforms: [{
                type: Input
            }], copyMaterial: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], sampleRenderTarget: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThSSAOPass extends ThPass {
    getType() {
        return SSAOPass;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set width(value) {
        if (this._objRef) {
            this._objRef.width = value;
        }
    }
    // @ts-ignore
    get width() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.width;
    }
    set height(value) {
        if (this._objRef) {
            this._objRef.height = value;
        }
    }
    // @ts-ignore
    get height() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.height;
    }
    set clear(value) {
        if (this._objRef) {
            this._objRef.clear = value;
        }
    }
    // @ts-ignore
    get clear() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clear;
    }
    set kernelRadius(value) {
        if (this._objRef) {
            this._objRef.kernelRadius = value;
        }
    }
    // @ts-ignore
    get kernelRadius() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.kernelRadius;
    }
    set kernelSize(value) {
        if (this._objRef) {
            this._objRef.kernelSize = value;
        }
    }
    // @ts-ignore
    get kernelSize() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.kernelSize;
    }
    set kernel(value) {
        if (this._objRef) {
            this._objRef.kernel = value;
        }
    }
    // @ts-ignore
    get kernel() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.kernel;
    }
    set noiseTexture(value) {
        if (this._objRef) {
            this._objRef.noiseTexture = value;
        }
    }
    // @ts-ignore
    get noiseTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.noiseTexture;
    }
    set output(value) {
        if (this._objRef) {
            this._objRef.output = value;
        }
    }
    // @ts-ignore
    get output() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.output;
    }
    set minDistance(value) {
        if (this._objRef) {
            this._objRef.minDistance = value;
        }
    }
    // @ts-ignore
    get minDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minDistance;
    }
    set maxDistance(value) {
        if (this._objRef) {
            this._objRef.maxDistance = value;
        }
    }
    // @ts-ignore
    get maxDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxDistance;
    }
    set beautyRenderTarget(value) {
        if (this._objRef) {
            this._objRef.beautyRenderTarget = value;
        }
    }
    // @ts-ignore
    get beautyRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.beautyRenderTarget;
    }
    set normalRenderTarget(value) {
        if (this._objRef) {
            this._objRef.normalRenderTarget = value;
        }
    }
    // @ts-ignore
    get normalRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalRenderTarget;
    }
    set ssaoRenderTarget(value) {
        if (this._objRef) {
            this._objRef.ssaoRenderTarget = value;
        }
    }
    // @ts-ignore
    get ssaoRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.ssaoRenderTarget;
    }
    set blurRenderTarget(value) {
        if (this._objRef) {
            this._objRef.blurRenderTarget = value;
        }
    }
    // @ts-ignore
    get blurRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurRenderTarget;
    }
    set ssaoMaterial(value) {
        if (this._objRef) {
            this._objRef.ssaoMaterial = value;
        }
    }
    // @ts-ignore
    get ssaoMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.ssaoMaterial;
    }
    set normalMaterial(value) {
        if (this._objRef) {
            this._objRef.normalMaterial = value;
        }
    }
    // @ts-ignore
    get normalMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMaterial;
    }
    set blurMaterial(value) {
        if (this._objRef) {
            this._objRef.blurMaterial = value;
        }
    }
    // @ts-ignore
    get blurMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurMaterial;
    }
    set depthRenderMaterial(value) {
        if (this._objRef) {
            this._objRef.depthRenderMaterial = value;
        }
    }
    // @ts-ignore
    get depthRenderMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthRenderMaterial;
    }
    set copyMaterial(value) {
        if (this._objRef) {
            this._objRef.copyMaterial = value;
        }
    }
    // @ts-ignore
    get copyMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyMaterial;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set originalClearColor(value) {
        if (this._objRef) {
            this._objRef.originalClearColor = applyValue(this._objRef.originalClearColor, value);
        }
    }
    // @ts-ignore
    get originalClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.originalClearColor;
    }
}
ThSSAOPass.OUTPUT = SSAOPass.OUTPUT;
ThSSAOPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSAOPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSSAOPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSSAOPass, selector: "th-sSAOPass", inputs: { scene: "scene", camera: "camera", width: "width", height: "height", clear: "clear", kernelRadius: "kernelRadius", kernelSize: "kernelSize", kernel: "kernel", noiseTexture: "noiseTexture", output: "output", minDistance: "minDistance", maxDistance: "maxDistance", beautyRenderTarget: "beautyRenderTarget", normalRenderTarget: "normalRenderTarget", ssaoRenderTarget: "ssaoRenderTarget", blurRenderTarget: "blurRenderTarget", ssaoMaterial: "ssaoMaterial", normalMaterial: "normalMaterial", blurMaterial: "blurMaterial", depthRenderMaterial: "depthRenderMaterial", copyMaterial: "copyMaterial", fsQuad: "fsQuad", originalClearColor: "originalClearColor" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSAOPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSAOPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sSAOPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSAOPass) }]
                }]
        }], propDecorators: { scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], clear: [{
                type: Input
            }], kernelRadius: [{
                type: Input
            }], kernelSize: [{
                type: Input
            }], kernel: [{
                type: Input
            }], noiseTexture: [{
                type: Input
            }], output: [{
                type: Input
            }], minDistance: [{
                type: Input
            }], maxDistance: [{
                type: Input
            }], beautyRenderTarget: [{
                type: Input
            }], normalRenderTarget: [{
                type: Input
            }], ssaoRenderTarget: [{
                type: Input
            }], blurRenderTarget: [{
                type: Input
            }], ssaoMaterial: [{
                type: Input
            }], normalMaterial: [{
                type: Input
            }], blurMaterial: [{
                type: Input
            }], depthRenderMaterial: [{
                type: Input
            }], copyMaterial: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], originalClearColor: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThSSRPass extends ThPass {
    getType() {
        return SSRPass;
    }
    set width(value) {
        if (this._objRef) {
            this._objRef.width = value;
        }
    }
    // @ts-ignore
    get width() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.width;
    }
    set height(value) {
        if (this._objRef) {
            this._objRef.height = value;
        }
    }
    // @ts-ignore
    get height() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.height;
    }
    set clear(value) {
        if (this._objRef) {
            this._objRef.clear = value;
        }
    }
    // @ts-ignore
    get clear() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clear;
    }
    set renderer(value) {
        if (this._objRef) {
            this._objRef.renderer = value;
        }
    }
    // @ts-ignore
    get renderer() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderer;
    }
    set scene(value) {
        if (this._objRef) {
            this._objRef.scene = value;
        }
    }
    // @ts-ignore
    get scene() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.scene;
    }
    set camera(value) {
        if (this._objRef) {
            this._objRef.camera = value;
        }
    }
    // @ts-ignore
    get camera() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.camera;
    }
    set groundReflector(value) {
        if (this._objRef) {
            this._objRef.groundReflector = value;
        }
    }
    // @ts-ignore
    get groundReflector() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.groundReflector;
    }
    set opacity(value) {
        if (this._objRef) {
            this._objRef.opacity = value;
        }
    }
    // @ts-ignore
    get opacity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.opacity;
    }
    set output(value) {
        if (this._objRef) {
            this._objRef.output = value;
        }
    }
    // @ts-ignore
    get output() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.output;
    }
    set maxDistance(value) {
        if (this._objRef) {
            this._objRef.maxDistance = value;
        }
    }
    // @ts-ignore
    get maxDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxDistance;
    }
    set thickness(value) {
        if (this._objRef) {
            this._objRef.thickness = value;
        }
    }
    // @ts-ignore
    get thickness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.thickness;
    }
    set tempColor(value) {
        if (this._objRef) {
            this._objRef.tempColor = applyValue(this._objRef.tempColor, value);
        }
    }
    // @ts-ignore
    get tempColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.tempColor;
    }
    set selective(value) {
        if (this._objRef) {
            this._objRef.selective = value;
        }
    }
    // @ts-ignore
    get selective() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.selective;
    }
    set blur(value) {
        if (this._objRef) {
            this._objRef.blur = value;
        }
    }
    // @ts-ignore
    get blur() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blur;
    }
    set thickTolerance(value) {
        if (this._objRef) {
            this._objRef.thickTolerance = value;
        }
    }
    // @ts-ignore
    get thickTolerance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.thickTolerance;
    }
    set beautyRenderTarget(value) {
        if (this._objRef) {
            this._objRef.beautyRenderTarget = value;
        }
    }
    // @ts-ignore
    get beautyRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.beautyRenderTarget;
    }
    set prevRenderTarget(value) {
        if (this._objRef) {
            this._objRef.prevRenderTarget = value;
        }
    }
    // @ts-ignore
    get prevRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.prevRenderTarget;
    }
    set normalRenderTarget(value) {
        if (this._objRef) {
            this._objRef.normalRenderTarget = value;
        }
    }
    // @ts-ignore
    get normalRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalRenderTarget;
    }
    set metalnessRenderTarget(value) {
        if (this._objRef) {
            this._objRef.metalnessRenderTarget = value;
        }
    }
    // @ts-ignore
    get metalnessRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metalnessRenderTarget;
    }
    set ssrRenderTarget(value) {
        if (this._objRef) {
            this._objRef.ssrRenderTarget = value;
        }
    }
    // @ts-ignore
    get ssrRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.ssrRenderTarget;
    }
    set blurRenderTarget(value) {
        if (this._objRef) {
            this._objRef.blurRenderTarget = value;
        }
    }
    // @ts-ignore
    get blurRenderTarget() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurRenderTarget;
    }
    set blurRenderTarget2(value) {
        if (this._objRef) {
            this._objRef.blurRenderTarget2 = value;
        }
    }
    // @ts-ignore
    get blurRenderTarget2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurRenderTarget2;
    }
    set ssrMaterial(value) {
        if (this._objRef) {
            this._objRef.ssrMaterial = value;
        }
    }
    // @ts-ignore
    get ssrMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.ssrMaterial;
    }
    set normalMaterial(value) {
        if (this._objRef) {
            this._objRef.normalMaterial = value;
        }
    }
    // @ts-ignore
    get normalMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normalMaterial;
    }
    set metalnessOnMaterial(value) {
        if (this._objRef) {
            this._objRef.metalnessOnMaterial = value;
        }
    }
    // @ts-ignore
    get metalnessOnMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metalnessOnMaterial;
    }
    set metalnessOffMaterial(value) {
        if (this._objRef) {
            this._objRef.metalnessOffMaterial = value;
        }
    }
    // @ts-ignore
    get metalnessOffMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.metalnessOffMaterial;
    }
    set blurMaterial(value) {
        if (this._objRef) {
            this._objRef.blurMaterial = value;
        }
    }
    // @ts-ignore
    get blurMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurMaterial;
    }
    set blurMaterial2(value) {
        if (this._objRef) {
            this._objRef.blurMaterial2 = value;
        }
    }
    // @ts-ignore
    get blurMaterial2() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.blurMaterial2;
    }
    set depthRenderMaterial(value) {
        if (this._objRef) {
            this._objRef.depthRenderMaterial = value;
        }
    }
    // @ts-ignore
    get depthRenderMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.depthRenderMaterial;
    }
    set copyMaterial(value) {
        if (this._objRef) {
            this._objRef.copyMaterial = value;
        }
    }
    // @ts-ignore
    get copyMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyMaterial;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
    set originalClearColor(value) {
        if (this._objRef) {
            this._objRef.originalClearColor = applyValue(this._objRef.originalClearColor, value);
        }
    }
    // @ts-ignore
    get originalClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.originalClearColor;
    }
    set dispose(value) {
        if (this._objRef) {
            this._objRef.dispose = value;
        }
    }
    // @ts-ignore
    get dispose() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dispose;
    }
    set renderPass(value) {
        if (this._objRef) {
            this._objRef.renderPass = value;
        }
    }
    // @ts-ignore
    get renderPass() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderPass;
    }
    set renderOverride(value) {
        if (this._objRef) {
            this._objRef.renderOverride = value;
        }
    }
    // @ts-ignore
    get renderOverride() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderOverride;
    }
    set renderMetalness(value) {
        if (this._objRef) {
            this._objRef.renderMetalness = value;
        }
    }
    // @ts-ignore
    get renderMetalness() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderMetalness;
    }
}
ThSSRPass.OUTPUT = SSRPass.OUTPUT;
ThSSRPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSRPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThSSRPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThSSRPass, selector: "th-sSRPass", inputs: { width: "width", height: "height", clear: "clear", renderer: "renderer", scene: "scene", camera: "camera", groundReflector: "groundReflector", opacity: "opacity", output: "output", maxDistance: "maxDistance", thickness: "thickness", tempColor: "tempColor", selective: "selective", blur: "blur", thickTolerance: "thickTolerance", beautyRenderTarget: "beautyRenderTarget", prevRenderTarget: "prevRenderTarget", normalRenderTarget: "normalRenderTarget", metalnessRenderTarget: "metalnessRenderTarget", ssrRenderTarget: "ssrRenderTarget", blurRenderTarget: "blurRenderTarget", blurRenderTarget2: "blurRenderTarget2", ssrMaterial: "ssrMaterial", normalMaterial: "normalMaterial", metalnessOnMaterial: "metalnessOnMaterial", metalnessOffMaterial: "metalnessOffMaterial", blurMaterial: "blurMaterial", blurMaterial2: "blurMaterial2", depthRenderMaterial: "depthRenderMaterial", copyMaterial: "copyMaterial", fsQuad: "fsQuad", originalClearColor: "originalClearColor", dispose: "dispose", renderPass: "renderPass", renderOverride: "renderOverride", renderMetalness: "renderMetalness" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSRPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThSSRPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-sSRPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThSSRPass) }]
                }]
        }], propDecorators: { width: [{
                type: Input
            }], height: [{
                type: Input
            }], clear: [{
                type: Input
            }], renderer: [{
                type: Input
            }], scene: [{
                type: Input
            }], camera: [{
                type: Input
            }], groundReflector: [{
                type: Input
            }], opacity: [{
                type: Input
            }], output: [{
                type: Input
            }], maxDistance: [{
                type: Input
            }], thickness: [{
                type: Input
            }], tempColor: [{
                type: Input
            }], selective: [{
                type: Input
            }], blur: [{
                type: Input
            }], thickTolerance: [{
                type: Input
            }], beautyRenderTarget: [{
                type: Input
            }], prevRenderTarget: [{
                type: Input
            }], normalRenderTarget: [{
                type: Input
            }], metalnessRenderTarget: [{
                type: Input
            }], ssrRenderTarget: [{
                type: Input
            }], blurRenderTarget: [{
                type: Input
            }], blurRenderTarget2: [{
                type: Input
            }], ssrMaterial: [{
                type: Input
            }], normalMaterial: [{
                type: Input
            }], metalnessOnMaterial: [{
                type: Input
            }], metalnessOffMaterial: [{
                type: Input
            }], blurMaterial: [{
                type: Input
            }], blurMaterial2: [{
                type: Input
            }], depthRenderMaterial: [{
                type: Input
            }], copyMaterial: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }], originalClearColor: [{
                type: Input
            }], dispose: [{
                type: Input
            }], renderPass: [{
                type: Input
            }], renderOverride: [{
                type: Input
            }], renderMetalness: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThStereoCamera extends ThCamera {
    getType() {
        return StereoCamera;
    }
    set type(value) {
        if (this._objRef) {
            this._objRef.type = value;
        }
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    set aspect(value) {
        if (this._objRef) {
            this._objRef.aspect = value;
        }
    }
    // @ts-ignore
    get aspect() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.aspect;
    }
    set eyeSep(value) {
        if (this._objRef) {
            this._objRef.eyeSep = value;
        }
    }
    // @ts-ignore
    get eyeSep() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.eyeSep;
    }
    set cameraL(value) {
        if (this._objRef) {
            this._objRef.cameraL = value;
        }
    }
    // @ts-ignore
    get cameraL() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cameraL;
    }
    set cameraR(value) {
        if (this._objRef) {
            this._objRef.cameraR = value;
        }
    }
    // @ts-ignore
    get cameraR() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.cameraR;
    }
}
ThStereoCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThStereoCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThStereoCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThStereoCamera, selector: "th-stereoCamera", inputs: { type: "type", aspect: "aspect", eyeSep: "eyeSep", cameraL: "cameraL", cameraR: "cameraR" }, providers: [
        { provide: ThObject3D, useExisting: forwardRef(() => ThStereoCamera) },
        { provide: ThCamera, useExisting: forwardRef(() => ThStereoCamera) }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThStereoCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-stereoCamera',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: ThObject3D, useExisting: forwardRef(() => ThStereoCamera) },
                        { provide: ThCamera, useExisting: forwardRef(() => ThStereoCamera) }
                    ]
                }]
        }], propDecorators: { type: [{
                type: Input
            }], aspect: [{
                type: Input
            }], eyeSep: [{
                type: Input
            }], cameraL: [{
                type: Input
            }], cameraR: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThTAARenderPass extends ThSSAARenderPass {
    getType() {
        return TAARenderPass;
    }
    set accumulate(value) {
        if (this._objRef) {
            this._objRef.accumulate = value;
        }
    }
    // @ts-ignore
    get accumulate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.accumulate;
    }
}
ThTAARenderPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTAARenderPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTAARenderPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTAARenderPass, selector: "th-tAARenderPass", inputs: { accumulate: "accumulate" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThTAARenderPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTAARenderPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-tAARenderPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThTAARenderPass) }]
                }]
        }], propDecorators: { accumulate: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTeapotGeometry extends ThBufferGeometry {
    getType() {
        return TeapotGeometry;
    }
}
ThTeapotGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTeapotGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTeapotGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTeapotGeometry, selector: "th-teapotGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTeapotGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTeapotGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-teapotGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTeapotGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTetrahedronGeometry extends ThPolyhedronGeometry {
    getType() {
        return TetrahedronGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
}
ThTetrahedronGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTetrahedronGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTetrahedronGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTetrahedronGeometry, selector: "th-tetrahedronGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTetrahedronGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTetrahedronGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-tetrahedronGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTetrahedronGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTextGeometry extends ThExtrudeGeometry {
    getType() {
        return TextGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThTextGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTextGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTextGeometry, selector: "th-textGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTextGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-textGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTextGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/ban-types */
class ThTexturePass extends ThPass {
    getType() {
        return TexturePass;
    }
    set map(value) {
        if (this._objRef) {
            this._objRef.map = value;
        }
    }
    // @ts-ignore
    get map() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.map;
    }
    set opacity(value) {
        if (this._objRef) {
            this._objRef.opacity = value;
        }
    }
    // @ts-ignore
    get opacity() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.opacity;
    }
    set uniforms(map) {
        if (this._objRef) {
            Object.assign(this._objRef.uniforms, map);
        }
    }
    // @ts-ignore
    get uniforms() {
        var _a;
        // @ts-ignore
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.uniforms;
    }
    set material(value) {
        if (this._objRef) {
            this._objRef.material = value;
        }
    }
    // @ts-ignore
    get material() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.material;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThTexturePass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTexturePass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTexturePass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTexturePass, selector: "th-texturePass", inputs: { map: "map", opacity: "opacity", uniforms: "uniforms", material: "material", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThTexturePass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTexturePass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-texturePass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThTexturePass) }]
                }]
        }], propDecorators: { map: [{
                type: Input
            }], opacity: [{
                type: Input
            }], uniforms: [{
                type: Input
            }], material: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTorusGeometry extends ThBufferGeometry {
    getType() {
        return TorusGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThTorusGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTorusGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTorusGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTorusGeometry, selector: "th-torusGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTorusGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTorusGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-torusGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTorusGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTorusKnotGeometry extends ThBufferGeometry {
    getType() {
        return TorusKnotGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThTorusKnotGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTorusKnotGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTorusKnotGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTorusKnotGeometry, selector: "th-torusKnotGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTorusKnotGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTorusKnotGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-torusKnotGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTorusKnotGeometry)
                        }
                    ]
                }]
        }] });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTrackballControls extends ThControlBase {
    getType() {
        return TrackballControls;
    }
    set object(value) {
        if (this._objRef) {
            this._objRef.object = value;
        }
    }
    // @ts-ignore
    get object() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.object;
    }
    set domElement(value) {
        if (this._objRef) {
            this._objRef.domElement = value;
        }
    }
    // @ts-ignore
    get domElement() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.domElement;
    }
    set enabled(value) {
        if (this._objRef) {
            this._objRef.enabled = value;
        }
    }
    // @ts-ignore
    get enabled() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.enabled;
    }
    set screen(value) {
        if (this._objRef) {
            this._objRef.screen = value;
        }
    }
    // @ts-ignore
    get screen() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.screen;
    }
    set rotateSpeed(value) {
        if (this._objRef) {
            this._objRef.rotateSpeed = value;
        }
    }
    // @ts-ignore
    get rotateSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.rotateSpeed;
    }
    set zoomSpeed(value) {
        if (this._objRef) {
            this._objRef.zoomSpeed = value;
        }
    }
    // @ts-ignore
    get zoomSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.zoomSpeed;
    }
    set panSpeed(value) {
        if (this._objRef) {
            this._objRef.panSpeed = value;
        }
    }
    // @ts-ignore
    get panSpeed() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.panSpeed;
    }
    set noRotate(value) {
        if (this._objRef) {
            this._objRef.noRotate = value;
        }
    }
    // @ts-ignore
    get noRotate() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.noRotate;
    }
    set noZoom(value) {
        if (this._objRef) {
            this._objRef.noZoom = value;
        }
    }
    // @ts-ignore
    get noZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.noZoom;
    }
    set noPan(value) {
        if (this._objRef) {
            this._objRef.noPan = value;
        }
    }
    // @ts-ignore
    get noPan() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.noPan;
    }
    set noRoll(value) {
        if (this._objRef) {
            this._objRef.noRoll = value;
        }
    }
    // @ts-ignore
    get noRoll() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.noRoll;
    }
    set staticMoving(value) {
        if (this._objRef) {
            this._objRef.staticMoving = value;
        }
    }
    // @ts-ignore
    get staticMoving() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.staticMoving;
    }
    set dynamicDampingFactor(value) {
        if (this._objRef) {
            this._objRef.dynamicDampingFactor = value;
        }
    }
    // @ts-ignore
    get dynamicDampingFactor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.dynamicDampingFactor;
    }
    set minDistance(value) {
        if (this._objRef) {
            this._objRef.minDistance = value;
        }
    }
    // @ts-ignore
    get minDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minDistance;
    }
    set maxDistance(value) {
        if (this._objRef) {
            this._objRef.maxDistance = value;
        }
    }
    // @ts-ignore
    get maxDistance() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxDistance;
    }
    set minZoom(value) {
        if (this._objRef) {
            this._objRef.minZoom = value;
        }
    }
    // @ts-ignore
    get minZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minZoom;
    }
    set maxZoom(value) {
        if (this._objRef) {
            this._objRef.maxZoom = value;
        }
    }
    // @ts-ignore
    get maxZoom() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.maxZoom;
    }
    set keys(value) {
        if (this._objRef) {
            this._objRef.keys = value;
        }
    }
    // @ts-ignore
    get keys() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.keys;
    }
    set mouseButtons(value) {
        if (this._objRef) {
            this._objRef.mouseButtons = value;
        }
    }
    // @ts-ignore
    get mouseButtons() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.mouseButtons;
    }
    set target(value) {
        if (this._objRef) {
            this._objRef.target = applyValue(this._objRef.target, value);
        }
    }
    // @ts-ignore
    get target() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target;
    }
    set position0(value) {
        if (this._objRef) {
            this._objRef.position0 = applyValue(this._objRef.position0, value);
        }
    }
    // @ts-ignore
    get position0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.position0;
    }
    set target0(value) {
        if (this._objRef) {
            this._objRef.target0 = applyValue(this._objRef.target0, value);
        }
    }
    // @ts-ignore
    get target0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.target0;
    }
    set up0(value) {
        if (this._objRef) {
            this._objRef.up0 = applyValue(this._objRef.up0, value);
        }
    }
    // @ts-ignore
    get up0() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.up0;
    }
}
ThTrackballControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTrackballControls, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTrackballControls.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTrackballControls, selector: "th-trackballControls", inputs: { object: "object", domElement: "domElement", enabled: "enabled", screen: "screen", rotateSpeed: "rotateSpeed", zoomSpeed: "zoomSpeed", panSpeed: "panSpeed", noRotate: "noRotate", noZoom: "noZoom", noPan: "noPan", noRoll: "noRoll", staticMoving: "staticMoving", dynamicDampingFactor: "dynamicDampingFactor", minDistance: "minDistance", maxDistance: "maxDistance", minZoom: "minZoom", maxZoom: "maxZoom", keys: "keys", mouseButtons: "mouseButtons", target: "target", position0: "position0", target0: "target0", up0: "up0" }, providers: [
        {
            provide: ThControlBase,
            useExisting: forwardRef(() => ThTrackballControls)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTrackballControls, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-trackballControls',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThControlBase,
                            useExisting: forwardRef(() => ThTrackballControls)
                        }
                    ]
                }]
        }], propDecorators: { object: [{
                type: Input
            }], domElement: [{
                type: Input
            }], enabled: [{
                type: Input
            }], screen: [{
                type: Input
            }], rotateSpeed: [{
                type: Input
            }], zoomSpeed: [{
                type: Input
            }], panSpeed: [{
                type: Input
            }], noRotate: [{
                type: Input
            }], noZoom: [{
                type: Input
            }], noPan: [{
                type: Input
            }], noRoll: [{
                type: Input
            }], staticMoving: [{
                type: Input
            }], dynamicDampingFactor: [{
                type: Input
            }], minDistance: [{
                type: Input
            }], maxDistance: [{
                type: Input
            }], minZoom: [{
                type: Input
            }], maxZoom: [{
                type: Input
            }], keys: [{
                type: Input
            }], mouseButtons: [{
                type: Input
            }], target: [{
                type: Input
            }], position0: [{
                type: Input
            }], target0: [{
                type: Input
            }], up0: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThTubeGeometry extends ThBufferGeometry {
    getType() {
        return TubeGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
    set tangents(value) {
        if (this._objRef) {
            this._objRef.tangents = value;
        }
    }
    // @ts-ignore
    get tangents() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.tangents;
    }
    set normals(value) {
        if (this._objRef) {
            this._objRef.normals = value;
        }
    }
    // @ts-ignore
    get normals() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.normals;
    }
    set binormals(value) {
        if (this._objRef) {
            this._objRef.binormals = value;
        }
    }
    // @ts-ignore
    get binormals() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.binormals;
    }
}
ThTubeGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTubeGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThTubeGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThTubeGeometry, selector: "th-tubeGeometry", inputs: { tangents: "tangents", normals: "normals", binormals: "binormals" }, providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThTubeGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTubeGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-tubeGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThTubeGeometry)
                        }
                    ]
                }]
        }], propDecorators: { tangents: [{
                type: Input
            }], normals: [{
                type: Input
            }], binormals: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/ban-types */
class ThUnrealBloomPass extends ThPass {
    getType() {
        return UnrealBloomPass;
    }
    set resolution(value) {
        if (this._objRef) {
            this._objRef.resolution = applyValue(this._objRef.resolution, value);
        }
    }
    // @ts-ignore
    get resolution() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.resolution;
    }
    set strength(value) {
        if (this._objRef) {
            this._objRef.strength = value;
        }
    }
    // @ts-ignore
    get strength() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.strength;
    }
    set radius(value) {
        if (this._objRef) {
            this._objRef.radius = value;
        }
    }
    // @ts-ignore
    get radius() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.radius;
    }
    set threshold(value) {
        if (this._objRef) {
            this._objRef.threshold = value;
        }
    }
    // @ts-ignore
    get threshold() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.threshold;
    }
    set clearColor(value) {
        if (this._objRef) {
            this._objRef.clearColor = applyValue(this._objRef.clearColor, value);
        }
    }
    // @ts-ignore
    get clearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.clearColor;
    }
    set renderTargetsHorizontal(value) {
        if (this._objRef) {
            this._objRef.renderTargetsHorizontal = value;
        }
    }
    // @ts-ignore
    get renderTargetsHorizontal() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetsHorizontal;
    }
    set renderTargetsVertical(value) {
        if (this._objRef) {
            this._objRef.renderTargetsVertical = value;
        }
    }
    // @ts-ignore
    get renderTargetsVertical() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetsVertical;
    }
    set nMips(value) {
        if (this._objRef) {
            this._objRef.nMips = value;
        }
    }
    // @ts-ignore
    get nMips() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.nMips;
    }
    set renderTargetBright(value) {
        if (this._objRef) {
            this._objRef.renderTargetBright = value;
        }
    }
    // @ts-ignore
    get renderTargetBright() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.renderTargetBright;
    }
    set highPassUniforms(value) {
        if (this._objRef) {
            this._objRef.highPassUniforms = value;
        }
    }
    // @ts-ignore
    get highPassUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.highPassUniforms;
    }
    set materialHighPassFilter(value) {
        if (this._objRef) {
            this._objRef.materialHighPassFilter = value;
        }
    }
    // @ts-ignore
    get materialHighPassFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialHighPassFilter;
    }
    set separableBlurMaterials(value) {
        if (this._objRef) {
            this._objRef.separableBlurMaterials = value;
        }
    }
    // @ts-ignore
    get separableBlurMaterials() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.separableBlurMaterials;
    }
    set compositeMaterial(value) {
        if (this._objRef) {
            this._objRef.compositeMaterial = value;
        }
    }
    // @ts-ignore
    get compositeMaterial() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.compositeMaterial;
    }
    set bloomTintColors(value) {
        if (this._objRef) {
            this._objRef.bloomTintColors = value;
        }
    }
    // @ts-ignore
    get bloomTintColors() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.bloomTintColors;
    }
    set copyUniforms(value) {
        if (this._objRef) {
            this._objRef.copyUniforms = value;
        }
    }
    // @ts-ignore
    get copyUniforms() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.copyUniforms;
    }
    set materialCopy(value) {
        if (this._objRef) {
            this._objRef.materialCopy = value;
        }
    }
    // @ts-ignore
    get materialCopy() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.materialCopy;
    }
    set oldClearColor(value) {
        if (this._objRef) {
            this._objRef.oldClearColor = applyValue(this._objRef.oldClearColor, value);
        }
    }
    // @ts-ignore
    get oldClearColor() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearColor;
    }
    set oldClearAlpha(value) {
        if (this._objRef) {
            this._objRef.oldClearAlpha = value;
        }
    }
    // @ts-ignore
    get oldClearAlpha() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.oldClearAlpha;
    }
    set basic(value) {
        if (this._objRef) {
            this._objRef.basic = value;
        }
    }
    // @ts-ignore
    get basic() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.basic;
    }
    set fsQuad(value) {
        if (this._objRef) {
            this._objRef.fsQuad = value;
        }
    }
    // @ts-ignore
    get fsQuad() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.fsQuad;
    }
}
ThUnrealBloomPass.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThUnrealBloomPass, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThUnrealBloomPass.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThUnrealBloomPass, selector: "th-unrealBloomPass", inputs: { resolution: "resolution", strength: "strength", radius: "radius", threshold: "threshold", clearColor: "clearColor", renderTargetsHorizontal: "renderTargetsHorizontal", renderTargetsVertical: "renderTargetsVertical", nMips: "nMips", renderTargetBright: "renderTargetBright", highPassUniforms: "highPassUniforms", materialHighPassFilter: "materialHighPassFilter", separableBlurMaterials: "separableBlurMaterials", compositeMaterial: "compositeMaterial", bloomTintColors: "bloomTintColors", copyUniforms: "copyUniforms", materialCopy: "materialCopy", oldClearColor: "oldClearColor", oldClearAlpha: "oldClearAlpha", basic: "basic", fsQuad: "fsQuad" }, providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThUnrealBloomPass) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThUnrealBloomPass, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-unrealBloomPass',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThPassBase, useExisting: forwardRef(() => ThUnrealBloomPass) }]
                }]
        }], propDecorators: { resolution: [{
                type: Input
            }], strength: [{
                type: Input
            }], radius: [{
                type: Input
            }], threshold: [{
                type: Input
            }], clearColor: [{
                type: Input
            }], renderTargetsHorizontal: [{
                type: Input
            }], renderTargetsVertical: [{
                type: Input
            }], nMips: [{
                type: Input
            }], renderTargetBright: [{
                type: Input
            }], highPassUniforms: [{
                type: Input
            }], materialHighPassFilter: [{
                type: Input
            }], separableBlurMaterials: [{
                type: Input
            }], compositeMaterial: [{
                type: Input
            }], bloomTintColors: [{
                type: Input
            }], copyUniforms: [{
                type: Input
            }], materialCopy: [{
                type: Input
            }], oldClearColor: [{
                type: Input
            }], oldClearAlpha: [{
                type: Input
            }], basic: [{
                type: Input
            }], fsQuad: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThVideoTexture extends ThTexture {
    getType() {
        return VideoTexture;
    }
    // @ts-ignore
    get isVideoTexture() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.isVideoTexture;
    }
    set magFilter(value) {
        if (this._objRef) {
            this._objRef.magFilter = value;
        }
    }
    // @ts-ignore
    get magFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.magFilter;
    }
    set minFilter(value) {
        if (this._objRef) {
            this._objRef.minFilter = value;
        }
    }
    // @ts-ignore
    get minFilter() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.minFilter;
    }
    set generateMipmaps(value) {
        if (this._objRef) {
            this._objRef.generateMipmaps = value;
        }
    }
    // @ts-ignore
    get generateMipmaps() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.generateMipmaps;
    }
}
ThVideoTexture.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThVideoTexture, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThVideoTexture.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThVideoTexture, selector: "th-videoTexture", inputs: { magFilter: "magFilter", minFilter: "minFilter", generateMipmaps: "generateMipmaps" }, providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThVideoTexture) }], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThVideoTexture, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-videoTexture',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: ThTextureBase, useExisting: forwardRef(() => ThVideoTexture) }]
                }]
        }], propDecorators: { magFilter: [{
                type: Input
            }], minFilter: [{
                type: Input
            }], generateMipmaps: [{
                type: Input
            }] } });

/* eslint-disable @typescript-eslint/naming-convention */
class ThWireframeGeometry extends ThBufferGeometry {
    getType() {
        return WireframeGeometry;
    }
    // @ts-ignore
    get type() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.type;
    }
    // @ts-ignore
    get parameters() {
        var _a;
        return (_a = this._objRef) === null || _a === void 0 ? void 0 : _a.parameters;
    }
}
ThWireframeGeometry.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThWireframeGeometry, deps: null, target: i0.ɵɵFactoryTarget.Component });
ThWireframeGeometry.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: ThWireframeGeometry, selector: "th-wireframeGeometry", providers: [
        {
            provide: ThBufferGeometry,
            useExisting: forwardRef(() => ThWireframeGeometry)
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThWireframeGeometry, decorators: [{
            type: Component,
            args: [{
                    selector: 'th-wireframeGeometry',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: ThBufferGeometry,
                            useExisting: forwardRef(() => ThWireframeGeometry)
                        }
                    ]
                }]
        }] });

class NgxThreeGeneratedModule {
}
NgxThreeGeneratedModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeGeneratedModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxThreeGeneratedModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeGeneratedModule, declarations: [ThTransformControlsGen,
        ThTransformControls,
        ThArcballControls,
        ThDragControls,
        ThFirstPersonControls,
        ThFlyControls,
        ThOrbitControls,
        ThMapControls,
        ThPointerLockControls,
        ThTrackballControls,
        ThAudioListener,
        ThPositionalAudio,
        ThAudio,
        ThStereoCamera,
        ThPerspectiveCamera,
        ThOrthographicCamera,
        ThCubeCamera,
        ThArrayCamera,
        ThObject3D,
        ThSpotLightHelper,
        ThSkeletonHelper,
        ThPointLightHelper,
        ThHemisphereLightHelper,
        ThGridHelper,
        ThPolarGridHelper,
        ThDirectionalLightHelper,
        ThCameraHelper,
        ThBoxHelper,
        ThBox3Helper,
        ThPlaneHelper,
        ThArrowHelper,
        ThAxesHelper,
        ThSpotLight,
        ThPointLight,
        ThRectAreaLight,
        ThHemisphereLight,
        ThDirectionalLight,
        ThAmbientLight,
        ThAmbientLightProbe,
        ThHemisphereLightProbe,
        ThLightProbe,
        ThSprite,
        ThLOD,
        ThInstancedMesh,
        ThSkinnedMesh,
        ThBone,
        ThMesh,
        ThLineSegments,
        ThLineLoop,
        ThLine,
        ThPoints,
        ThGroup,
        ThScene,
        ThShadowMaterial,
        ThSpriteMaterial,
        ThRawShaderMaterial,
        ThShaderMaterial,
        ThPointsMaterial,
        ThMeshPhysicalMaterial,
        ThMeshStandardMaterial,
        ThMeshPhongMaterial,
        ThMeshToonMaterial,
        ThMeshNormalMaterial,
        ThMeshLambertMaterial,
        ThMeshDepthMaterial,
        ThMeshDistanceMaterial,
        ThMeshBasicMaterial,
        ThMeshMatcapMaterial,
        ThLineDashedMaterial,
        ThLineBasicMaterial,
        ThMaterial,
        ThInstancedBufferGeometry,
        ThBufferGeometry,
        ThBoxGeometry,
        ThCapsuleGeometry,
        ThCircleGeometry,
        ThConeGeometry,
        ThCylinderGeometry,
        ThDodecahedronGeometry,
        ThEdgesGeometry,
        ThExtrudeGeometry,
        ThIcosahedronGeometry,
        ThLatheGeometry,
        ThOctahedronGeometry,
        ThPlaneGeometry,
        ThPolyhedronGeometry,
        ThRingGeometry,
        ThShapeGeometry,
        ThSphereGeometry,
        ThTetrahedronGeometry,
        ThTorusGeometry,
        ThTorusKnotGeometry,
        ThTubeGeometry,
        ThWireframeGeometry,
        ThBoxLineGeometry,
        ThConvexGeometry,
        ThDecalGeometry,
        ThLightningStrike,
        ThParametricGeometry,
        ThRoundedBoxGeometry,
        ThTeapotGeometry,
        ThTextGeometry,
        ThPass,
        ThEffectComposerGen,
        ThEffectComposer,
        ThAdaptiveToneMappingPass,
        ThAfterimagePass,
        ThBloomPass,
        ThBokehPass,
        ThClearPass,
        ThCubeTexturePass,
        ThDotScreenPass,
        ThFilmPass,
        ThGlitchPass,
        ThHalftonePass,
        ThLUTPass,
        ThMaskPass,
        ThClearMaskPass,
        ThOutlinePass,
        ThRenderPassGen,
        ThRenderPass,
        ThSAOPass,
        ThSMAAPass,
        ThSSAARenderPass,
        ThSSAOPass,
        ThSSRPass,
        ThSavePass,
        ThShaderPass,
        ThTAARenderPass,
        ThTexturePass,
        ThUnrealBloomPass,
        ThVideoTexture,
        ThCompressedArrayTexture,
        ThDataTexture,
        ThCompressedTexture,
        ThCubeTexture,
        ThData3DTexture,
        ThDataArrayTexture,
        ThCanvasTexture,
        ThDepthTexture,
        ThFramebufferTexture,
        ThTexture], exports: [ThTransformControlsGen,
        ThTransformControls,
        ThArcballControls,
        ThDragControls,
        ThFirstPersonControls,
        ThFlyControls,
        ThOrbitControls,
        ThMapControls,
        ThPointerLockControls,
        ThTrackballControls,
        ThAudioListener,
        ThPositionalAudio,
        ThAudio,
        ThStereoCamera,
        ThPerspectiveCamera,
        ThOrthographicCamera,
        ThCubeCamera,
        ThArrayCamera,
        ThObject3D,
        ThSpotLightHelper,
        ThSkeletonHelper,
        ThPointLightHelper,
        ThHemisphereLightHelper,
        ThGridHelper,
        ThPolarGridHelper,
        ThDirectionalLightHelper,
        ThCameraHelper,
        ThBoxHelper,
        ThBox3Helper,
        ThPlaneHelper,
        ThArrowHelper,
        ThAxesHelper,
        ThSpotLight,
        ThPointLight,
        ThRectAreaLight,
        ThHemisphereLight,
        ThDirectionalLight,
        ThAmbientLight,
        ThAmbientLightProbe,
        ThHemisphereLightProbe,
        ThLightProbe,
        ThSprite,
        ThLOD,
        ThInstancedMesh,
        ThSkinnedMesh,
        ThBone,
        ThMesh,
        ThLineSegments,
        ThLineLoop,
        ThLine,
        ThPoints,
        ThGroup,
        ThScene,
        ThShadowMaterial,
        ThSpriteMaterial,
        ThRawShaderMaterial,
        ThShaderMaterial,
        ThPointsMaterial,
        ThMeshPhysicalMaterial,
        ThMeshStandardMaterial,
        ThMeshPhongMaterial,
        ThMeshToonMaterial,
        ThMeshNormalMaterial,
        ThMeshLambertMaterial,
        ThMeshDepthMaterial,
        ThMeshDistanceMaterial,
        ThMeshBasicMaterial,
        ThMeshMatcapMaterial,
        ThLineDashedMaterial,
        ThLineBasicMaterial,
        ThMaterial,
        ThInstancedBufferGeometry,
        ThBufferGeometry,
        ThBoxGeometry,
        ThCapsuleGeometry,
        ThCircleGeometry,
        ThConeGeometry,
        ThCylinderGeometry,
        ThDodecahedronGeometry,
        ThEdgesGeometry,
        ThExtrudeGeometry,
        ThIcosahedronGeometry,
        ThLatheGeometry,
        ThOctahedronGeometry,
        ThPlaneGeometry,
        ThPolyhedronGeometry,
        ThRingGeometry,
        ThShapeGeometry,
        ThSphereGeometry,
        ThTetrahedronGeometry,
        ThTorusGeometry,
        ThTorusKnotGeometry,
        ThTubeGeometry,
        ThWireframeGeometry,
        ThBoxLineGeometry,
        ThConvexGeometry,
        ThDecalGeometry,
        ThLightningStrike,
        ThParametricGeometry,
        ThRoundedBoxGeometry,
        ThTeapotGeometry,
        ThTextGeometry,
        ThPass,
        ThEffectComposerGen,
        ThEffectComposer,
        ThAdaptiveToneMappingPass,
        ThAfterimagePass,
        ThBloomPass,
        ThBokehPass,
        ThClearPass,
        ThCubeTexturePass,
        ThDotScreenPass,
        ThFilmPass,
        ThGlitchPass,
        ThHalftonePass,
        ThLUTPass,
        ThMaskPass,
        ThClearMaskPass,
        ThOutlinePass,
        ThRenderPassGen,
        ThRenderPass,
        ThSAOPass,
        ThSMAAPass,
        ThSSAARenderPass,
        ThSSAOPass,
        ThSSRPass,
        ThSavePass,
        ThShaderPass,
        ThTAARenderPass,
        ThTexturePass,
        ThUnrealBloomPass,
        ThVideoTexture,
        ThCompressedArrayTexture,
        ThDataTexture,
        ThCompressedTexture,
        ThCubeTexture,
        ThData3DTexture,
        ThDataArrayTexture,
        ThCanvasTexture,
        ThDepthTexture,
        ThFramebufferTexture,
        ThTexture] });
NgxThreeGeneratedModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeGeneratedModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeGeneratedModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ThTransformControlsGen,
                        ThTransformControls,
                        ThArcballControls,
                        ThDragControls,
                        ThFirstPersonControls,
                        ThFlyControls,
                        ThOrbitControls,
                        ThMapControls,
                        ThPointerLockControls,
                        ThTrackballControls,
                        ThAudioListener,
                        ThPositionalAudio,
                        ThAudio,
                        ThStereoCamera,
                        ThPerspectiveCamera,
                        ThOrthographicCamera,
                        ThCubeCamera,
                        ThArrayCamera,
                        ThObject3D,
                        ThSpotLightHelper,
                        ThSkeletonHelper,
                        ThPointLightHelper,
                        ThHemisphereLightHelper,
                        ThGridHelper,
                        ThPolarGridHelper,
                        ThDirectionalLightHelper,
                        ThCameraHelper,
                        ThBoxHelper,
                        ThBox3Helper,
                        ThPlaneHelper,
                        ThArrowHelper,
                        ThAxesHelper,
                        ThSpotLight,
                        ThPointLight,
                        ThRectAreaLight,
                        ThHemisphereLight,
                        ThDirectionalLight,
                        ThAmbientLight,
                        ThAmbientLightProbe,
                        ThHemisphereLightProbe,
                        ThLightProbe,
                        ThSprite,
                        ThLOD,
                        ThInstancedMesh,
                        ThSkinnedMesh,
                        ThBone,
                        ThMesh,
                        ThLineSegments,
                        ThLineLoop,
                        ThLine,
                        ThPoints,
                        ThGroup,
                        ThScene,
                        ThShadowMaterial,
                        ThSpriteMaterial,
                        ThRawShaderMaterial,
                        ThShaderMaterial,
                        ThPointsMaterial,
                        ThMeshPhysicalMaterial,
                        ThMeshStandardMaterial,
                        ThMeshPhongMaterial,
                        ThMeshToonMaterial,
                        ThMeshNormalMaterial,
                        ThMeshLambertMaterial,
                        ThMeshDepthMaterial,
                        ThMeshDistanceMaterial,
                        ThMeshBasicMaterial,
                        ThMeshMatcapMaterial,
                        ThLineDashedMaterial,
                        ThLineBasicMaterial,
                        ThMaterial,
                        ThInstancedBufferGeometry,
                        ThBufferGeometry,
                        ThBoxGeometry,
                        ThCapsuleGeometry,
                        ThCircleGeometry,
                        ThConeGeometry,
                        ThCylinderGeometry,
                        ThDodecahedronGeometry,
                        ThEdgesGeometry,
                        ThExtrudeGeometry,
                        ThIcosahedronGeometry,
                        ThLatheGeometry,
                        ThOctahedronGeometry,
                        ThPlaneGeometry,
                        ThPolyhedronGeometry,
                        ThRingGeometry,
                        ThShapeGeometry,
                        ThSphereGeometry,
                        ThTetrahedronGeometry,
                        ThTorusGeometry,
                        ThTorusKnotGeometry,
                        ThTubeGeometry,
                        ThWireframeGeometry,
                        ThBoxLineGeometry,
                        ThConvexGeometry,
                        ThDecalGeometry,
                        ThLightningStrike,
                        ThParametricGeometry,
                        ThRoundedBoxGeometry,
                        ThTeapotGeometry,
                        ThTextGeometry,
                        ThPass,
                        ThEffectComposerGen,
                        ThEffectComposer,
                        ThAdaptiveToneMappingPass,
                        ThAfterimagePass,
                        ThBloomPass,
                        ThBokehPass,
                        ThClearPass,
                        ThCubeTexturePass,
                        ThDotScreenPass,
                        ThFilmPass,
                        ThGlitchPass,
                        ThHalftonePass,
                        ThLUTPass,
                        ThMaskPass,
                        ThClearMaskPass,
                        ThOutlinePass,
                        ThRenderPassGen,
                        ThRenderPass,
                        ThSAOPass,
                        ThSMAAPass,
                        ThSSAARenderPass,
                        ThSSAOPass,
                        ThSSRPass,
                        ThSavePass,
                        ThShaderPass,
                        ThTAARenderPass,
                        ThTexturePass,
                        ThUnrealBloomPass,
                        ThVideoTexture,
                        ThCompressedArrayTexture,
                        ThDataTexture,
                        ThCompressedTexture,
                        ThCubeTexture,
                        ThData3DTexture,
                        ThDataArrayTexture,
                        ThCanvasTexture,
                        ThDepthTexture,
                        ThFramebufferTexture,
                        ThTexture,
                    ],
                    exports: [
                        ThTransformControlsGen,
                        ThTransformControls,
                        ThArcballControls,
                        ThDragControls,
                        ThFirstPersonControls,
                        ThFlyControls,
                        ThOrbitControls,
                        ThMapControls,
                        ThPointerLockControls,
                        ThTrackballControls,
                        ThAudioListener,
                        ThPositionalAudio,
                        ThAudio,
                        ThStereoCamera,
                        ThPerspectiveCamera,
                        ThOrthographicCamera,
                        ThCubeCamera,
                        ThArrayCamera,
                        ThObject3D,
                        ThSpotLightHelper,
                        ThSkeletonHelper,
                        ThPointLightHelper,
                        ThHemisphereLightHelper,
                        ThGridHelper,
                        ThPolarGridHelper,
                        ThDirectionalLightHelper,
                        ThCameraHelper,
                        ThBoxHelper,
                        ThBox3Helper,
                        ThPlaneHelper,
                        ThArrowHelper,
                        ThAxesHelper,
                        ThSpotLight,
                        ThPointLight,
                        ThRectAreaLight,
                        ThHemisphereLight,
                        ThDirectionalLight,
                        ThAmbientLight,
                        ThAmbientLightProbe,
                        ThHemisphereLightProbe,
                        ThLightProbe,
                        ThSprite,
                        ThLOD,
                        ThInstancedMesh,
                        ThSkinnedMesh,
                        ThBone,
                        ThMesh,
                        ThLineSegments,
                        ThLineLoop,
                        ThLine,
                        ThPoints,
                        ThGroup,
                        ThScene,
                        ThShadowMaterial,
                        ThSpriteMaterial,
                        ThRawShaderMaterial,
                        ThShaderMaterial,
                        ThPointsMaterial,
                        ThMeshPhysicalMaterial,
                        ThMeshStandardMaterial,
                        ThMeshPhongMaterial,
                        ThMeshToonMaterial,
                        ThMeshNormalMaterial,
                        ThMeshLambertMaterial,
                        ThMeshDepthMaterial,
                        ThMeshDistanceMaterial,
                        ThMeshBasicMaterial,
                        ThMeshMatcapMaterial,
                        ThLineDashedMaterial,
                        ThLineBasicMaterial,
                        ThMaterial,
                        ThInstancedBufferGeometry,
                        ThBufferGeometry,
                        ThBoxGeometry,
                        ThCapsuleGeometry,
                        ThCircleGeometry,
                        ThConeGeometry,
                        ThCylinderGeometry,
                        ThDodecahedronGeometry,
                        ThEdgesGeometry,
                        ThExtrudeGeometry,
                        ThIcosahedronGeometry,
                        ThLatheGeometry,
                        ThOctahedronGeometry,
                        ThPlaneGeometry,
                        ThPolyhedronGeometry,
                        ThRingGeometry,
                        ThShapeGeometry,
                        ThSphereGeometry,
                        ThTetrahedronGeometry,
                        ThTorusGeometry,
                        ThTorusKnotGeometry,
                        ThTubeGeometry,
                        ThWireframeGeometry,
                        ThBoxLineGeometry,
                        ThConvexGeometry,
                        ThDecalGeometry,
                        ThLightningStrike,
                        ThParametricGeometry,
                        ThRoundedBoxGeometry,
                        ThTeapotGeometry,
                        ThTextGeometry,
                        ThPass,
                        ThEffectComposerGen,
                        ThEffectComposer,
                        ThAdaptiveToneMappingPass,
                        ThAfterimagePass,
                        ThBloomPass,
                        ThBokehPass,
                        ThClearPass,
                        ThCubeTexturePass,
                        ThDotScreenPass,
                        ThFilmPass,
                        ThGlitchPass,
                        ThHalftonePass,
                        ThLUTPass,
                        ThMaskPass,
                        ThClearMaskPass,
                        ThOutlinePass,
                        ThRenderPassGen,
                        ThRenderPass,
                        ThSAOPass,
                        ThSMAAPass,
                        ThSSAARenderPass,
                        ThSSAOPass,
                        ThSSRPass,
                        ThSavePass,
                        ThShaderPass,
                        ThTAARenderPass,
                        ThTexturePass,
                        ThUnrealBloomPass,
                        ThVideoTexture,
                        ThCompressedArrayTexture,
                        ThDataTexture,
                        ThCompressedTexture,
                        ThCubeTexture,
                        ThData3DTexture,
                        ThDataArrayTexture,
                        ThCanvasTexture,
                        ThDepthTexture,
                        ThFramebufferTexture,
                        ThTexture,
                    ],
                }]
        }] });

class ThLoader {
    setCrossOrigin(cors) {
        this.crossOrigin = cors;
    }
    setWithCredentials(credentials) {
        this.withCredentials = credentials;
    }
    createLoaderInstance() {
        const loader = new this.clazz();
        if (this.crossOrigin) {
            loader.setCrossOrigin(this.crossOrigin);
        }
        if (this.withCredentials !== undefined) {
            loader.setWithCredentials(this.withCredentials);
        }
        return loader;
    }
}

class ThCallbackLoaderService extends ThLoader {
    load(...args) {
        const loader = this.createLoaderInstance();
        return loader.load(...args);
    }
}
class ThCallbackLoaderBasePipe {
    transform(...args) {
        return this.service.load(...args);
    }
}
class ThCallbackLoaderBaseDirective {
    set url(url) {
        this._url = url;
        this.load();
    }
    get url() {
        return this._url;
    }
    get onLoaded() {
        if (!this.onLoaded$) {
            this.onLoaded$ = new EventEmitter();
        }
        return this.onLoaded$;
    }
    get onProgress() {
        if (!this.onProgress$) {
            this.onProgress$ = new EventEmitter();
        }
        return this.onProgress$;
    }
    constructor(host, zone) {
        this.host = host;
        this.zone = zone;
        this.initialized = false;
    }
    ngOnInit() {
        this.initialized = true;
        this.load();
        // this.zone.runOutsideAngular(() => );
    }
    load() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.initialized) {
                return;
            }
            if (this._url === undefined) {
                throw new Error('missing url');
            }
            const url = this._url;
            const onProgress = isObserved(this.onProgress$)
                ? (progress) => {
                    var _a;
                    (_a = this.onProgress$) === null || _a === void 0 ? void 0 : _a.next(progress);
                }
                : undefined;
            const onLoad = isObserved(this.onLoaded$)
                ? (...args) => {
                    var _a;
                    (_a = this.onLoaded$) === null || _a === void 0 ? void 0 : _a.next(args[0]);
                }
                : undefined;
            this.host.objRef = this.zone.runOutsideAngular(() => this.service.load(url, onProgress, onLoad));
        });
    }
}
ThCallbackLoaderBaseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCallbackLoaderBaseDirective, deps: "invalid", target: i0.ɵɵFactoryTarget.Directive });
ThCallbackLoaderBaseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThCallbackLoaderBaseDirective, inputs: { url: "url" }, outputs: { onLoaded: "onLoaded", onProgress: "onProgress" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCallbackLoaderBaseDirective, decorators: [{
            type: Directive,
            args: [{}]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }];
    }, propDecorators: { url: [{
                type: Input
            }], onLoaded: [{
                type: Output
            }], onProgress: [{
                type: Output
            }] } });

class DDSLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = DDSLoader;
    }
}
DDSLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DDSLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
DDSLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DDSLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DDSLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThDDSLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThDDSLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDDSLoaderPipe, deps: [{ token: DDSLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThDDSLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThDDSLoaderPipe, name: "loadDDSTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDDSLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadDDSTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: DDSLoaderService }]; } });
class ThDDSLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThDDSLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDDSLoaderDirective, deps: [{ token: ThCompressedTexture, host: true }, { token: i0.NgZone }, { token: DDSLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThDDSLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThDDSLoaderDirective, selector: "[loadDDSTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThDDSLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadDDSTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThCompressedTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: DDSLoaderService }];
    } });

class KTX2LoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = KTX2Loader;
        this.transcoderPath = '';
    }
    setDecoderPath(path) {
        this.transcoderPath = path;
    }
    createLoaderInstance() {
        const loader = super.createLoaderInstance();
        loader.setTranscoderPath(this.transcoderPath);
        return loader;
    }
}
KTX2LoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTX2LoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
KTX2LoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTX2LoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTX2LoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThKTX2LoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThKTX2LoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTX2LoaderPipe, deps: [{ token: KTX2LoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThKTX2LoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThKTX2LoaderPipe, name: "loadKTX2Texture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTX2LoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadKTX2Texture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: KTX2LoaderService }]; } });
class ThKTX2LoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThKTX2LoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTX2LoaderDirective, deps: [{ token: ThTexture, host: true }, { token: i0.NgZone }, { token: KTX2LoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThKTX2LoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThKTX2LoaderDirective, selector: "[loadKTX2Texture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTX2LoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadKTX2Texture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: KTX2LoaderService }];
    } });

class KTXLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = KTXLoader;
    }
}
KTXLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTXLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
KTXLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTXLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: KTXLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThKTXLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThKTXLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTXLoaderPipe, deps: [{ token: KTXLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThKTXLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThKTXLoaderPipe, name: "loadKTXTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTXLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadKTXTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: KTXLoaderService }]; } });
class ThKTXLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThKTXLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTXLoaderDirective, deps: [{ token: ThCompressedTexture, host: true }, { token: i0.NgZone }, { token: KTXLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThKTXLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThKTXLoaderDirective, selector: "[loadKTXTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThKTXLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadKTXTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThCompressedTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: KTXLoaderService }];
    } });

class PVRLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = PVRLoader;
    }
}
PVRLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PVRLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PVRLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PVRLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PVRLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThPVRLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThPVRLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPVRLoaderPipe, deps: [{ token: PVRLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThPVRLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThPVRLoaderPipe, name: "loadPVRTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPVRLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadPVRTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: PVRLoaderService }]; } });
class ThPVRLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThPVRLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPVRLoaderDirective, deps: [{ token: ThCompressedTexture, host: true }, { token: i0.NgZone }, { token: PVRLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThPVRLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThPVRLoaderDirective, selector: "[loadPVRTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPVRLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadPVRTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThCompressedTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: PVRLoaderService }];
    } });

class EXRLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = EXRLoader;
    }
}
EXRLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: EXRLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
EXRLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: EXRLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: EXRLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThEXRLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThEXRLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEXRLoaderPipe, deps: [{ token: EXRLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThEXRLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThEXRLoaderPipe, name: "loadEXRTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEXRLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadEXRTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: EXRLoaderService }]; } });
class ThEXRLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThEXRLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEXRLoaderDirective, deps: [{ token: ThDataTexture, host: true }, { token: i0.NgZone }, { token: EXRLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThEXRLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThEXRLoaderDirective, selector: "[loadEXRTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThEXRLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadEXRTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThDataTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: EXRLoaderService }];
    } });

class RGBELoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = RGBELoader;
    }
}
RGBELoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBELoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
RGBELoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBELoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBELoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThRGBELoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThRGBELoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBELoaderPipe, deps: [{ token: RGBELoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThRGBELoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThRGBELoaderPipe, name: "loadRGBETexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBELoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadRGBETexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: RGBELoaderService }]; } });
class ThRGBELoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThRGBELoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBELoaderDirective, deps: [{ token: ThDataTexture, host: true }, { token: i0.NgZone }, { token: RGBELoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThRGBELoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThRGBELoaderDirective, selector: "[loadRGBETexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBELoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadRGBETexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThDataTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: RGBELoaderService }];
    } });

class RGBMLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = RGBMLoader;
    }
}
RGBMLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBMLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
RGBMLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBMLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RGBMLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThRGBMLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThRGBMLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBMLoaderPipe, deps: [{ token: RGBMLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThRGBMLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThRGBMLoaderPipe, name: "loadRGBMTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBMLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadRGBMTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: RGBMLoaderService }]; } });
class ThRGBMLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThRGBMLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBMLoaderDirective, deps: [{ token: ThDataTexture, host: true }, { token: i0.NgZone }, { token: RGBMLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThRGBMLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThRGBMLoaderDirective, selector: "[loadRGBMTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRGBMLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadRGBMTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThDataTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: RGBMLoaderService }];
    } });

class TGALoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = TGALoader;
    }
}
TGALoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TGALoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
TGALoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TGALoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TGALoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThTGALoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThTGALoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTGALoaderPipe, deps: [{ token: TGALoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThTGALoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThTGALoaderPipe, name: "loadTGATexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTGALoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadTGATexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: TGALoaderService }]; } });
class ThTGALoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThTGALoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTGALoaderDirective, deps: [{ token: ThDataTexture, host: true }, { token: i0.NgZone }, { token: TGALoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThTGALoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThTGALoaderDirective, selector: "[loadTGATexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTGALoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadTGATexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThDataTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: TGALoaderService }];
    } });

class CubeTextureLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = CubeTextureLoader;
    }
}
CubeTextureLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: CubeTextureLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
CubeTextureLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: CubeTextureLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: CubeTextureLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThCubeTextureLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThCubeTextureLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTextureLoaderPipe, deps: [{ token: CubeTextureLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThCubeTextureLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTextureLoaderPipe, name: "loadCubeTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTextureLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadCubeTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: CubeTextureLoaderService }]; } });
class ThCubeTextureLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThCubeTextureLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTextureLoaderDirective, deps: [{ token: ThTexture, host: true }, { token: i0.NgZone }, { token: CubeTextureLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThCubeTextureLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThCubeTextureLoaderDirective, selector: "[loadCubeTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThCubeTextureLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadCubeTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: CubeTextureLoaderService }];
    } });

class ThAsyncLoaderService extends ThLoader {
    load(...args) {
        const loader = this.createLoaderInstance();
        return loader.loadAsync(...args);
    }
}
ThAsyncLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAsyncLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ThAsyncLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAsyncLoaderService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAsyncLoaderService, decorators: [{
            type: Injectable
        }] });
class ThAsyncLoaderBasePipe {
    constructor() {
        this.animationLoop = inject(ThAnimationLoopService);
    }
    transform(...args) {
        return this.service.load(...args).then((response) => {
            this.animationLoop.requestAnimationFrame();
            return response;
        });
    }
}
class ThAsyncLoaderBaseDirective {
    set url(url) {
        this._url = url;
        this.load();
    }
    get url() {
        return this._url;
    }
    get onLoaded() {
        if (!this.onLoaded$) {
            this.onLoaded$ = new EventEmitter();
        }
        return this.onLoaded$;
    }
    get onProgress() {
        if (!this.onProgress$) {
            this.onProgress$ = new EventEmitter();
        }
        return this.onProgress$;
    }
    constructor(host, zone) {
        this.host = host;
        this.zone = zone;
        this.initialized = false;
        this.animationLoop = inject(ThAnimationLoopService);
        this.proxy = createLazyObject3DProxy();
        host.objRef = this.proxy;
    }
    ngOnInit() {
        this.initialized = true;
        this.load();
        // this.zone.runOutsideAngular(() => );
    }
    load() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.initialized) {
                return;
            }
            if (this._url === undefined) {
                throw new Error('missing url');
            }
            if (!this.proxy) {
                return;
            }
            const url = this._url;
            const onProgress = isObserved(this.onProgress$)
                ? (progress) => {
                    this.zone.run(() => {
                        var _a;
                        (_a = this.onProgress$) === null || _a === void 0 ? void 0 : _a.next(progress);
                    });
                }
                : undefined;
            const result = yield this.zone.runOutsideAngular(() => this.service.load(url, onProgress));
            this.animationLoop.requestAnimationFrame();
            this.proxy.objRef = this.getRefFromResponse(result);
            // add the new object to the parent and
            // emit a loaded event directly on the three.js object and on objRef$
            this.host.objRef = this.proxy;
            if (this.onLoaded$ && result !== undefined) {
                this.zone.run(() => { var _a; return (_a = this.onLoaded$) === null || _a === void 0 ? void 0 : _a.next(result); });
            }
        });
    }
}
ThAsyncLoaderBaseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAsyncLoaderBaseDirective, deps: "invalid", target: i0.ɵɵFactoryTarget.Directive });
ThAsyncLoaderBaseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThAsyncLoaderBaseDirective, inputs: { url: "url" }, outputs: { onLoaded: "onLoaded", onProgress: "onProgress" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThAsyncLoaderBaseDirective, decorators: [{
            type: Directive,
            args: [{}]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }];
    }, propDecorators: { url: [{
                type: Input
            }], onLoaded: [{
                type: Output
            }], onProgress: [{
                type: Output
            }] } });

class DRACOLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = DRACOLoader;
        this.decoderPath = '';
        this.reuseInstance = true;
    }
    setDecoderPath(path) {
        this.decoderPath = path;
    }
    setDecoderConfig(config) {
        this.decoderConfig = config;
    }
    setWorkerLimit(limit) {
        this.workerLimit = limit;
    }
    setReuseInstance(reuse) {
        this.reuseInstance = reuse;
    }
    createLoaderInstance() {
        if (this.reuseInstance && this.instance) {
            return this.instance;
        }
        const loader = super.createLoaderInstance();
        loader.setDecoderPath(this.decoderPath);
        if (this.decoderConfig) {
            loader.setDecoderConfig(this.decoderConfig);
        }
        if (this.workerLimit) {
            loader.setWorkerLimit(this.workerLimit);
        }
        if (this.reuseInstance) {
            this.instance = loader;
        }
        return loader;
    }
}
DRACOLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DRACOLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
DRACOLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DRACOLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: DRACOLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class GLTFLoaderService extends ThAsyncLoaderService {
    constructor(dracoLoaderService) {
        super();
        this.dracoLoaderService = dracoLoaderService;
        this.clazz = GLTFLoader;
    }
    createLoaderInstance() {
        const loader = super.createLoaderInstance();
        loader.setDRACOLoader(this.dracoLoaderService.createLoaderInstance());
        return loader;
    }
}
GLTFLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: GLTFLoaderService, deps: [{ token: DRACOLoaderService }], target: i0.ɵɵFactoryTarget.Injectable });
GLTFLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: GLTFLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: GLTFLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: DRACOLoaderService }]; } });
class ThGLTFLoaderPipe extends ThAsyncLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThGLTFLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGLTFLoaderPipe, deps: [{ token: GLTFLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThGLTFLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThGLTFLoaderPipe, name: "loadGLTF" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGLTFLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadGLTF',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: GLTFLoaderService }]; } });
class ThGLTFLoaderDirective extends ThAsyncLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
    getRefFromResponse(response) {
        return response.scene;
    }
}
ThGLTFLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGLTFLoaderDirective, deps: [{ token: ThObject3D, host: true }, { token: i0.NgZone }, { token: GLTFLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThGLTFLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThGLTFLoaderDirective, selector: "[loadGLTF]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThGLTFLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadGLTF]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: GLTFLoaderService }];
    } });

class TextureLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = TextureLoader;
    }
}
TextureLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TextureLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
TextureLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TextureLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: TextureLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThTextureLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThTextureLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureLoaderPipe, deps: [{ token: TextureLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThTextureLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThTextureLoaderPipe, name: "loadTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: TextureLoaderService }]; } });
class ThTextureLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThTextureLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureLoaderDirective, deps: [{ token: ThTexture, host: true }, { token: i0.NgZone }, { token: TextureLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThTextureLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThTextureLoaderDirective, selector: "[loadTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThTextureLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: TextureLoaderService }];
    } });

/**
 * create a clone of any "cloneable" three.js class (or from it's ngx-three warpper)
 */
class ClonePipe {
    transform(value) {
        var _a;
        if (!value) {
            return;
        }
        if (value instanceof ThWrapperBase) {
            return (_a = value.objRef) === null || _a === void 0 ? void 0 : _a.clone();
        }
        else {
            return value.clone();
        }
    }
}
ClonePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ClonePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ClonePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ClonePipe, name: "clone" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ClonePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'clone'
                }]
        }] });

/**
 * constructs a color of it's constructor parameters
 */
class ColorPipe {
    /* ContructorProperties does not support multiple constructors --> */
    transform(args) {
        if (Array.isArray(args)) {
            return new Color(...args);
        }
        else {
            return new Color(args);
        }
    }
}
ColorPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
ColorPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ColorPipe, name: "color" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'color',
                    pure: true
                }]
        }] });

class FogPipe {
    transform(args) {
        return new Fog(...args);
    }
}
FogPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: FogPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FogPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: FogPipe, name: "fog" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: FogPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'fog',
                    pure: true
                }]
        }] });

/**
 * transform arrays to vectors
 */
class Vector2Pipe {
    transform(args) {
        return new Vector2(...args);
    }
}
Vector2Pipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector2Pipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
Vector2Pipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: Vector2Pipe, name: "vector2" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector2Pipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vector2',
                    pure: true
                }]
        }] });
class Vector3Pipe {
    transform(args) {
        return new Vector3(...args);
    }
}
Vector3Pipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector3Pipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
Vector3Pipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: Vector3Pipe, name: "vector3" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector3Pipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vector3',
                    pure: true
                }]
        }] });
class Vector4Pipe {
    transform(args) {
        return new Vector4(...args);
    }
}
Vector4Pipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector4Pipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
Vector4Pipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: Vector4Pipe, name: "vector4" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: Vector4Pipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vector4',
                    pure: true
                }]
        }] });

class ThRenderDirective {
    constructor(engineService, animationLoopService) {
        this.engineService = engineService;
        this.animationLoopService = animationLoopService;
    }
    get beforeRender() {
        return this.engineService.beforeRender$;
    }
    get onResize() {
        return this.engineService.resize$;
    }
    set renderOnDemand(onDemand) {
        if (onDemand) {
            this.animationLoopService.stop();
        }
        else {
            this.animationLoopService.start();
        }
    }
    get renderOnDemand() {
        return !this.animationLoopService.isActive();
    }
}
ThRenderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderDirective, deps: [{ token: ThEngineService }, { token: ThAnimationLoopService }], target: i0.ɵɵFactoryTarget.Directive });
ThRenderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThRenderDirective, selector: "[beforeRender], [onResize], [renderOnDemand]", inputs: { renderOnDemand: "renderOnDemand" }, outputs: { beforeRender: "beforeRender", onResize: "onResize" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThRenderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[beforeRender], [onResize], [renderOnDemand]'
                }]
        }], ctorParameters: function () { return [{ type: ThEngineService }, { type: ThAnimationLoopService }]; }, propDecorators: { beforeRender: [{
                type: Output
            }], onResize: [{
                type: Output
            }], renderOnDemand: [{
                type: Input
            }] } });

class StatsDirective {
    constructor(engineService) {
        this.engineService = engineService;
        this.stats = new Stats();
    }
    ngOnDestroy() {
        if (this.renderSubscription) {
            this.renderSubscription.unsubscribe();
        }
    }
    ngOnInit() {
        var _a;
        if (!this.engineService.canvas) {
            throw new Error('No canvas present');
        }
        const parentElement = this.engineService.canvas.parentElement;
        if (parentElement) {
            parentElement.style.position = 'relative';
            this.stats.dom.style.position = 'absolute';
            this.stats.showPanel(0);
            (_a = this.engineService.canvas.parentElement) === null || _a === void 0 ? void 0 : _a.appendChild(this.stats.dom);
            this.renderSubscription = this.engineService.beforeRender$.subscribe(() => {
                this.stats.update();
            });
        }
    }
    set thStats(enabled) {
        if (!enabled) {
            this.stats.dom.style.visibility = 'hidden';
        }
        else {
            this.stats.dom.style.visibility = 'visible';
        }
    }
}
StatsDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: StatsDirective, deps: [{ token: ThEngineService }], target: i0.ɵɵFactoryTarget.Directive });
StatsDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: StatsDirective, selector: "[thStats]", inputs: { thStats: "thStats" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: StatsDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[thStats]'
                }]
        }], ctorParameters: function () { return [{ type: ThEngineService }]; }, propDecorators: { thStats: [{
                type: Input
            }] } });

class OBJLoaderService extends ThAsyncLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = OBJLoader;
    }
}
OBJLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: OBJLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
OBJLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: OBJLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: OBJLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThObjLoaderPipe extends ThAsyncLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThObjLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjLoaderPipe, deps: [{ token: OBJLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThObjLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThObjLoaderPipe, name: "loadObj" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadObj',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: OBJLoaderService }]; } });
class ThObjLoaderDirective extends ThAsyncLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
    getRefFromResponse(response) {
        return response;
    }
}
ThObjLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjLoaderDirective, deps: [{ token: ThObject3D, host: true }, { token: i0.NgZone }, { token: OBJLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThObjLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThObjLoaderDirective, selector: "[loadObj]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThObjLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadObj]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: OBJLoaderService }];
    } });

class FBXLoaderService extends ThAsyncLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = FBXLoader;
    }
}
FBXLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: FBXLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
FBXLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: FBXLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: FBXLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThFBXLoaderPipe extends ThAsyncLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThFBXLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFBXLoaderPipe, deps: [{ token: FBXLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThFBXLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThFBXLoaderPipe, name: "loadFBX" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFBXLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadFBX',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: FBXLoaderService }]; } });
class ThFBXLoaderDirective extends ThAsyncLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
    getRefFromResponse(response) {
        return response;
    }
}
ThFBXLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFBXLoaderDirective, deps: [{ token: ThObject3D, host: true }, { token: i0.NgZone }, { token: FBXLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThFBXLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThFBXLoaderDirective, selector: "[loadFBX]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThFBXLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadFBX]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: FBXLoaderService }];
    } });

class LogLuvLoaderService extends ThCallbackLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = LogLuvLoader;
    }
}
LogLuvLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: LogLuvLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
LogLuvLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: LogLuvLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: LogLuvLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThLogLuvLoaderPipe extends ThCallbackLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThLogLuvLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLogLuvLoaderPipe, deps: [{ token: LogLuvLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThLogLuvLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThLogLuvLoaderPipe, name: "loadLogLuvTexture" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLogLuvLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadLogLuvTexture',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: LogLuvLoaderService }]; } });
class ThLogLuvLoaderDirective extends ThCallbackLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
}
ThLogLuvLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLogLuvLoaderDirective, deps: [{ token: ThDataTexture, host: true }, { token: i0.NgZone }, { token: LogLuvLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThLogLuvLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThLogLuvLoaderDirective, selector: "[loadLogLuvTexture]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThLogLuvLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadLogLuvTexture]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThDataTexture, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: LogLuvLoaderService }];
    } });

/*
          Generated, modifications will get overwritten
        */

class PLYLoaderService extends ThAsyncLoaderService {
    constructor() {
        super(...arguments);
        this.clazz = PLYLoader;
    }
}
PLYLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PLYLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PLYLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PLYLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PLYLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
class ThPLYLoaderPipe extends ThAsyncLoaderBasePipe {
    constructor(service) {
        super();
        this.service = service;
    }
}
ThPLYLoaderPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPLYLoaderPipe, deps: [{ token: PLYLoaderService }], target: i0.ɵɵFactoryTarget.Pipe });
ThPLYLoaderPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: ThPLYLoaderPipe, name: "loadPLY" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPLYLoaderPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'loadPLY',
                    pure: true
                }]
        }], ctorParameters: function () { return [{ type: PLYLoaderService }]; } });
class ThPLYLoaderDirective extends ThAsyncLoaderBaseDirective {
    constructor(host, zone, service) {
        super(host, zone);
        this.host = host;
        this.zone = zone;
        this.service = service;
    }
    getRefFromResponse(response) {
        response.computeVertexNormals();
        return response;
    }
    load() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.initialized) {
                return;
            }
            if (this._url === undefined) {
                throw new Error('missing url');
            }
            const url = this._url;
            const onProgress = isObserved(this.onProgress$)
                ? (progress) => {
                    var _a;
                    (_a = this.onProgress$) === null || _a === void 0 ? void 0 : _a.next(progress);
                }
                : undefined;
            const result = yield this.zone.runOutsideAngular(() => this.service.load(url, onProgress));
            // add the new object to the parent and
            // emit a loaded event directly on the three.js object and on objRef$
            this.host.objRef = this.getRefFromResponse(result);
            if (this.onLoaded$ && result !== undefined) {
                (_a = this.onLoaded$) === null || _a === void 0 ? void 0 : _a.next(result);
            }
        });
    }
}
ThPLYLoaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPLYLoaderDirective, deps: [{ token: ThBufferGeometry, host: true }, { token: i0.NgZone }, { token: PLYLoaderService }], target: i0.ɵɵFactoryTarget.Directive });
ThPLYLoaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: ThPLYLoaderDirective, selector: "[loadPLY]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: ThPLYLoaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[loadPLY]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThBufferGeometry, decorators: [{
                        type: Host
                    }] }, { type: i0.NgZone }, { type: PLYLoaderService }];
    } });

class BindPipe {
    transform(methodToBind, instance) {
        return methodToBind.bind(instance);
    }
}
BindPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: BindPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BindPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: BindPipe, name: "bind" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: BindPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bind'
                }]
        }] });

/**
 * The following code is ported from pmndrs/drei and adapted to work with Angular and ngx-three
 * Many thanks to pmndrs/drei at its contributors!
 */
const v1 = new Vector3();
const v2 = new Vector3();
const v3 = new Vector3();
function defaultCalculatePosition(el, camera, size) {
    const objectPos = v1.setFromMatrixPosition(el.matrixWorld);
    objectPos.project(camera);
    const widthHalf = size.width / 2;
    const heightHalf = size.height / 2;
    return [objectPos.x * widthHalf + widthHalf, -(objectPos.y * heightHalf) + heightHalf];
}
function isObjectBehindCamera(el, camera) {
    const objectPos = v1.setFromMatrixPosition(el.matrixWorld);
    const cameraPos = v2.setFromMatrixPosition(camera.matrixWorld);
    const deltaCamObj = objectPos.sub(cameraPos);
    const camDir = camera.getWorldDirection(v3);
    return deltaCamObj.angleTo(camDir) > Math.PI / 2;
}
function isObjectVisible(el, camera, raycaster, occlude) {
    const elPos = v1.setFromMatrixPosition(el.matrixWorld);
    const screenPos = elPos.clone();
    screenPos.project(camera);
    raycaster.setFromCamera(screenPos, camera);
    const intersects = raycaster.intersectObjects(occlude, true);
    if (intersects.length) {
        const intersectionDistance = intersects[0].distance;
        const pointDistance = elPos.distanceTo(raycaster.ray.origin);
        return pointDistance < intersectionDistance;
    }
    return true;
}
function objectScale(el, camera) {
    if (camera instanceof OrthographicCamera) {
        return camera.zoom;
    }
    else if (camera instanceof PerspectiveCamera) {
        const objectPos = v1.setFromMatrixPosition(el.matrixWorld);
        const cameraPos = v2.setFromMatrixPosition(camera.matrixWorld);
        const vFOV = (camera.fov * Math.PI) / 180;
        const dist = objectPos.distanceTo(cameraPos);
        const scaleFOV = 2 * Math.tan(vFOV / 2) * dist;
        return 1 / scaleFOV;
    }
    else {
        return 1;
    }
}
function objectZIndex(el, camera, zIndexRange) {
    if (camera instanceof PerspectiveCamera || camera instanceof OrthographicCamera) {
        const objectPos = v1.setFromMatrixPosition(el.matrixWorld);
        const cameraPos = v2.setFromMatrixPosition(camera.matrixWorld);
        const dist = objectPos.distanceTo(cameraPos);
        const A = (zIndexRange[1] - zIndexRange[0]) / (camera.far - camera.near);
        const B = zIndexRange[1] - A * camera.far;
        return Math.round(A * dist + B);
    }
    return undefined;
}
const epsilon = (value) => (Math.abs(value) < 1e-10 ? 0 : value);
function getCSSMatrix(matrix, multipliers, prepend = '') {
    let matrix3d = 'matrix3d(';
    for (let i = 0; i !== 16; i++) {
        matrix3d += epsilon(multipliers[i] * matrix.elements[i]) + (i !== 15 ? ',' : ')');
    }
    return prepend + matrix3d;
}
const getCameraCSSMatrix = ((multipliers) => (matrix) => getCSSMatrix(matrix, multipliers))([1, -1, 1, 1, 1, -1, 1, 1, 1, -1, 1, 1, 1, -1, 1, 1]);
const getObjectCSSMatrix = ((scaleMultipliers) => (matrix, factor) => getCSSMatrix(matrix, scaleMultipliers(factor), 'translate(-50%,-50%)'))((f) => [1 / f, 1 / f, 1 / f, 1, -1 / f, -1 / f, -1 / f, -1, 1 / f, 1 / f, 1 / f, 1, 1, 1, 1, 1]);
/**
 * A port of the pmndrs/drei Html component
 *
 * Add Html content to any three.js object3d node
 */
class HtmlComponent extends ThGroup {
    constructor(view, canvas, parent) {
        super(parent);
        this.view = view;
        this.canvas = canvas;
        this.prepend = false; // Project content behind the canvas (default: false)
        this.center = false; // Adds a -50%/-50% css transform (default: false) [ignored in transform mode]
        this.fullscreen = false; // Aligns to the upper-left corner, fills the screen (default:false) [ignored in transform mode]
        this.eps = 0.001;
        this.sprite = false; // Renders as sprite, but only in transform mode (default=false)
        this.transform = false; // If true, applies matrix3d transformations (default=false)
        this.zIndexRange = [16777271, 0]; // Z-order range (default=[16777271, 0])
        this.onOcclude = new EventEmitter();
        /**
         * Override default positioning function. [ignored in transform mode]
         */
        this.calculatePosition = defaultCalculatePosition;
        this.as = 'div'; // Wrapping element (default: 'div')
        this.pointerEvents = 'auto';
        this.transformInnerStyles = this.computeInnerStyles();
        this.styles = null;
        this.oldZoom = 0;
        this.oldPosition = [0, 0];
        this.notOccluded = true;
        this.raycaster = inject(RAYCASTER);
    }
    ngOnInit() {
        super.ngOnInit();
        this.styles = this.computeStyles();
    }
    ngAfterViewInit() {
        this.el = document.createElement(this.as);
        this.frameSubscription = this.view.onRender.subscribe(() => this.onFrame());
        if (this.transformOuterRef) {
            this.el.appendChild(this.transformOuterRef.nativeElement);
        }
        if (this.el && !this.target) {
            this.appendElement(this.el);
        }
    }
    onResize() {
        this.styles = this.computeStyles();
    }
    ngOnChanges(changes) {
        super.ngOnChanges(changes);
        /*
        if(this.el) {
          if(changes.portal || changes.transform) {
            this.appendElement(this.el);
          }
    
          if(changes.wrapperClass) {
            this.el.className = changes.wrapperClass.currentValue ?? '';
          }
    
          if(changes.pointerEvents) {
            this.transformInnerStyles = this.computeInnerStyles();
          }
        }
        */
    }
    appendElement(el) {
        var _a, _b, _c, _d;
        if (!this.el || !this.objRef || !this.canvas.rendererCanvas || !this.view.camera) {
            return;
        }
        this.target = (_a = this.portal) !== null && _a !== void 0 ? _a : (_b = this.canvas.rendererCanvas) === null || _b === void 0 ? void 0 : _b.nativeElement.parentElement;
        (_d = (_c = this.view.scene) === null || _c === void 0 ? void 0 : _c.objRef) === null || _d === void 0 ? void 0 : _d.updateMatrixWorld();
        if (this.transform) {
            el.style.cssText = 'position:absolute;top:0;left:0;pointer-events:none;overflow:hidden;';
        }
        else {
            const vec = this.calculatePosition(this.objRef, this.view.camera.objRef, this.getSize());
            el.style.cssText = `position:absolute;top:0;left:0;transform:translate3d(${vec[0]}px,${vec[1]}px,0);transform-origin:0 0;`;
        }
        if (this.target) {
            if (this.prepend) {
                this.target.prepend(el);
            }
            else {
                this.target.appendChild(el);
            }
        }
    }
    onFrame() {
        var _a, _b;
        const camera = (_a = this.view.camera) === null || _a === void 0 ? void 0 : _a.objRef;
        const scene = (_b = this.view.scene) === null || _b === void 0 ? void 0 : _b.objRef;
        const group = this._objRef;
        const size = this.getSize();
        if (!camera || !group || !scene || !this.el) {
            return;
        }
        camera.updateMatrixWorld();
        group.updateWorldMatrix(true, false);
        const vec = this.transform ? this.oldPosition : this.calculatePosition(group, camera, size);
        if (this.transform ||
            Math.abs(this.oldZoom - camera.zoom) > this.eps ||
            Math.abs(this.oldPosition[0] - vec[0]) > this.eps ||
            Math.abs(this.oldPosition[1] - vec[1]) > this.eps) {
            const isBehindCamera = isObjectBehindCamera(group, camera);
            let raytraceTarget = false;
            if (typeof this.occlude === 'boolean') {
                if (this.occlude === true) {
                    raytraceTarget = [scene];
                }
            }
            else if (Array.isArray(this.occlude)) {
                raytraceTarget = this.occlude.map((item) => { var _a; return (_a = item.objRef) !== null && _a !== void 0 ? _a : item; });
            }
            const previouslyVisible = this.notOccluded;
            if (raytraceTarget) {
                this.notOccluded = !isBehindCamera && isObjectVisible(group, camera, this.raycaster, raytraceTarget);
            }
            else {
                this.notOccluded = !isBehindCamera;
            }
            if (previouslyVisible !== this.notOccluded) {
                if (this.onOcclude.length > 0) {
                    this.onOcclude.next(!this.notOccluded);
                }
                else {
                    this.el.style.display = this.notOccluded ? 'block' : 'none';
                }
            }
            this.el.style.zIndex = `${objectZIndex(group, camera, this.zIndexRange)}`;
            if (this.transform) {
                const [widthHalf, heightHalf] = [size.width / 2, size.height / 2];
                const fov = camera.projectionMatrix.elements[5] * heightHalf;
                const { isOrthographicCamera, top, left, bottom, right } = camera;
                const cameraMatrix = getCameraCSSMatrix(camera.matrixWorldInverse);
                const cameraTransform = isOrthographicCamera
                    ? `scale(${fov})translate(${epsilon(-(right + left) / 2)}px,${epsilon((top + bottom) / 2)}px)`
                    : `translateZ(${fov}px)`;
                let matrix = group.matrixWorld;
                if (this.sprite) {
                    matrix = camera.matrixWorldInverse.clone().transpose().copyPosition(matrix).scale(group.scale);
                    matrix.elements[3] = matrix.elements[7] = matrix.elements[11] = 0;
                    matrix.elements[15] = 1;
                }
                this.el.style.width = size.width + 'px';
                this.el.style.height = size.height + 'px';
                this.el.style.perspective = isOrthographicCamera ? '' : `${fov}px`;
                if (this.transformOuterRef && this.transformInnerRef) {
                    // eslint-disable-next-line max-len
                    this.transformOuterRef.nativeElement.style.transform = `${cameraTransform}${cameraMatrix}translate(${widthHalf}px,${heightHalf}px)`;
                    this.transformInnerRef.nativeElement.style.transform = getObjectCSSMatrix(matrix, 1 / ((this.distanceFactor || 10) / 400));
                }
            }
            else {
                const scale = this.distanceFactor === undefined ? 1 : objectScale(group, camera) * this.distanceFactor;
                this.el.style.transform = `translate3d(${vec[0]}px,${vec[1]}px,0) scale(${scale})`;
            }
            this.oldPosition = vec;
            this.oldZoom = camera.zoom;
        }
    }
    ngOnDestroy() {
        var _a, _b;
        (_a = this.el) === null || _a === void 0 ? void 0 : _a.remove();
        (_b = this.frameSubscription) === null || _b === void 0 ? void 0 : _b.unsubscribe();
    }
    computeStyles() {
        const size = this.getSize();
        if (this.transform) {
            return {
                position: 'absolute',
                top: 0,
                left: 0,
                width: size.width + 'px',
                height: size.height + 'px',
                transformStyle: 'preserve-3d',
                pointerEvents: 'none'
            };
        }
        else {
            return Object.assign(Object.assign({ position: 'absolute', transform: this.center ? 'translate3d(-50%,-50%,0)' : 'none' }, (this.fullscreen && {
                top: -size.height / 2 + 'px',
                left: -size.width / 2 + 'px',
                width: size.width + 'px',
                height: size.height + 'px'
            })), this.style);
        }
    }
    computeInnerStyles() {
        return { position: 'absolute', pointerEvents: this.pointerEvents };
    }
    getSize() {
        var _a, _b, _c;
        return ((_c = (_a = this.view.viewPort) !== null && _a !== void 0 ? _a : (_b = this.canvas.rendererCanvas) === null || _b === void 0 ? void 0 : _b.nativeElement.getBoundingClientRect()) !== null && _c !== void 0 ? _c : { width: 0, height: 0 });
    }
}
HtmlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: HtmlComponent, deps: [{ token: ThView }, { token: ThCanvas }, { token: ThObject3D, skipSelf: true }], target: i0.ɵɵFactoryTarget.Component });
HtmlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.1", type: HtmlComponent, selector: "th-html", inputs: { prepend: "prepend", center: "center", fullscreen: "fullscreen", portal: "portal", distanceFactor: "distanceFactor", sprite: "sprite", transform: "transform", zIndexRange: "zIndexRange", style: "style", className: "className", occlude: "occlude", calculatePosition: "calculatePosition", as: "as", wrapperClass: "wrapperClass", pointerEvents: "pointerEvents" }, outputs: { onOcclude: "onOcclude" }, viewQueries: [{ propertyName: "transformOuterRef", first: true, predicate: ["outerRef"], descendants: true }, { propertyName: "transformInnerRef", first: true, predicate: ["innerRef"], descendants: true }], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: "<div [ngStyle]=\"styles\" #outerRef *ngIf=\"transform;  else noTransform\" (onResize)=\"onResize()\">\n    <div #innerRef [ngStyle]=\"transformInnerStyles\" >\n        <div [style]=\"style\" [className]=\"className\">\n            <ng-container *ngTemplateOutlet=\"tempOutlet\" ></ng-container>\n        </div>\n    </div>\n</div>\n<ng-template #noTransform>\n    <div [ngStyle]=\"styles\" [className]=\"className\" #outerRef>\n        <ng-container *ngTemplateOutlet=\"tempOutlet\" ></ng-container>\n    </div>\n</ng-template>\n\n<ng-template #tempOutlet>\n    <ng-content></ng-content>\n</ng-template>\n", dependencies: [{ kind: "directive", type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i4.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i4.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: ThRenderDirective, selector: "[beforeRender], [onResize], [renderOnDemand]", inputs: ["renderOnDemand"], outputs: ["beforeRender", "onResize"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: HtmlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'th-html', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div [ngStyle]=\"styles\" #outerRef *ngIf=\"transform;  else noTransform\" (onResize)=\"onResize()\">\n    <div #innerRef [ngStyle]=\"transformInnerStyles\" >\n        <div [style]=\"style\" [className]=\"className\">\n            <ng-container *ngTemplateOutlet=\"tempOutlet\" ></ng-container>\n        </div>\n    </div>\n</div>\n<ng-template #noTransform>\n    <div [ngStyle]=\"styles\" [className]=\"className\" #outerRef>\n        <ng-container *ngTemplateOutlet=\"tempOutlet\" ></ng-container>\n    </div>\n</ng-template>\n\n<ng-template #tempOutlet>\n    <ng-content></ng-content>\n</ng-template>\n" }]
        }], ctorParameters: function () {
        return [{ type: ThView }, { type: ThCanvas }, { type: ThObject3D, decorators: [{
                        type: SkipSelf
                    }] }];
    }, propDecorators: { prepend: [{
                type: Input
            }], center: [{
                type: Input
            }], fullscreen: [{
                type: Input
            }], portal: [{
                type: Input
            }], distanceFactor: [{
                type: Input
            }], sprite: [{
                type: Input
            }], transform: [{
                type: Input
            }], zIndexRange: [{
                type: Input
            }], style: [{
                type: Input
            }], className: [{
                type: Input
            }], occlude: [{
                type: Input
            }], onOcclude: [{
                type: Output
            }], calculatePosition: [{
                type: Input
            }], as: [{
                type: Input
            }], wrapperClass: [{
                type: Input
            }], pointerEvents: [{
                type: Input
            }], transformOuterRef: [{
                type: ViewChild,
                args: ['outerRef']
            }], transformInnerRef: [{
                type: ViewChild,
                args: ['innerRef']
            }] } });

class RefByIdDirective {
    constructor(host, parent) {
        this.host = host;
        this.parent = parent;
        this.host.autoAddToParent = false;
        this.host.autoDispose = false;
        this.host.objRef = createLazyObject3DProxy();
    }
    set refById(id) {
        var _a;
        this.id = id;
        (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        this.subscription = this.parent.objRef$.subscribe((obj) => {
            this.parentObj = obj;
            this.applyRef();
        });
    }
    applyRef() {
        if (!this.parentObj || this.id === undefined) {
            return;
        }
        const ref = this.findById(this.parentObj, this.id);
        if (ref) {
            this.setRef(this.host, ref);
        }
    }
    findById(parentObj, id) {
        var _a;
        if (((_a = parentObj.name) !== null && _a !== void 0 ? _a : parentObj.uuid) === id) {
            return parentObj;
        }
        for (const child of parentObj.children) {
            const object = this.findById(child, id);
            if (object !== undefined) {
                return object;
            }
        }
        return undefined;
    }
    setRef(host, ref) {
        const objRef = host.objRef;
        if (!objRef) {
            return;
        }
        if (isLazyObject3dProxy(objRef)) {
            objRef.objRef = ref;
            host.objRef = objRef;
        }
    }
    ngOnDestroy() {
        var _a;
        (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
    }
}
RefByIdDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RefByIdDirective, deps: [{ token: ThObject3D, self: true }, { token: ThObject3D, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
RefByIdDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.1", type: RefByIdDirective, selector: "[refById]", inputs: { refById: "refById" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: RefByIdDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[refById]'
                }]
        }], ctorParameters: function () {
        return [{ type: ThObject3D, decorators: [{
                        type: Self
                    }] }, { type: ThObject3D, decorators: [{
                        type: SkipSelf
                    }] }];
    }, propDecorators: { refById: [{
                type: Input
            }] } });

/**
 * creates a plane from a normal vector3 and a constant:
 * https://threejs.org/docs/#api/en/math/Plane
 */
class PlanePipe {
    transform(normal, constant) {
        return new Plane(new Vector3(...normal), constant);
    }
}
PlanePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PlanePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
PlanePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: PlanePipe, name: "plane" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: PlanePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'plane'
                }]
        }] });

class NgxThreeModule {
}
NgxThreeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxThreeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeModule, declarations: [ThCanvas,
        ThView,
        ThObjectBase,
        ThMaterialBase,
        ThWrapperBase,
        ThGLTFLoaderDirective,
        ThGLTFLoaderPipe,
        ThObjLoaderPipe,
        ThObjLoaderDirective,
        ThFBXLoaderDirective,
        ThFBXLoaderPipe,
        ThPLYLoaderDirective,
        ThPLYLoaderPipe,
        RaycasterEventDirective,
        ColorPipe,
        Vector2Pipe,
        Vector3Pipe,
        Vector4Pipe,
        ClonePipe,
        FogPipe,
        BindPipe,
        PlanePipe,
        StatsDirective,
        ThRenderDirective,
        // texture loaders
        ThTextureLoaderDirective,
        ThTextureLoaderPipe,
        ThCubeTextureLoaderDirective,
        ThCubeTextureLoaderPipe,
        // compressed texture loaders
        ThDDSLoaderDirective,
        ThDDSLoaderPipe,
        ThKTXLoaderDirective,
        ThKTXLoaderPipe,
        ThKTX2LoaderDirective,
        ThKTX2LoaderPipe,
        ThPVRLoaderDirective,
        ThPVRLoaderPipe,
        // data texture loaders
        ThEXRLoaderDirective,
        ThEXRLoaderPipe,
        ThRGBELoaderDirective,
        ThRGBELoaderPipe,
        ThRGBMLoaderDirective,
        ThRGBMLoaderPipe,
        ThTGALoaderDirective,
        ThTGALoaderPipe,
        ThLogLuvLoaderDirective,
        ThLogLuvLoaderPipe,
        // directives
        RefByIdDirective,
        //extras
        HtmlComponent], imports: [NgxThreeGeneratedModule, CommonModule], exports: [NgxThreeGeneratedModule,
        ThCanvas,
        ThView,
        ThGLTFLoaderDirective,
        ThGLTFLoaderPipe,
        ThObjLoaderDirective,
        ThObjLoaderPipe,
        ThFBXLoaderDirective,
        ThFBXLoaderPipe,
        ThPLYLoaderDirective,
        ThPLYLoaderPipe,
        RaycasterEventDirective,
        ColorPipe,
        Vector2Pipe,
        Vector3Pipe,
        Vector4Pipe,
        ClonePipe,
        FogPipe,
        BindPipe,
        PlanePipe,
        ThRenderDirective,
        StatsDirective,
        // texture loaders
        ThTextureLoaderDirective,
        ThTextureLoaderPipe,
        ThCubeTextureLoaderDirective,
        ThCubeTextureLoaderPipe,
        // compressed texture loaders
        ThDDSLoaderDirective,
        ThDDSLoaderPipe,
        ThKTXLoaderDirective,
        ThKTXLoaderPipe,
        ThKTX2LoaderDirective,
        ThKTX2LoaderPipe,
        ThPVRLoaderDirective,
        ThPVRLoaderPipe,
        // data texture loaders
        ThEXRLoaderDirective,
        ThEXRLoaderPipe,
        ThRGBELoaderDirective,
        ThRGBELoaderPipe,
        ThRGBMLoaderDirective,
        ThRGBMLoaderPipe,
        ThTGALoaderDirective,
        ThTGALoaderPipe,
        ThLogLuvLoaderDirective,
        ThLogLuvLoaderPipe,
        // directives
        RefByIdDirective,
        // extra
        HtmlComponent] });
NgxThreeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeModule, imports: [NgxThreeGeneratedModule, CommonModule, NgxThreeGeneratedModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.1", ngImport: i0, type: NgxThreeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ThCanvas,
                        ThView,
                        ThObjectBase,
                        ThMaterialBase,
                        ThWrapperBase,
                        ThGLTFLoaderDirective,
                        ThGLTFLoaderPipe,
                        ThObjLoaderPipe,
                        ThObjLoaderDirective,
                        ThFBXLoaderDirective,
                        ThFBXLoaderPipe,
                        ThPLYLoaderDirective,
                        ThPLYLoaderPipe,
                        RaycasterEventDirective,
                        ColorPipe,
                        Vector2Pipe,
                        Vector3Pipe,
                        Vector4Pipe,
                        ClonePipe,
                        FogPipe,
                        BindPipe,
                        PlanePipe,
                        StatsDirective,
                        ThRenderDirective,
                        // texture loaders
                        ThTextureLoaderDirective,
                        ThTextureLoaderPipe,
                        ThCubeTextureLoaderDirective,
                        ThCubeTextureLoaderPipe,
                        // compressed texture loaders
                        ThDDSLoaderDirective,
                        ThDDSLoaderPipe,
                        ThKTXLoaderDirective,
                        ThKTXLoaderPipe,
                        ThKTX2LoaderDirective,
                        ThKTX2LoaderPipe,
                        ThPVRLoaderDirective,
                        ThPVRLoaderPipe,
                        // data texture loaders
                        ThEXRLoaderDirective,
                        ThEXRLoaderPipe,
                        ThRGBELoaderDirective,
                        ThRGBELoaderPipe,
                        ThRGBMLoaderDirective,
                        ThRGBMLoaderPipe,
                        ThTGALoaderDirective,
                        ThTGALoaderPipe,
                        ThLogLuvLoaderDirective,
                        ThLogLuvLoaderPipe,
                        // directives
                        RefByIdDirective,
                        //extras
                        HtmlComponent
                    ],
                    imports: [NgxThreeGeneratedModule, CommonModule],
                    exports: [
                        NgxThreeGeneratedModule,
                        ThCanvas,
                        ThView,
                        ThGLTFLoaderDirective,
                        ThGLTFLoaderPipe,
                        ThObjLoaderDirective,
                        ThObjLoaderPipe,
                        ThFBXLoaderDirective,
                        ThFBXLoaderPipe,
                        ThPLYLoaderDirective,
                        ThPLYLoaderPipe,
                        RaycasterEventDirective,
                        ColorPipe,
                        Vector2Pipe,
                        Vector3Pipe,
                        Vector4Pipe,
                        ClonePipe,
                        FogPipe,
                        BindPipe,
                        PlanePipe,
                        ThRenderDirective,
                        StatsDirective,
                        // texture loaders
                        ThTextureLoaderDirective,
                        ThTextureLoaderPipe,
                        ThCubeTextureLoaderDirective,
                        ThCubeTextureLoaderPipe,
                        // compressed texture loaders
                        ThDDSLoaderDirective,
                        ThDDSLoaderPipe,
                        ThKTXLoaderDirective,
                        ThKTXLoaderPipe,
                        ThKTX2LoaderDirective,
                        ThKTX2LoaderPipe,
                        ThPVRLoaderDirective,
                        ThPVRLoaderPipe,
                        // data texture loaders
                        ThEXRLoaderDirective,
                        ThEXRLoaderPipe,
                        ThRGBELoaderDirective,
                        ThRGBELoaderPipe,
                        ThRGBMLoaderDirective,
                        ThRGBMLoaderPipe,
                        ThTGALoaderDirective,
                        ThTGALoaderPipe,
                        ThLogLuvLoaderDirective,
                        ThLogLuvLoaderPipe,
                        // directives
                        RefByIdDirective,
                        // extra
                        HtmlComponent
                    ]
                }]
        }] });

function createThProviderArray(cls, baseCls) {
    const providers = [];
    if (ThObject3D.isPrototypeOf(baseCls) || Object3D === baseCls) {
        providers.push({ provide: ThObject3D, useExisting: forwardRef(() => cls) });
        if (ThCamera.isPrototypeOf(baseCls) || ThCamera === baseCls) {
            providers.push({ provide: ThCamera, useExisting: forwardRef(() => cls) });
        }
    }
}
/**
 * usage:
 *
 * @Component({
 *  providers: createObj3DProviderArray(forwardRef(() => TheComponent)))
 * })
 * export class TheComponent {
 * ...
 * }
 * @param type the Object3D derived Class to be provided
 */
function createObj3DProviderArray(type) {
    return [{ provide: ThObject3D, useExisting: forwardRef(() => type) }];
}
function createCameraProviderArray(type) {
    return [
        { provide: ThObject3D, useExisting: forwardRef(() => type) },
        { provide: ThCamera, useExisting: forwardRef(() => type) }
    ];
}

/*
 * Public API Surface of ngx-three
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BindPipe, ClonePipe, ColorPipe, CubeTextureLoaderService, DDSLoaderService, DRACOLoaderService, EXRLoaderService, FBXLoaderService, FogPipe, GLTFLoaderService, HtmlComponent, KTX2LoaderService, KTXLoaderService, LogLuvLoaderService, NgxThreeGeneratedModule, NgxThreeModule, OBJLoaderService, PLYLoaderService, PVRLoaderService, PlanePipe, RGBELoaderService, RGBMLoaderService, RaycasterEventDirective, RefByIdDirective, StatsDirective, TGALoaderService, TextureLoaderService, ThAdaptiveToneMappingPass, ThAfterimagePass, ThAmbientLight, ThAmbientLightProbe, ThArcballControls, ThArrayCamera, ThArrowHelper, ThAsyncLoaderBaseDirective, ThAsyncLoaderBasePipe, ThAsyncLoaderService, ThAudio, ThAudioListener, ThAxesHelper, ThBloomPass, ThBokehPass, ThBone, ThBox3Helper, ThBoxGeometry, ThBoxHelper, ThBoxLineGeometry, ThBufferGeometry, ThCallbackLoaderBaseDirective, ThCallbackLoaderBasePipe, ThCallbackLoaderService, ThCamera, ThCameraHelper, ThCanvas, ThCanvasTexture, ThCapsuleGeometry, ThCircleGeometry, ThClearMaskPass, ThClearPass, ThCompressedArrayTexture, ThCompressedTexture, ThConeGeometry, ThConvexGeometry, ThCubeCamera, ThCubeTexture, ThCubeTextureLoaderDirective, ThCubeTextureLoaderPipe, ThCubeTexturePass, ThCylinderGeometry, ThDDSLoaderDirective, ThDDSLoaderPipe, ThData3DTexture, ThDataArrayTexture, ThDataTexture, ThDecalGeometry, ThDepthTexture, ThDirectionalLight, ThDirectionalLightHelper, ThDodecahedronGeometry, ThDotScreenPass, ThDragControls, ThEXRLoaderDirective, ThEXRLoaderPipe, ThEdgesGeometry, ThEffectComposer, ThEffectComposerGen, ThEngineService, ThExtrudeGeometry, ThFBXLoaderDirective, ThFBXLoaderPipe, ThFilmPass, ThFirstPersonControls, ThFlyControls, ThFramebufferTexture, ThGLTFLoaderDirective, ThGLTFLoaderPipe, ThGlitchPass, ThGridHelper, ThGroup, ThHalftonePass, ThHemisphereLight, ThHemisphereLightHelper, ThHemisphereLightProbe, ThIcosahedronGeometry, ThInstancedBufferGeometry, ThInstancedMesh, ThKTX2LoaderDirective, ThKTX2LoaderPipe, ThKTXLoaderDirective, ThKTXLoaderPipe, ThLOD, ThLUTPass, ThLatheGeometry, ThLight, ThLightProbe, ThLightningStrike, ThLine, ThLineBasicMaterial, ThLineDashedMaterial, ThLineLoop, ThLineSegments, ThLogLuvLoaderDirective, ThLogLuvLoaderPipe, ThMapControls, ThMaskPass, ThMaterial, ThMesh, ThMeshBasicMaterial, ThMeshDepthMaterial, ThMeshDistanceMaterial, ThMeshLambertMaterial, ThMeshMatcapMaterial, ThMeshNormalMaterial, ThMeshPhongMaterial, ThMeshPhysicalMaterial, ThMeshStandardMaterial, ThMeshToonMaterial, ThObjLoaderDirective, ThObjLoaderPipe, ThObject3D, ThOctahedronGeometry, ThOrbitControls, ThOrthographicCamera, ThOutlinePass, ThPLYLoaderDirective, ThPLYLoaderPipe, ThPVRLoaderDirective, ThPVRLoaderPipe, ThParametricGeometry, ThPass, ThPerspectiveCamera, ThPlaneGeometry, ThPlaneHelper, ThPointLight, ThPointLightHelper, ThPointerLockControls, ThPoints, ThPointsMaterial, ThPolarGridHelper, ThPolyhedronGeometry, ThPositionalAudio, ThRGBELoaderDirective, ThRGBELoaderPipe, ThRGBMLoaderDirective, ThRGBMLoaderPipe, ThRawShaderMaterial, ThRectAreaLight, ThRenderDirective, ThRenderPass, ThRenderPassGen, ThRingGeometry, ThRoundedBoxGeometry, ThSAOPass, ThSMAAPass, ThSSAARenderPass, ThSSAOPass, ThSSRPass, ThSavePass, ThScene, ThShaderMaterial, ThShaderPass, ThShadowMaterial, ThShapeGeometry, ThSkeletonHelper, ThSkinnedMesh, ThSphereGeometry, ThSpotLight, ThSpotLightHelper, ThSprite, ThSpriteMaterial, ThStereoCamera, ThTAARenderPass, ThTGALoaderDirective, ThTGALoaderPipe, ThTeapotGeometry, ThTetrahedronGeometry, ThTextGeometry, ThTexture, ThTextureLoaderDirective, ThTextureLoaderPipe, ThTexturePass, ThTorusGeometry, ThTorusKnotGeometry, ThTrackballControls, ThTransformControls, ThTransformControlsGen, ThTubeGeometry, ThUnrealBloomPass, ThVideoTexture, ThView, ThWireframeGeometry, Vector2Pipe, Vector3Pipe, Vector4Pipe, createCameraProviderArray, createLazyObject3DProxy, createObj3DProviderArray, createThProviderArray, isLazyObject3dProxy };
//# sourceMappingURL=ngx-three.mjs.map
